'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

var ctGXeokitViewer = require('ct-g-xeokit-viewer');
var ctGXeokitSharedPluginLib = require('ct-g-xeokit-shared-plugin-lib');

function _arrayWithHoles(arr) {
  if (Array.isArray(arr)) return arr;
}

function _iterableToArrayLimit(arr, i) {
  var _i = arr == null ? null : typeof Symbol !== "undefined" && arr[Symbol.iterator] || arr["@@iterator"];

  if (_i == null) return;
  var _arr = [];
  var _n = true;
  var _d = false;

  var _s, _e;

  try {
    for (_i = _i.call(arr); !(_n = (_s = _i.next()).done); _n = true) {
      _arr.push(_s.value);

      if (i && _arr.length === i) break;
    }
  } catch (err) {
    _d = true;
    _e = err;
  } finally {
    try {
      if (!_n && _i["return"] != null) _i["return"]();
    } finally {
      if (_d) throw _e;
    }
  }

  return _arr;
}

function _arrayLikeToArray(arr, len) {
  if (len == null || len > arr.length) len = arr.length;

  for (var i = 0, arr2 = new Array(len); i < len; i++) {
    arr2[i] = arr[i];
  }

  return arr2;
}

function _unsupportedIterableToArray(o, minLen) {
  if (!o) return;
  if (typeof o === "string") return _arrayLikeToArray(o, minLen);
  var n = Object.prototype.toString.call(o).slice(8, -1);
  if (n === "Object" && o.constructor) n = o.constructor.name;
  if (n === "Map" || n === "Set") return Array.from(o);
  if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen);
}

function _nonIterableRest() {
  throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.");
}

function _slicedToArray(arr, i) {
  return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest();
}

function _classCallCheck(instance, Constructor) {
  if (!(instance instanceof Constructor)) {
    throw new TypeError("Cannot call a class as a function");
  }
}

function _defineProperties(target, props) {
  for (var i = 0; i < props.length; i++) {
    var descriptor = props[i];
    descriptor.enumerable = descriptor.enumerable || false;
    descriptor.configurable = true;
    if ("value" in descriptor) descriptor.writable = true;
    Object.defineProperty(target, descriptor.key, descriptor);
  }
}

function _createClass(Constructor, protoProps, staticProps) {
  if (protoProps) _defineProperties(Constructor.prototype, protoProps);
  if (staticProps) _defineProperties(Constructor, staticProps);
  return Constructor;
}

function _assertThisInitialized(self) {
  if (self === void 0) {
    throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
  }

  return self;
}

function _getPrototypeOf(o) {
  _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) {
    return o.__proto__ || Object.getPrototypeOf(o);
  };
  return _getPrototypeOf(o);
}

function _superPropBase(object, property) {
  while (!Object.prototype.hasOwnProperty.call(object, property)) {
    object = _getPrototypeOf(object);
    if (object === null) break;
  }

  return object;
}

function _get() {
  if (typeof Reflect !== "undefined" && Reflect.get) {
    _get = Reflect.get;
  } else {
    _get = function _get(target, property, receiver) {
      var base = _superPropBase(target, property);
      if (!base) return;
      var desc = Object.getOwnPropertyDescriptor(base, property);

      if (desc.get) {
        return desc.get.call(arguments.length < 3 ? target : receiver);
      }

      return desc.value;
    };
  }

  return _get.apply(this, arguments);
}

function _setPrototypeOf(o, p) {
  _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) {
    o.__proto__ = p;
    return o;
  };

  return _setPrototypeOf(o, p);
}

function _inherits(subClass, superClass) {
  if (typeof superClass !== "function" && superClass !== null) {
    throw new TypeError("Super expression must either be null or a function");
  }

  subClass.prototype = Object.create(superClass && superClass.prototype, {
    constructor: {
      value: subClass,
      writable: true,
      configurable: true
    }
  });
  if (superClass) _setPrototypeOf(subClass, superClass);
}

function _typeof(obj) {
  "@babel/helpers - typeof";

  if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") {
    _typeof = function _typeof(obj) {
      return typeof obj;
    };
  } else {
    _typeof = function _typeof(obj) {
      return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj;
    };
  }

  return _typeof(obj);
}

function _possibleConstructorReturn(self, call) {
  if (call && (_typeof(call) === "object" || typeof call === "function")) {
    return call;
  } else if (call !== void 0) {
    throw new TypeError("Derived constructors may only return object or undefined");
  }

  return _assertThisInitialized(self);
}

function _createSuper$2(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct$2(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _isNativeReflectConstruct$2() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }
var distVec3 = ctGXeokitViewer.math.vec3();

var lengthWire = function lengthWire(x1, y1, x2, y2) {
  var a = x1 - x2;
  var b = y1 - y2;
  return Math.sqrt(a * a + b * b);
};
/**
 * @desc Measures the distance between two 3D points.
 *
 * See {@link DistanceMeasurementsPlugin} for more info.
 */


var DistanceMeasurement = /*#__PURE__*/function (_Component) {
  _inherits(DistanceMeasurement, _Component);

  var _super = _createSuper$2(DistanceMeasurement);

  /**
   * @private
   */
  function DistanceMeasurement(plugin) {
    var _this;

    var cfg = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};

    _classCallCheck(this, DistanceMeasurement);

    _this = _super.call(this, plugin.viewer.scene, cfg);
    /**
     * The {@link DistanceMeasurementsPlugin} that owns this DistanceMeasurement.
     * @type {DistanceMeasurementsPlugin}
     */

    _this.plugin = plugin;
    _this._container = cfg.container;

    if (!_this._container) {
      throw "config missing: container";
    }

    _this._eventSubs = {};
    var scene = _this.plugin.viewer.scene;
    _this._originMarker = new ctGXeokitViewer.Marker(scene, cfg.origin);
    _this._targetMarker = new ctGXeokitViewer.Marker(scene, cfg.target);
    _this._originWorld = ctGXeokitViewer.math.vec3();
    _this._targetWorld = ctGXeokitViewer.math.vec3();
    _this._wp = new Float64Array(24);
    _this._vp = new Float64Array(24);
    _this._pp = new Float64Array(24);
    _this._cp = new Float64Array(8);
    _this._xAxisLabelCulled = false;
    _this._yAxisLabelCulled = false;
    _this._zAxisLabelCulled = false;
    _this._color = cfg.color || _this.plugin.defaultColor;
    _this._xAxisColor = cfg.xAxisColor;
    _this._yAxisColor = cfg.yAxisColor;
    _this._zAxisColor = cfg.zAxisColor;
    _this._xAxisLabelColor = cfg.xAxisLabelColor;
    _this._yAxisLabelColor = cfg.yAxisLabelColor;
    _this._zAxisLabelColor = cfg.zAxisLabelColor;
    _this._xAxisClassName = cfg.xAxisClassName;
    _this._yAxisClassName = cfg.yAxisClassName;
    _this._zAxisClassName = cfg.zAxisClassName;
    _this._xAxisLabelClassName = cfg.xAxisLabelClassName;
    _this._yAxisLabelClassName = cfg.yAxisLabelClassName;
    _this._zAxisLabelClassName = cfg.zAxisLabelClassName;
    var onMouseOver = cfg.onMouseOver ? function (event) {
      cfg.onMouseOver(event, _assertThisInitialized(_this));
    } : null;
    var onMouseLeave = cfg.onMouseLeave ? function (event) {
      cfg.onMouseLeave(event, _assertThisInitialized(_this));
    } : null;
    var onContextMenu = cfg.onContextMenu ? function (event) {
      cfg.onContextMenu(event, _assertThisInitialized(_this));
    } : null;
    _this._originDot = new ctGXeokitSharedPluginLib.Dot(_this._container, {
      fillColor: _this._color,
      zIndex: plugin.zIndex !== undefined ? plugin.zIndex + 2 : undefined,
      onMouseOver: onMouseOver,
      onMouseLeave: onMouseLeave,
      onContextMenu: onContextMenu
    });
    _this._targetDot = new ctGXeokitSharedPluginLib.Dot(_this._container, {
      fillColor: _this._color,
      zIndex: plugin.zIndex !== undefined ? plugin.zIndex + 2 : undefined,
      onMouseOver: onMouseOver,
      onMouseLeave: onMouseLeave,
      onContextMenu: onContextMenu
    });
    _this._lengthWire = new ctGXeokitSharedPluginLib.Wire(_this._container, {
      color: _this._color,
      thickness: 1,
      thicknessClickable: 6,
      zIndex: plugin.zIndex !== undefined ? plugin.zIndex + 1 : undefined,
      onMouseOver: onMouseOver,
      onMouseLeave: onMouseLeave,
      onContextMenu: onContextMenu
    });
    _this._xAxisWire = new ctGXeokitSharedPluginLib.Wire(_this._container, {
      color: _this._xAxisColor || "red",
      className: _this._xAxisClassName,
      thickness: 1,
      thicknessClickable: 6,
      zIndex: plugin.zIndex !== undefined ? plugin.zIndex + 1 : undefined,
      onMouseOver: onMouseOver,
      onMouseLeave: onMouseLeave,
      onContextMenu: onContextMenu
    });
    _this._yAxisWire = new ctGXeokitSharedPluginLib.Wire(_this._container, {
      color: _this._yAxisColor || "green",
      className: _this._yAxisClassName,
      thickness: 1,
      thicknessClickable: 6,
      zIndex: plugin.zIndex !== undefined ? plugin.zIndex + 1 : undefined,
      onMouseOver: onMouseOver,
      onMouseLeave: onMouseLeave,
      onContextMenu: onContextMenu
    });
    _this._zAxisWire = new ctGXeokitSharedPluginLib.Wire(_this._container, {
      color: _this._zAxisColor || "blue",
      className: _this._zAxisClassName,
      thickness: 1,
      thicknessClickable: 6,
      zIndex: plugin.zIndex !== undefined ? plugin.zIndex + 1 : undefined,
      onMouseOver: onMouseOver,
      onMouseLeave: onMouseLeave,
      onContextMenu: onContextMenu
    });
    _this._lengthLabel = new ctGXeokitSharedPluginLib.Label(_this._container, {
      fillColor: _this._color,
      prefix: "",
      text: "",
      zIndex: plugin.zIndex !== undefined ? plugin.zIndex + 4 : undefined,
      onMouseOver: onMouseOver,
      onMouseLeave: onMouseLeave,
      onContextMenu: onContextMenu
    });
    _this._xAxisLabel = new ctGXeokitSharedPluginLib.Label(_this._container, {
      fillColor: _this._xAxisLabelColor || "red",
      className: _this._xAxisLabelClassName,
      prefix: "X",
      text: "",
      zIndex: plugin.zIndex !== undefined ? plugin.zIndex + 3 : undefined,
      onMouseOver: onMouseOver,
      onMouseLeave: onMouseLeave,
      onContextMenu: onContextMenu
    });
    _this._yAxisLabel = new ctGXeokitSharedPluginLib.Label(_this._container, {
      fillColor: _this._yAxisLabelColor || "green",
      className: _this._yAxisLabelClassName,
      prefix: "Y",
      text: "",
      zIndex: plugin.zIndex !== undefined ? plugin.zIndex + 3 : undefined,
      onMouseOver: onMouseOver,
      onMouseLeave: onMouseLeave,
      onContextMenu: onContextMenu
    });
    _this._zAxisLabel = new ctGXeokitSharedPluginLib.Label(_this._container, {
      fillColor: _this._zAxisLabelColor || "blue",
      className: _this._zAxisLabelClassName,
      prefix: "Z",
      text: "",
      zIndex: plugin.zIndex !== undefined ? plugin.zIndex + 3 : undefined,
      onMouseOver: onMouseOver,
      onMouseLeave: onMouseLeave,
      onContextMenu: onContextMenu
    });
    _this._wpDirty = false;
    _this._vpDirty = false;
    _this._cpDirty = false;
    _this._visible = false;
    _this._originVisible = false;
    _this._targetVisible = false;
    _this._wireVisible = false;
    _this._axisVisible = false;
    _this._xAxisVisible = false;
    _this._yAxisVisible = false;
    _this._zAxisVisible = false;
    _this._axisEnabled = true;
    _this._labelsVisible = false;
    _this._clickable = true;

    _this._originMarker.on("worldPos", function (value) {
      _this._originWorld.set(value || [0, 0, 0]);

      _this._wpDirty = true;

      _this._needUpdate(0); // No lag

    });

    _this._targetMarker.on("worldPos", function (value) {
      _this._targetWorld.set(value || [0, 0, 0]);

      _this._wpDirty = true;

      _this._needUpdate(0); // No lag

    });

    _this._onViewMatrix = scene.camera.on("viewMatrix", function () {
      _this._vpDirty = true;

      _this._needUpdate(0); // No lag

    });
    _this._onProjMatrix = scene.camera.on("projMatrix", function () {
      _this._cpDirty = true;

      _this._needUpdate();
    });
    _this._onCanvasBoundary = scene.canvas.on("boundary", function () {
      _this._cpDirty = true;

      _this._needUpdate(0); // No lag

    });
    _this._onMetricsUnits = scene.metrics.on("units", function () {
      _this._cpDirty = true;

      _this._needUpdate();
    });
    _this._onMetricsScale = scene.metrics.on("scale", function () {
      _this._cpDirty = true;

      _this._needUpdate();
    });
    _this._onMetricsOrigin = scene.metrics.on("origin", function () {
      _this._cpDirty = true;

      _this._needUpdate();
    });
    _this.approximate = cfg.approximate;
    _this.visible = cfg.visible;
    _this.originVisible = cfg.originVisible;
    _this.targetVisible = cfg.targetVisible;
    _this.wireVisible = cfg.wireVisible;
    _this.axisVisible = cfg.axisVisible;
    _this.xAxisVisible = cfg.xAxisVisible;
    _this.yAxisVisible = cfg.yAxisVisible;
    _this.zAxisVisible = cfg.zAxisVisible;
    _this.labelsVisible = cfg.labelsVisible;
    return _this;
  }

  _createClass(DistanceMeasurement, [{
    key: "_update",
    value: function _update() {
      if (!this._visible) {
        return;
      }

      var scene = this.plugin.viewer.scene;

      if (this._wpDirty) {
        this._wp[0] = this._originWorld[0];
        this._wp[1] = this._originWorld[1];
        this._wp[2] = this._originWorld[2];
        this._wp[3] = 1.0;
        this._wp[4] = this._targetWorld[0];
        this._wp[5] = this._originWorld[1];
        this._wp[6] = this._originWorld[2];
        this._wp[7] = 1.0;
        this._wp[8] = this._targetWorld[0];
        this._wp[9] = this._targetWorld[1];
        this._wp[10] = this._originWorld[2];
        this._wp[11] = 1.0;
        this._wp[12] = this._targetWorld[0];
        this._wp[13] = this._targetWorld[1];
        this._wp[14] = this._targetWorld[2];
        this._wp[15] = 1.0;
        this._wpDirty = false;
        this._vpDirty = true;
      }

      if (this._vpDirty) {
        ctGXeokitViewer.math.transformPositions4(scene.camera.viewMatrix, this._wp, this._vp);
        this._vp[3] = 1.0;
        this._vp[7] = 1.0;
        this._vp[11] = 1.0;
        this._vp[15] = 1.0;
        this._vpDirty = false;
        this._cpDirty = true;
      }

      var near = -0.3;
      var vpz1 = this._originMarker.viewPos[2];
      var vpz2 = this._targetMarker.viewPos[2];

      if (vpz1 > near || vpz2 > near) {
        this._xAxisLabel.setVisible(false);

        this._yAxisLabel.setVisible(false);

        this._zAxisLabel.setVisible(false);

        this._lengthLabel.setVisible(false);

        this._xAxisWire.setVisible(false);

        this._yAxisWire.setVisible(false);

        this._zAxisWire.setVisible(false);

        this._lengthWire.setVisible(false);

        this._originDot.setVisible(false);

        this._targetDot.setVisible(false);

        return;
      }

      if (this._cpDirty) {
        ctGXeokitViewer.math.transformPositions4(scene.camera.project.matrix, this._vp, this._pp);
        var pp = this._pp;
        var cp = this._cp;
        var canvas = scene.canvas.canvas;
        var offsets = canvas.getBoundingClientRect();

        var containerOffsets = this._container.getBoundingClientRect();

        var top = offsets.top - containerOffsets.top;
        var left = offsets.left - containerOffsets.left;
        var aabb = scene.canvas.boundary;
        var canvasWidth = aabb[2];
        var canvasHeight = aabb[3];
        var j = 0;
        var metrics = this.plugin.viewer.scene.metrics;
        var scale = metrics.scale;
        var units = metrics.units;
        var unitInfo = metrics.unitsInfo[units];
        var unitAbbrev = this.plugin.viewer.localeService.translate(unitInfo.abbrev) || unitInfo.abbrev;

        for (var i = 0, len = pp.length; i < len; i += 4) {
          cp[j] = left + Math.floor((1 + pp[i + 0] / pp[i + 3]) * canvasWidth / 2);
          cp[j + 1] = top + Math.floor((1 - pp[i + 1] / pp[i + 3]) * canvasHeight / 2);
          j += 2;
        }

        this._originDot.setPos(cp[0], cp[1]);

        this._targetDot.setPos(cp[6], cp[7]);

        this._lengthWire.setStartAndEnd(cp[0], cp[1], cp[6], cp[7]);

        this._xAxisWire.setStartAndEnd(cp[0], cp[1], cp[2], cp[3]);

        this._yAxisWire.setStartAndEnd(cp[2], cp[3], cp[4], cp[5]);

        this._zAxisWire.setStartAndEnd(cp[4], cp[5], cp[6], cp[7]);

        if (!this.labelsVisible) {
          this._lengthLabel.setCulled(true);

          this._xAxisLabel.setCulled(true);

          this._yAxisLabel.setCulled(true);

          this._zAxisLabel.setCulled(true);
        } else {
          this._lengthLabel.setPosOnWire(cp[0], cp[1], cp[6], cp[7]);

          this._xAxisLabel.setPosOnWire(cp[0], cp[1], cp[2], cp[3]);

          this._yAxisLabel.setPosOnWire(cp[2], cp[3], cp[4], cp[5]);

          this._zAxisLabel.setPosOnWire(cp[4], cp[5], cp[6], cp[7]);

          this._length = Math.abs(ctGXeokitViewer.math.lenVec3(ctGXeokitViewer.math.subVec3(this._targetWorld, this._originWorld, distVec3)));

          this._lengthLabel.setText(" " + (this._length * scale).toFixed(2) + unitAbbrev);

          var xAxisCanvasLength = Math.abs(lengthWire(cp[0], cp[1], cp[2], cp[3]));
          var yAxisCanvasLength = Math.abs(lengthWire(cp[2], cp[3], cp[4], cp[5]));
          var zAxisCanvasLength = Math.abs(lengthWire(cp[4], cp[5], cp[6], cp[7]));
          var labelMinAxisLength = this.plugin.labelMinAxisLength;
          this._xAxisLabelCulled = xAxisCanvasLength < labelMinAxisLength;
          this._yAxisLabelCulled = yAxisCanvasLength < labelMinAxisLength;
          this._zAxisLabelCulled = zAxisCanvasLength < labelMinAxisLength;

          if (!this._xAxisLabelCulled) {
            this._xAxisLabel.setText(" " + Math.abs((this._targetWorld[0] - this._originWorld[0]) * scale).toFixed(2) + unitAbbrev);

            this._xAxisLabel.setCulled(!this.axisVisible);
          } else {
            this._xAxisLabel.setCulled(true);
          }

          if (!this._yAxisLabelCulled) {
            this._yAxisLabel.setText(" " + Math.abs((this._targetWorld[1] - this._originWorld[1]) * scale).toFixed(2) + unitAbbrev);

            this._yAxisLabel.setCulled(!this.axisVisible);
          } else {
            this._yAxisLabel.setCulled(true);
          }

          if (!this._zAxisLabelCulled) {
            this._zAxisLabel.setText(" " + Math.abs((this._targetWorld[2] - this._originWorld[2]) * scale).toFixed(2) + unitAbbrev);

            this._zAxisLabel.setCulled(!this.axisVisible);
          } else {
            this._zAxisLabel.setCulled(true);
          }
        }

        this._originDot.setVisible(this._visible && this._originVisible);

        this._targetDot.setVisible(this._visible && this._targetVisible);

        this._xAxisWire.setVisible(this.axisVisible && this.xAxisVisible);

        this._yAxisWire.setVisible(this.axisVisible && this.yAxisVisible);

        this._zAxisWire.setVisible(this.axisVisible && this.zAxisVisible);

        this._xAxisLabel.setVisible(this.labelsVisible && this.axisVisible && this.xAxisVisible);

        this._yAxisLabel.setVisible(this.labelsVisible && this.axisVisible && this.yAxisVisible);

        this._zAxisLabel.setVisible(this.labelsVisible && this.axisVisible && this.zAxisVisible);

        this._lengthWire.setVisible(this.wireVisible);

        this._lengthLabel.setVisible(this.labelsVisible);

        this._lengthLabel.setCulled(!this.wireVisible);

        this._cpDirty = false;
      }
    }
    /**
     * Sets whether this DistanceMeasurement indicates that its measurement is approximate.
     *
     * This is ````true```` by default.
     *
     * @type {Boolean}
     */

  }, {
    key: "approximate",
    get:
    /**
     * Gets whether this DistanceMeasurement indicates that its measurement is approximate.
     *
     * This is ````true```` by default.
     *
     * @type {Boolean}
     */
    function get() {
      return this._approximate;
    }
    /**
     * Gets the origin {@link Marker}.
     *
     * @type {Marker}
     */
    ,
    set: function set(approximate) {
      approximate = approximate !== false;

      if (this._approximate === approximate) {
        return;
      }

      this._approximate = approximate;
      this._cpDirty = true;

      this._needUpdate(0);
    }
  }, {
    key: "origin",
    get: function get() {
      return this._originMarker;
    }
    /**
     * Gets the target {@link Marker}.
     *
     * @type {Marker}
     */

  }, {
    key: "target",
    get: function get() {
      return this._targetMarker;
    }
    /**
     * Gets the World-space direct point-to-point distance between {@link DistanceMeasurement#origin} and {@link DistanceMeasurement#target}.
     *
     * @type {Number}
     */

  }, {
    key: "length",
    get: function get() {
      this._update();

      var scale = this.plugin.viewer.scene.metrics.scale;
      return this._length * scale;
    }
  }, {
    key: "color",
    get: function get() {
      return this._color;
    },
    set: function set(value) {
      this._color = value;

      this._originDot.setFillColor(value);

      this._targetDot.setFillColor(value);

      this._lengthWire.setColor(value);

      this._lengthLabel.setFillColor(value);
    }
    /**
     * Sets whether this DistanceMeasurement is visible or not.
     *
     * @type {Boolean}
     */

  }, {
    key: "visible",
    get:
    /**
     * Gets whether this DistanceMeasurement is visible or not.
     *
     * @type {Boolean}
     */
    function get() {
      return this._visible;
    }
    /**
     * Sets if the origin {@link Marker} is visible.
     *
     * @type {Boolean}
     */
    ,
    set: function set(value) {
      value = value !== undefined ? Boolean(value) : this.plugin.defaultVisible;
      this._visible = value;

      this._originDot.setVisible(this._visible && this._originVisible);

      this._targetDot.setVisible(this._visible && this._targetVisible);

      this._lengthWire.setVisible(this._visible && this._wireVisible);

      this._lengthLabel.setVisible(this._visible && this._wireVisible);

      var xAxisVisible = this._visible && this._axisVisible && this._xAxisVisible;
      var yAxisVisible = this._visible && this._axisVisible && this._yAxisVisible;
      var zAxisVisible = this._visible && this._axisVisible && this._zAxisVisible;

      this._xAxisWire.setVisible(xAxisVisible);

      this._yAxisWire.setVisible(yAxisVisible);

      this._zAxisWire.setVisible(zAxisVisible);

      this._xAxisLabel.setVisible(xAxisVisible && !this._xAxisLabelCulled);

      this._yAxisLabel.setVisible(yAxisVisible && !this._yAxisLabelCulled);

      this._zAxisLabel.setVisible(zAxisVisible && !this._zAxisLabelCulled);

      this._cpDirty = true;

      this._needUpdate();
    }
  }, {
    key: "originVisible",
    get:
    /**
     * Gets if the origin {@link Marker} is visible.
     *
     * @type {Boolean}
     */
    function get() {
      return this._originVisible;
    }
    /**
     * Sets if the target {@link Marker} is visible.
     *
     * @type {Boolean}
     */
    ,
    set: function set(value) {
      value = value !== undefined ? Boolean(value) : this.plugin.defaultOriginVisible;
      this._originVisible = value;

      this._originDot.setVisible(this._visible && this._originVisible);
    }
  }, {
    key: "targetVisible",
    get:
    /**
     * Gets if the target {@link Marker} is visible.
     *
     * @type {Boolean}
     */
    function get() {
      return this._targetVisible;
    }
    /**
     * Sets if the axis-aligned wires between {@link DistanceMeasurement#origin} and {@link DistanceMeasurement#target} are enabled.
     *
     * Wires are only shown if enabled and visible.
     *
     * @type {Boolean}
     */
    ,
    set: function set(value) {
      value = value !== undefined ? Boolean(value) : this.plugin.defaultTargetVisible;
      this._targetVisible = value;

      this._targetDot.setVisible(this._visible && this._targetVisible);
    }
  }, {
    key: "axisEnabled",
    get:
    /**
     * Gets if the axis-aligned wires between {@link DistanceMeasurement#origin} and {@link DistanceMeasurement#target} are enabled.
     *
     * Wires are only shown if enabled and visible.
     *
     * @type {Boolean}
     */
    function get() {
      return this._axisEnabled;
    }
    /**
     * Sets if the axis-aligned wires between {@link DistanceMeasurement#origin} and {@link DistanceMeasurement#target} are visible.
     *
     * Wires are only shown if enabled and visible.
     *
     * @type {Boolean}
     */
    ,
    set: function set(value) {
      value = value !== undefined ? Boolean(value) : this.plugin.defaultAxisVisible;
      this._axisEnabled = value;
      var axisVisible = this._visible && this._axisVisible && this._axisEnabled;

      this._xAxisWire.setVisible(axisVisible && this._xAxisVisible);

      this._yAxisWire.setVisible(axisVisible && this._yAxisVisible);

      this._zAxisWire.setVisible(axisVisible && this._zAxisVisible);

      this._xAxisLabel.setVisible(axisVisible && !this._xAxisLabelCulled && this._xAxisVisible);

      this._yAxisLabel.setVisible(axisVisible && !this._yAxisLabelCulled && this._xAxisVisible);

      this._zAxisLabel.setVisible(axisVisible && !this._zAxisLabelCulled && this._xAxisVisible);

      this._cpDirty = true;

      this._needUpdate();
    }
  }, {
    key: "axisVisible",
    get:
    /**
     * Gets if the axis-aligned wires between {@link DistanceMeasurement#origin} and {@link DistanceMeasurement#target} are visible.
     *
     * Wires are only shown if enabled and visible.
     *
     * @type {Boolean}
     */
    function get() {
      return this._axisVisible;
    }
    /**
     * Sets if the X-axis-aligned wire between {@link DistanceMeasurement#origin} and {@link DistanceMeasurement#target} is visible.
     *
     * Wires are only shown if enabled and visible.
     *
     * @type {Boolean}
     */
    ,
    set: function set(value) {
      value = value !== undefined ? Boolean(value) : this.plugin.defaultAxisVisible;
      this._axisVisible = value;
      var axisVisible = this._visible && this._axisVisible && this._axisEnabled;

      this._xAxisWire.setVisible(axisVisible && this._xAxisVisible);

      this._yAxisWire.setVisible(axisVisible && this._yAxisVisible);

      this._zAxisWire.setVisible(axisVisible && this._zAxisVisible);

      this._xAxisLabel.setVisible(axisVisible && !this._xAxisLabelCulled && this._xAxisVisible);

      this._yAxisLabel.setVisible(axisVisible && !this._yAxisLabelCulled && this._yAxisVisible);

      this._zAxisLabel.setVisible(axisVisible && !this._zAxisLabelCulled && this._zAxisVisible);

      this._cpDirty = true;

      this._needUpdate();
    }
  }, {
    key: "xAxisVisible",
    get:
    /**
     * Gets if the X-axis-aligned wires between {@link DistanceMeasurement#origin} and {@link DistanceMeasurement#target} are visible.
     *
     * Wires are only shown if enabled and visible.
     *
     * @type {Boolean}
     */
    function get() {
      return this._xAxisVisible;
    }
    /**
     * Sets if the Y-axis-aligned wire between {@link DistanceMeasurement#origin} and {@link DistanceMeasurement#target} is visible.
     *
     * Wires are only shown if enabled and visible.
     *
     * @type {Boolean}
     */
    ,
    set: function set(value) {
      value = value !== undefined ? Boolean(value) : this.plugin.defaultAxisVisible;
      this._xAxisVisible = value;
      var axisVisible = this._visible && this._axisVisible && this._xAxisVisible && this._axisEnabled;

      this._xAxisWire.setVisible(axisVisible);

      this._xAxisLabel.setVisible(axisVisible && !this._xAxisLabelCulled);

      this._cpDirty = true;

      this._needUpdate();
    }
  }, {
    key: "yAxisVisible",
    get:
    /**
     * Gets if the Y-axis-aligned wires between {@link DistanceMeasurement#origin} and {@link DistanceMeasurement#target} are visible.
     *
     * Wires are only shown if enabled and visible.
     *
     * @type {Boolean}
     */
    function get() {
      return this._yAxisVisible;
    }
    /**
     * Sets if the Z-axis-aligned wire between {@link DistanceMeasurement#origin} and {@link DistanceMeasurement#target} is visible.
     *
     * Wires are only shown if enabled and visible.
     *
     * @type {Boolean}
     */
    ,
    set: function set(value) {
      value = value !== undefined ? Boolean(value) : this.plugin.defaultAxisVisible;
      this._yAxisVisible = value;
      var axisVisible = this._visible && this._axisVisible && this._yAxisVisible && this._axisEnabled;

      this._yAxisWire.setVisible(axisVisible);

      this._yAxisLabel.setVisible(axisVisible && !this._yAxisLabelCulled);

      this._cpDirty = true;

      this._needUpdate();
    }
  }, {
    key: "zAxisVisible",
    get:
    /**
     * Gets if the Z-axis-aligned wires between {@link DistanceMeasurement#origin} and {@link DistanceMeasurement#target} are visible.
     *
     * Wires are only shown if enabled and visible.
     *
     * @type {Boolean}
     */
    function get() {
      return this._zAxisVisible;
    }
    /**
     * Sets if the direct point-to-point wire between {@link DistanceMeasurement#origin} and {@link DistanceMeasurement#target} is visible.
     *
     * @type {Boolean}
     */
    ,
    set: function set(value) {
      value = value !== undefined ? Boolean(value) : this.plugin.defaultAxisVisible;
      this._zAxisVisible = value;
      var axisVisible = this._visible && this._axisVisible && this._zAxisVisible && this._axisEnabled;

      this._zAxisWire.setVisible(axisVisible);

      this._zAxisLabel.setVisible(axisVisible && !this._zAxisLabelCulled);

      this._cpDirty = true;

      this._needUpdate();
    }
  }, {
    key: "wireVisible",
    get:
    /**
     * Gets if the direct point-to-point wire between {@link DistanceMeasurement#origin} and {@link DistanceMeasurement#target} is visible.
     *
     * @type {Boolean}
     */
    function get() {
      return this._wireVisible;
    }
    /**
     * Sets if the labels are visible.
     *
     * @type {Boolean}
     */
    ,
    set: function set(value) {
      value = value !== undefined ? Boolean(value) : this.plugin.defaultWireVisible;
      this._wireVisible = value;
      var wireVisible = this._visible && this._wireVisible;

      this._lengthLabel.setVisible(wireVisible);

      this._lengthWire.setVisible(wireVisible);
    }
  }, {
    key: "labelsVisible",
    get:
    /**
     * Gets if the labels are visible.
     *
     * @type {Boolean}
     */
    function get() {
      return this._labelsVisible;
    }
    /**
     * Sets if this DistanceMeasurement appears highlighted.
     * @param highlighted
     */
    ,
    set: function set(value) {
      value = value !== undefined ? Boolean(value) : this.plugin.defaultLabelsVisible;
      this._labelsVisible = value;
      var labelsVisible = this._visible && this._labelsVisible;

      this._xAxisLabel.setVisible(labelsVisible && !this._xAxisLabelCulled && this._clickable && this._axisEnabled);

      this._yAxisLabel.setVisible(labelsVisible && !this._yAxisLabelCulled && this._clickable && this._axisEnabled);

      this._zAxisLabel.setVisible(labelsVisible && !this._zAxisLabelCulled && this._clickable && this._axisEnabled);

      this._lengthLabel.setVisible(labelsVisible);

      this._cpDirty = true;

      this._needUpdate();
    }
  }, {
    key: "setHighlighted",
    value: function setHighlighted(highlighted) {
      this._originDot.setHighlighted(highlighted);

      this._targetDot.setHighlighted(highlighted);

      this._xAxisWire.setHighlighted(highlighted);

      this._yAxisWire.setHighlighted(highlighted);

      this._zAxisWire.setHighlighted(highlighted);

      this._xAxisLabel.setHighlighted(highlighted);

      this._yAxisLabel.setHighlighted(highlighted);

      this._zAxisLabel.setHighlighted(highlighted);

      this._lengthWire.setHighlighted(highlighted);

      this._lengthLabel.setHighlighted(highlighted);
    }
    /**
     * Sets if the wires, dots ad labels will fire "mouseOver" "mouseLeave" and "contextMenu" events.
     *
     * @type {Boolean}
     */

  }, {
    key: "clickable",
    get:
    /**
     * Gets if the wires, dots ad labels will fire "mouseOver" "mouseLeave" and "contextMenu" events.
     *
     * @type {Boolean}
     */
    function get() {
      return this._clickable;
    }
    /**
     * @private
     */
    ,
    set: function set(value) {
      value = !!value;
      this._clickable = value;

      this._originDot.setClickable(this._clickable);

      this._targetDot.setClickable(this._clickable);

      this._xAxisWire.setClickable(this._clickable);

      this._yAxisWire.setClickable(this._clickable);

      this._zAxisWire.setClickable(this._clickable);

      this._lengthWire.setClickable(this._clickable);

      this._xAxisLabel.setClickable(this._clickable);

      this._yAxisLabel.setClickable(this._clickable);

      this._zAxisLabel.setClickable(this._clickable);

      this._lengthLabel.setClickable(this._clickable);
    }
  }, {
    key: "destroy",
    value: function destroy() {
      var scene = this.plugin.viewer.scene;
      var metrics = scene.metrics;

      if (this._onViewMatrix) {
        scene.camera.off(this._onViewMatrix);
      }

      if (this._onProjMatrix) {
        scene.camera.off(this._onProjMatrix);
      }

      if (this._onCanvasBoundary) {
        scene.canvas.off(this._onCanvasBoundary);
      }

      if (this._onMetricsUnits) {
        metrics.off(this._onMetricsUnits);
      }

      if (this._onMetricsScale) {
        metrics.off(this._onMetricsScale);
      }

      if (this._onMetricsOrigin) {
        metrics.off(this._onMetricsOrigin);
      }

      this._originDot.destroy();

      this._targetDot.destroy();

      this._xAxisWire.destroy();

      this._yAxisWire.destroy();

      this._zAxisWire.destroy();

      this._lengthLabel.destroy();

      this._xAxisLabel.destroy();

      this._yAxisLabel.destroy();

      this._zAxisLabel.destroy();

      this._lengthWire.destroy();

      _get(_getPrototypeOf(DistanceMeasurement.prototype), "destroy", this).call(this);
    }
  }]);

  return DistanceMeasurement;
}(ctGXeokitViewer.Component);

// Fast queue that avoids using potentially inefficient array .shift() calls
// Based on https://github.com/creationix/fastqueue

/** @private */
var Queue = /*#__PURE__*/function () {
  function Queue() {
    _classCallCheck(this, Queue);

    this._head = [];
    this._headLength = 0;
    this._tail = [];
    this._index = 0;
    this._length = 0;
  }

  _createClass(Queue, [{
    key: "length",
    get: function get() {
      return this._length;
    }
  }, {
    key: "shift",
    value: function shift() {
      if (this._index >= this._headLength) {
        var t = this._head;
        t.length = 0;
        this._head = this._tail;
        this._tail = t;
        this._index = 0;
        this._headLength = this._head.length;

        if (!this._headLength) {
          return;
        }
      }

      var value = this._head[this._index];

      if (this._index < 0) {
        delete this._head[this._index++];
      } else {
        this._head[this._index++] = undefined;
      }

      this._length--;
      return value;
    }
  }, {
    key: "push",
    value: function push(item) {
      this._length++;

      this._tail.push(item);

      return this;
    }
  }, {
    key: "unshift",
    value: function unshift(item) {
      this._head[--this._index] = item;
      this._length++;
      return this;
    }
  }]);

  return Queue;
}();

/** @private */
var Map = /*#__PURE__*/function () {
  function Map(items, baseId) {
    _classCallCheck(this, Map);

    this.items = items || [];
    this._lastUniqueId = (baseId || 0) + 1;
  }
  /**
   * Usage:
   *
   * id = myMap.addItem("foo") // ID internally generated
   * id = myMap.addItem("foo", "bar") // ID is "foo"
   */


  _createClass(Map, [{
    key: "addItem",
    value: function addItem() {
      var item;

      if (arguments.length === 2) {
        var id = arguments[0];
        item = arguments[1];

        if (this.items[id]) {
          // Won't happen if given ID is string
          throw "ID clash: '" + id + "'";
        }

        this.items[id] = item;
        return id;
      } else {
        item = arguments[0] || {};

        while (true) {
          var findId = this._lastUniqueId++;

          if (!this.items[findId]) {
            this.items[findId] = item;
            return findId;
          }
        }
      }
    }
  }, {
    key: "removeItem",
    value: function removeItem(id) {
      var item = this.items[id];
      delete this.items[id];
      return item;
    }
  }]);

  return Map;
}();

/**
 * @private
 */
function xmlToJson(node, attributeRenamer) {
  if (node.nodeType === node.TEXT_NODE) {
    var v = node.nodeValue;

    if (v.match(/^\s+$/) === null) {
      return v;
    }
  } else if (node.nodeType === node.ELEMENT_NODE || node.nodeType === node.DOCUMENT_NODE) {
    var json = {
      type: node.nodeName,
      children: []
    };

    if (node.nodeType === node.ELEMENT_NODE) {
      for (var j = 0; j < node.attributes.length; j++) {
        var attribute = node.attributes[j];
        var nm = attributeRenamer[attribute.nodeName] || attribute.nodeName;
        json[nm] = attribute.nodeValue;
      }
    }

    for (var i = 0; i < node.childNodes.length; i++) {
      var item = node.childNodes[i];
      var j = xmlToJson(item, attributeRenamer);
      if (j) json.children.push(j);
    }

    return json;
  }
}
/**
 * @private
 */


function clone(ob) {
  return JSON.parse(JSON.stringify(ob));
}
/**
 * @private
 */


var guidChars = [["0", 10], ["A", 26], ["a", 26], ["_", 1], ["$", 1]].map(function (a) {
  var li = [];
  var st = a[0].charCodeAt(0);
  var en = st + a[1];

  for (var i = st; i < en; ++i) {
    li.push(i);
  }

  return String.fromCharCode.apply(null, li);
}).join("");
/**
 * @private
 */

function b64(v, len) {
  var r = !len || len === 4 ? [0, 6, 12, 18] : [0, 6];
  return r.map(function (i) {
    return guidChars.substr(parseInt(v / (1 << i)) % 64, 1);
  }).reverse().join("");
}
/**
 * @private
 */


function compressGuid(g) {
  var bs = [0, 2, 4, 6, 8, 10, 12, 14, 16, 18, 20, 22, 24, 26, 28, 30].map(function (i) {
    return parseInt(g.substr(i, 2), 16);
  });
  return b64(bs[0], 2) + [1, 4, 7, 10, 13].map(function (i) {
    return b64((bs[i] << 16) + (bs[i + 1] << 8) + bs[i + 2]);
  }).join("");
}
/**
 * @private
 */


function findNodeOfType(m, t) {
  var li = [];

  var _ = function _(n) {
    if (n.type === t) li.push(n);
    (n.children || []).forEach(function (c) {
      _(c);
    });
  };

  _(m);

  return li;
}
/**
 * @private
 */


function timeout(dt) {
  return new Promise(function (resolve, reject) {
    setTimeout(resolve, dt);
  });
}
/**
 * @private
 */


function httpRequest(args) {
  return new Promise(function (resolve, reject) {
    var xhr = new XMLHttpRequest();
    xhr.open(args.method || "GET", args.url, true);

    xhr.onload = function (e) {
      console.log(args.url, xhr.readyState, xhr.status);

      if (xhr.readyState === 4) {
        if (xhr.status === 200) {
          resolve(xhr.responseXML);
        } else {
          reject(xhr.statusText);
        }
      }
    };

    xhr.send(null);
  });
}
/**
 * @private
 */


var queryString = function () {
  // This function is anonymous, is executed immediately and
  // the return value is assigned to QueryString!
  var query_string = {};
  var query = window.location.search.substring(1);
  var vars = query.split("&");

  for (var i = 0; i < vars.length; i++) {
    var pair = vars[i].split("="); // If first entry with this name

    if (typeof query_string[pair[0]] === "undefined") {
      query_string[pair[0]] = decodeURIComponent(pair[1]); // If second entry with this name
    } else if (typeof query_string[pair[0]] === "string") {
      var arr = [query_string[pair[0]], decodeURIComponent(pair[1])];
      query_string[pair[0]] = arr; // If third or later entry with this name
    } else {
      query_string[pair[0]].push(decodeURIComponent(pair[1]));
    }
  }

  return query_string;
}();
/**
 * @private
 */


function loadJSON(url, ok, err) {
  // Avoid checking ok and err on each use.
  var defaultCallback = function defaultCallback(_value) {
    return undefined;
  };

  ok = ok || defaultCallback;
  err = err || defaultCallback;
  var request = new XMLHttpRequest();
  request.overrideMimeType("application/json");
  request.open('GET', url, true);
  request.addEventListener('load', function (event) {
    var response = event.target.response;

    if (this.status === 200) {
      var json;

      try {
        json = JSON.parse(response);
      } catch (e) {
        err("utils.loadJSON(): Failed to parse JSON response - ".concat(e));
      }

      ok(json);
    } else if (this.status === 0) {
      // Some browsers return HTTP Status 0 when using non-http protocol
      // e.g. 'file://' or 'data://'. Handle as success.
      console.warn('loadFile: HTTP Status 0 received.');

      try {
        ok(JSON.parse(response));
      } catch (e) {
        err("utils.loadJSON(): Failed to parse JSON response - ".concat(e));
      }
    } else {
      err(event);
    }
  }, false);
  request.addEventListener('error', function (event) {
    err(event);
  }, false);
  request.send(null);
}
/**
 * @private
 */


function loadArraybuffer(url, ok, err) {
  // Check for data: URI
  var defaultCallback = function defaultCallback(_value) {
    return undefined;
  };

  ok = ok || defaultCallback;
  err = err || defaultCallback;
  var dataUriRegex = /^data:(.*?)(;base64)?,(.*)$/;
  var dataUriRegexResult = url.match(dataUriRegex);

  if (dataUriRegexResult) {
    // Safari can't handle data URIs through XMLHttpRequest
    var isBase64 = !!dataUriRegexResult[2];
    var data = dataUriRegexResult[3];
    data = window.decodeURIComponent(data);

    if (isBase64) {
      data = window.atob(data);
    }

    try {
      var buffer = new ArrayBuffer(data.length);
      var view = new Uint8Array(buffer);

      for (var i = 0; i < data.length; i++) {
        view[i] = data.charCodeAt(i);
      }

      window.setTimeout(function () {
        ok(buffer);
      }, 0);
    } catch (error) {
      window.setTimeout(function () {
        err(error);
      }, 0);
    }
  } else {
    var request = new XMLHttpRequest();
    request.open('GET', url, true);
    request.responseType = 'arraybuffer';

    request.onreadystatechange = function () {
      if (request.readyState === 4) {
        if (request.status === 200) {
          ok(request.response);
        } else {
          err('loadArrayBuffer error : ' + request.response);
        }
      }
    };

    request.send(null);
  }
}
/**
 Tests if the given object is an array
 @private
 */


function isArray(value) {
  return value && !value.propertyIsEnumerable('length') && _typeof(value) === 'object' && typeof value.length === 'number';
}
/**
 Tests if the given value is a string
 @param value
 @returns {Boolean}
 @private
 */


function isString(value) {
  return typeof value === 'string' || value instanceof String;
}
/**
 Tests if the given value is a number
 @param value
 @returns {Boolean}
 @private
 */


function isNumeric(value) {
  return !isNaN(parseFloat(value)) && isFinite(value);
}
/**
 Tests if the given value is an ID
 @param value
 @returns {Boolean}
 @private
 */


function isID(value) {
  return utils.isString(value) || utils.isNumeric(value);
}
/**
 Tests if the given components are the same, where the components can be either IDs or instances.
 @param c1
 @param c2
 @returns {Boolean}
 @private
 */


function isSameComponent(c1, c2) {
  if (!c1 || !c2) {
    return false;
  }

  var id1 = utils.isNumeric(c1) || utils.isString(c1) ? "".concat(c1) : c1.id;
  var id2 = utils.isNumeric(c2) || utils.isString(c2) ? "".concat(c2) : c2.id;
  return id1 === id2;
}
/**
 Tests if the given value is a function
 @param value
 @returns {Boolean}
 @private
 */


function isFunction(value) {
  return typeof value === "function";
}
/**
 Tests if the given value is a JavaScript JSON object, eg, ````{ foo: "bar" }````.
 @param value
 @returns {Boolean}
 @private
 */


function isObject(value) {
  var objectConstructor = {}.constructor;
  return !!value && value.constructor === objectConstructor;
}
/** Returns a shallow copy
 */


function copy(o) {
  return utils.apply(o, {});
}
/** Add properties of o to o2, overwriting them on o2 if already there
 */


function apply(o, o2) {
  for (var name in o) {
    if (o.hasOwnProperty(name)) {
      o2[name] = o[name];
    }
  }

  return o2;
}
/**
 Add non-null/defined properties of o to o2
 @private
 */


function apply2(o, o2) {
  for (var name in o) {
    if (o.hasOwnProperty(name)) {
      if (o[name] !== undefined && o[name] !== null) {
        o2[name] = o[name];
      }
    }
  }

  return o2;
}
/**
 Add properties of o to o2 where undefined or null on o2
 @private
 */


function applyIf(o, o2) {
  for (var name in o) {
    if (o.hasOwnProperty(name)) {
      if (o2[name] === undefined || o2[name] === null) {
        o2[name] = o[name];
      }
    }
  }

  return o2;
}
/**
 Returns true if the given map is empty.
 @param obj
 @returns {Boolean}
 @private
 */


function isEmptyObject(obj) {
  for (var name in obj) {
    if (obj.hasOwnProperty(name)) {
      return false;
    }
  }

  return true;
}
/**
 Returns the given ID as a string, in quotes if the ID was a string to begin with.

 This is useful for logging IDs.

 @param {Number| String} id The ID
 @returns {String}
 @private
 */


function inQuotes(id) {
  return utils.isNumeric(id) ? "".concat(id) : "'".concat(id, "'");
}
/**
 Returns the concatenation of two typed arrays.
 @param a
 @param b
 @returns {*|a}
 @private
 */


function concat(a, b) {
  var c = new a.constructor(a.length + b.length);
  c.set(a);
  c.set(b, a.length);
  return c;
}

function flattenParentChildHierarchy(root) {
  var list = [];

  function visit(node) {
    node.id = node.uuid;
    delete node.oid;
    list.push(node);
    var children = node.children;

    if (children) {
      for (var i = 0, len = children.length; i < len; i++) {
        var child = children[i];
        child.parent = node.id;
        visit(children[i]);
      }
    }

    node.children = [];
  }

  visit(root);
  return list;
}
/**
 * @private
 */


var utils = {
  xmlToJson: xmlToJson,
  clone: clone,
  compressGuid: compressGuid,
  findNodeOfType: findNodeOfType,
  timeout: timeout,
  httpRequest: httpRequest,
  loadJSON: loadJSON,
  loadArraybuffer: loadArraybuffer,
  queryString: queryString,
  isArray: isArray,
  isString: isString,
  isNumeric: isNumeric,
  isID: isID,
  isSameComponent: isSameComponent,
  isFunction: isFunction,
  isObject: isObject,
  copy: copy,
  apply: apply,
  apply2: apply2,
  applyIf: applyIf,
  isEmptyObject: isEmptyObject,
  inQuotes: inQuotes,
  concat: concat,
  flattenParentChildHierarchy: flattenParentChildHierarchy
};

var scenesRenderInfo = {}; // Used for throttling FPS for each Scene

var sceneIDMap = new Map(); // Ensures unique scene IDs

var taskQueue = new Queue(); // Task queue, which is pumped on each frame; tasks are pushed to it with calls to xeokit.schedule

var tickEvent = {
  sceneId: null,
  time: null,
  startTime: null,
  prevTime: null,
  deltaTime: null
};
var taskBudget = 10; // Millisecs we're allowed to spend on tasks in each frame
/**
 * @private
 */

function Core() {
  /**
   Semantic version number. The value for this is set by an expression that's concatenated to
   the end of the built binary by the xeokit build script.
   @property version
   @namespace xeokit
   @type {String}
   */
  this.version = "1.0.0";
  /**
   Existing {@link Scene}s , mapped to their IDs
   @property scenes
   @namespace xeokit
   @type {Scene}
   */

  this.scenes = {};
  this._superTypes = {}; // For each component type, a list of its supertypes, ordered upwards in the hierarchy.

  /**
   * Registers a scene on xeokit.
   * This is called within the xeokit.Scene constructor.
   * @private
   */

  this._addScene = function (scene) {
    if (scene.id) {
      // User-supplied ID
      if (core.scenes[scene.id]) {
        console.error("[ERROR] Scene ".concat(utils.inQuotes(scene.id), " already exists"));
        return;
      }
    } else {
      // Auto-generated ID
      scene.id = sceneIDMap.addItem({});
    }

    core.scenes[scene.id] = scene;
    var ticksPerOcclusionTest = scene.ticksPerOcclusionTest;
    var ticksPerRender = scene.ticksPerRender;
    scenesRenderInfo[scene.id] = {
      ticksPerOcclusionTest: ticksPerOcclusionTest,
      ticksPerRender: ticksPerRender,
      renderCountdown: ticksPerRender
    };
    scene.once("destroyed", function () {
      // Unregister destroyed scenes
      sceneIDMap.removeItem(scene.id);
      delete core.scenes[scene.id];
      delete scenesRenderInfo[scene.id];
    });
  };
  /**
   * @private
   */


  this.clear = function () {
    var scene;

    for (var id in core.scenes) {
      if (core.scenes.hasOwnProperty(id)) {
        scene = core.scenes[id]; // Only clear the default Scene
        // but destroy all the others

        if (id === "default.scene") {
          scene.clear();
        } else {
          scene.destroy();
          delete core.scenes[scene.id];
        }
      }
    }
  };
  /**
   * Schedule a task to run at the next frame.
   *
   * Internally, this pushes the task to a FIFO queue. Within each frame interval, xeokit processes the queue
   * for a certain period of time, popping tasks and running them. After each frame interval, tasks that did not
   * get a chance to run during the task are left in the queue to be run next time.
   *
   * @param {Function} callback Callback that runs the task.
   * @param {Object} [scope] Scope for the callback.
   */


  this.scheduleTask = function (callback, scope) {
    taskQueue.push(callback);
    taskQueue.push(scope);
  };

  this.runTasks = function () {
    var until = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : -1;
    // Pops and processes tasks in the queue, until the given number of milliseconds has elapsed.
    var time = new Date().getTime();
    var callback;
    var scope;
    var tasksRun = 0;

    while (taskQueue.length > 0 && (until < 0 || time < until)) {
      callback = taskQueue.shift();
      scope = taskQueue.shift();

      if (scope) {
        callback.call(scope);
      } else {
        callback();
      }

      time = new Date().getTime();
      tasksRun++;
    }

    return tasksRun;
  };

  this.getNumTasks = function () {
    return taskQueue.length;
  };
}
/**
 * @private
 * @type {Core}
 */


var core = new Core();

var frame = function frame() {
  var time = Date.now();

  runTasks(time);
  fireTickEvents(time);
  renderScenes();
  window.requestPostAnimationFrame !== undefined ? window.requestPostAnimationFrame(frame) : requestAnimationFrame(frame);
};

function runTasks(time) {
  // Process as many enqueued tasks as we can within the per-frame task budget
  core.runTasks(time + taskBudget);
  core.getNumTasks();
}

function fireTickEvents(time) {
  // Fire tick event on each Scene
  tickEvent.time = time;

  for (var id in core.scenes) {
    if (core.scenes.hasOwnProperty(id)) {
      var scene = core.scenes[id];
      tickEvent.sceneId = id;
      tickEvent.startTime = scene.startTime;
      tickEvent.deltaTime = tickEvent.prevTime != null ? tickEvent.time - tickEvent.prevTime : 0;
      /**
       * Fired on each game loop iteration.
       *
       * @event tick
       * @param {String} sceneID The ID of this Scene.
       * @param {Number} startTime The time in seconds since 1970 that this Scene was instantiated.
       * @param {Number} time The time in seconds since 1970 of this "tick" event.
       * @param {Number} prevTime The time of the previous "tick" event from this Scene.
       * @param {Number} deltaTime The time in seconds since the previous "tick" event from this Scene.
       */

      scene.fire("tick", tickEvent, true);
    }
  }

  tickEvent.prevTime = time;
}

function renderScenes() {
  var scenes = core.scenes;
  var forceRender = false;
  var scene;
  var renderInfo;
  var ticksPerOcclusionTest;
  var ticksPerRender;
  var id;

  for (id in scenes) {
    if (scenes.hasOwnProperty(id)) {
      scene = scenes[id];
      renderInfo = scenesRenderInfo[id];

      if (!renderInfo) {
        renderInfo = scenesRenderInfo[id] = {}; // FIXME
      }

      ticksPerOcclusionTest = scene.ticksPerOcclusionTest;

      if (renderInfo.ticksPerOcclusionTest !== ticksPerOcclusionTest) {
        renderInfo.ticksPerOcclusionTest = ticksPerOcclusionTest;
        renderInfo.renderCountdown = ticksPerOcclusionTest;
      }

      if (--scene.occlusionTestCountdown <= 0) {
        scene.doOcclusionTest();
        scene.occlusionTestCountdown = ticksPerOcclusionTest;
      }

      ticksPerRender = scene.ticksPerRender;

      if (renderInfo.ticksPerRender !== ticksPerRender) {
        renderInfo.ticksPerRender = ticksPerRender;
        renderInfo.renderCountdown = ticksPerRender;
      }

      if (--renderInfo.renderCountdown === 0) {
        scene.render(forceRender);
        renderInfo.renderCountdown = ticksPerRender;
      }
    }
  }
}

window.requestPostAnimationFrame !== undefined ? window.requestPostAnimationFrame(frame) : requestAnimationFrame(frame);

// Some temporary vars to help avoid garbage collection
var doublePrecision = true;
var FloatArrayType = doublePrecision ? Float64Array : Float32Array;
var tempMat1 = new FloatArrayType(16);
var tempMat2 = new FloatArrayType(16);
var tempVec4 = new FloatArrayType(4);
/**
 * @private
 */

var math = {
  setDoublePrecisionEnabled: function setDoublePrecisionEnabled(enable) {
    doublePrecision = enable;
    FloatArrayType = doublePrecision ? Float64Array : Float32Array;
  },
  getDoublePrecisionEnabled: function getDoublePrecisionEnabled() {
    return doublePrecision;
  },
  MIN_DOUBLE: -Number.MAX_SAFE_INTEGER,
  MAX_DOUBLE: Number.MAX_SAFE_INTEGER,

  /**
   * The number of radiians in a degree (0.0174532925).
   * @property DEGTORAD
   * @type {Number}
   */
  DEGTORAD: 0.0174532925,

  /**
   * The number of degrees in a radian.
   * @property RADTODEG
   * @type {Number}
   */
  RADTODEG: 57.295779513,
  unglobalizeObjectId: function unglobalizeObjectId(modelId, globalId) {
    var idx = globalId.indexOf("#");
    return idx === modelId.length && globalId.startsWith(modelId) ? globalId.substring(idx + 1) : globalId;
  },
  globalizeObjectId: function globalizeObjectId(modelId, objectId) {
    return modelId + "#" + objectId;
  },

  /**
   * Returns a new, uninitialized two-element vector.
   * @method vec2
   * @param [values] Initial values.
   * @static
   * @returns {Number[]}
   */
  vec2: function vec2(values) {
    return new FloatArrayType(values || 2);
  },

  /**
   * Returns a new, uninitialized three-element vector.
   * @method vec3
   * @param [values] Initial values.
   * @static
   * @returns {Number[]}
   */
  vec3: function vec3(values) {
    return new FloatArrayType(values || 3);
  },

  /**
   * Returns a new, uninitialized four-element vector.
   * @method vec4
   * @param [values] Initial values.
   * @static
   * @returns {Number[]}
   */
  vec4: function vec4(values) {
    return new FloatArrayType(values || 4);
  },

  /**
   * Returns a new, uninitialized 3x3 matrix.
   * @method mat3
   * @param [values] Initial values.
   * @static
   * @returns {Number[]}
   */
  mat3: function mat3(values) {
    return new FloatArrayType(values || 9);
  },

  /**
   * Converts a 3x3 matrix to 4x4
   * @method mat3ToMat4
   * @param mat3 3x3 matrix.
   * @param mat4 4x4 matrix
   * @static
   * @returns {Number[]}
   */
  mat3ToMat4: function mat3ToMat4(mat3) {
    var mat4 = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : new FloatArrayType(16);
    mat4[0] = mat3[0];
    mat4[1] = mat3[1];
    mat4[2] = mat3[2];
    mat4[3] = 0;
    mat4[4] = mat3[3];
    mat4[5] = mat3[4];
    mat4[6] = mat3[5];
    mat4[7] = 0;
    mat4[8] = mat3[6];
    mat4[9] = mat3[7];
    mat4[10] = mat3[8];
    mat4[11] = 0;
    mat4[12] = 0;
    mat4[13] = 0;
    mat4[14] = 0;
    mat4[15] = 1;
    return mat4;
  },

  /**
   * Returns a new, uninitialized 4x4 matrix.
   * @method mat4
   * @param [values] Initial values.
   * @static
   * @returns {Number[]}
   */
  mat4: function mat4(values) {
    return new FloatArrayType(values || 16);
  },

  /**
   * Converts a 4x4 matrix to 3x3
   * @method mat4ToMat3
   * @param mat4 4x4 matrix.
   * @param mat3 3x3 matrix
   * @static
   * @returns {Number[]}
   */
  mat4ToMat3: function mat4ToMat3(mat4, mat3) {// TODO
    //return new FloatArrayType(values || 9);
  },

  /**
   * Converts a list of double-precision values to a list of high-part floats and a list of low-part floats.
   * @param doubleVals
   * @param floatValsHigh
   * @param floatValsLow
   */
  doublesToFloats: function doublesToFloats(doubleVals, floatValsHigh, floatValsLow) {
    var floatPair = new FloatArrayType(2);

    for (var i = 0, len = doubleVals.length; i < len; i++) {
      math.splitDouble(doubleVals[i], floatPair);
      floatValsHigh[i] = floatPair[0];
      floatValsLow[i] = floatPair[1];
    }
  },

  /**
   * Splits a double value into two floats.
   * @param value
   * @param floatPair
   */
  splitDouble: function splitDouble(value, floatPair) {
    var hi = FloatArrayType.from([value])[0];
    var low = value - hi;
    floatPair[0] = hi;
    floatPair[1] = low;
  },

  /**
   * Returns a new UUID.
   * @method createUUID
   * @static
   * @return string The new UUID
   */
  createUUID: function () {
    var lut = [];

    for (var i = 0; i < 256; i++) {
      lut[i] = (i < 16 ? '0' : '') + i.toString(16);
    }

    return function () {
      var d0 = Math.random() * 0xffffffff | 0;
      var d1 = Math.random() * 0xffffffff | 0;
      var d2 = Math.random() * 0xffffffff | 0;
      var d3 = Math.random() * 0xffffffff | 0;
      return "".concat(lut[d0 & 0xff] + lut[d0 >> 8 & 0xff] + lut[d0 >> 16 & 0xff] + lut[d0 >> 24 & 0xff], "-").concat(lut[d1 & 0xff]).concat(lut[d1 >> 8 & 0xff], "-").concat(lut[d1 >> 16 & 0x0f | 0x40]).concat(lut[d1 >> 24 & 0xff], "-").concat(lut[d2 & 0x3f | 0x80]).concat(lut[d2 >> 8 & 0xff], "-").concat(lut[d2 >> 16 & 0xff]).concat(lut[d2 >> 24 & 0xff]).concat(lut[d3 & 0xff]).concat(lut[d3 >> 8 & 0xff]).concat(lut[d3 >> 16 & 0xff]).concat(lut[d3 >> 24 & 0xff]);
    };
  }(),

  /**
   * Clamps a value to the given range.
   * @param {Number} value Value to clamp.
   * @param {Number} min Lower bound.
   * @param {Number} max Upper bound.
   * @returns {Number} Clamped result.
   */
  clamp: function clamp(value, min, max) {
    return Math.max(min, Math.min(max, value));
  },

  /**
   * Floating-point modulus
   * @method fmod
   * @static
   * @param {Number} a
   * @param {Number} b
   * @returns {*}
   */
  fmod: function fmod(a, b) {
    if (a < b) {
      console.error("math.fmod : Attempting to find modulus within negative range - would be infinite loop - ignoring");
      return a;
    }

    while (b <= a) {
      a -= b;
    }

    return a;
  },

  /**
   * Returns true if the two 3-element vectors are the same.
   * @param v1
   * @param v2
   * @returns {Boolean}
   */
  compareVec3: function compareVec3(v1, v2) {
    return v1[0] === v2[0] && v1[1] === v2[1] && v1[2] === v2[2];
  },

  /**
   * Negates a three-element vector.
   * @method negateVec3
   * @static
   * @param {Array(Number)} v Vector to negate
   * @param  {Array(Number)} [dest] Destination vector
   * @return {Array(Number)} dest if specified, v otherwise
   */
  negateVec3: function negateVec3(v, dest) {
    if (!dest) {
      dest = v;
    }

    dest[0] = -v[0];
    dest[1] = -v[1];
    dest[2] = -v[2];
    return dest;
  },

  /**
   * Negates a four-element vector.
   * @method negateVec4
   * @static
   * @param {Array(Number)} v Vector to negate
   * @param  {Array(Number)} [dest] Destination vector
   * @return {Array(Number)} dest if specified, v otherwise
   */
  negateVec4: function negateVec4(v, dest) {
    if (!dest) {
      dest = v;
    }

    dest[0] = -v[0];
    dest[1] = -v[1];
    dest[2] = -v[2];
    dest[3] = -v[3];
    return dest;
  },

  /**
   * Adds one four-element vector to another.
   * @method addVec4
   * @static
   * @param {Array(Number)} u First vector
   * @param {Array(Number)} v Second vector
   * @param  {Array(Number)} [dest] Destination vector
   * @return {Array(Number)} dest if specified, u otherwise
   */
  addVec4: function addVec4(u, v, dest) {
    if (!dest) {
      dest = u;
    }

    dest[0] = u[0] + v[0];
    dest[1] = u[1] + v[1];
    dest[2] = u[2] + v[2];
    dest[3] = u[3] + v[3];
    return dest;
  },

  /**
   * Adds a scalar value to each element of a four-element vector.
   * @method addVec4Scalar
   * @static
   * @param {Array(Number)} v The vector
   * @param {Number} s The scalar
   * @param  {Array(Number)} [dest] Destination vector
   * @return {Array(Number)} dest if specified, v otherwise
   */
  addVec4Scalar: function addVec4Scalar(v, s, dest) {
    if (!dest) {
      dest = v;
    }

    dest[0] = v[0] + s;
    dest[1] = v[1] + s;
    dest[2] = v[2] + s;
    dest[3] = v[3] + s;
    return dest;
  },

  /**
   * Adds one three-element vector to another.
   * @method addVec3
   * @static
   * @param {Array(Number)} u First vector
   * @param {Array(Number)} v Second vector
   * @param  {Array(Number)} [dest] Destination vector
   * @return {Array(Number)} dest if specified, u otherwise
   */
  addVec3: function addVec3(u, v, dest) {
    if (!dest) {
      dest = u;
    }

    dest[0] = u[0] + v[0];
    dest[1] = u[1] + v[1];
    dest[2] = u[2] + v[2];
    return dest;
  },

  /**
   * Adds a scalar value to each element of a three-element vector.
   * @method addVec4Scalar
   * @static
   * @param {Array(Number)} v The vector
   * @param {Number} s The scalar
   * @param  {Array(Number)} [dest] Destination vector
   * @return {Array(Number)} dest if specified, v otherwise
   */
  addVec3Scalar: function addVec3Scalar(v, s, dest) {
    if (!dest) {
      dest = v;
    }

    dest[0] = v[0] + s;
    dest[1] = v[1] + s;
    dest[2] = v[2] + s;
    return dest;
  },

  /**
   * Subtracts one four-element vector from another.
   * @method subVec4
   * @static
   * @param {Array(Number)} u First vector
   * @param {Array(Number)} v Vector to subtract
   * @param  {Array(Number)} [dest] Destination vector
   * @return {Array(Number)} dest if specified, u otherwise
   */
  subVec4: function subVec4(u, v, dest) {
    if (!dest) {
      dest = u;
    }

    dest[0] = u[0] - v[0];
    dest[1] = u[1] - v[1];
    dest[2] = u[2] - v[2];
    dest[3] = u[3] - v[3];
    return dest;
  },

  /**
   * Subtracts one three-element vector from another.
   * @method subVec3
   * @static
   * @param {Array(Number)} u First vector
   * @param {Array(Number)} v Vector to subtract
   * @param  {Array(Number)} [dest] Destination vector
   * @return {Array(Number)} dest if specified, u otherwise
   */
  subVec3: function subVec3(u, v, dest) {
    if (!dest) {
      dest = u;
    }

    dest[0] = u[0] - v[0];
    dest[1] = u[1] - v[1];
    dest[2] = u[2] - v[2];
    return dest;
  },

  /**
   * Subtracts one two-element vector from another.
   * @method subVec2
   * @static
   * @param {Array(Number)} u First vector
   * @param {Array(Number)} v Vector to subtract
   * @param  {Array(Number)} [dest] Destination vector
   * @return {Array(Number)} dest if specified, u otherwise
   */
  subVec2: function subVec2(u, v, dest) {
    if (!dest) {
      dest = u;
    }

    dest[0] = u[0] - v[0];
    dest[1] = u[1] - v[1];
    return dest;
  },

  /**
   * Get the geometric mean of the vectors.
   * @method geometricMeanVec2
   * @static
   * @param {...Array(Number)} vectors Vec2 to mean
   * @return {Array(Number)} The geometric mean vec2
   */
  geometricMeanVec2: function geometricMeanVec2() {
    for (var _len = arguments.length, vectors = new Array(_len), _key = 0; _key < _len; _key++) {
      vectors[_key] = arguments[_key];
    }

    var geometricMean = new FloatArrayType(vectors[0]);

    for (var i = 1; i < vectors.length; i++) {
      geometricMean[0] += vectors[i][0];
      geometricMean[1] += vectors[i][1];
    }

    geometricMean[0] /= vectors.length;
    geometricMean[1] /= vectors.length;
    return geometricMean;
  },

  /**
   * Subtracts a scalar value from each element of a four-element vector.
   * @method subVec4Scalar
   * @static
   * @param {Array(Number)} v The vector
   * @param {Number} s The scalar
   * @param  {Array(Number)} [dest] Destination vector
   * @return {Array(Number)} dest if specified, v otherwise
   */
  subVec4Scalar: function subVec4Scalar(v, s, dest) {
    if (!dest) {
      dest = v;
    }

    dest[0] = v[0] - s;
    dest[1] = v[1] - s;
    dest[2] = v[2] - s;
    dest[3] = v[3] - s;
    return dest;
  },

  /**
   * Sets each element of a 4-element vector to a scalar value minus the value of that element.
   * @method subScalarVec4
   * @static
   * @param {Array(Number)} v The vector
   * @param {Number} s The scalar
   * @param  {Array(Number)} [dest] Destination vector
   * @return {Array(Number)} dest if specified, v otherwise
   */
  subScalarVec4: function subScalarVec4(v, s, dest) {
    if (!dest) {
      dest = v;
    }

    dest[0] = s - v[0];
    dest[1] = s - v[1];
    dest[2] = s - v[2];
    dest[3] = s - v[3];
    return dest;
  },

  /**
   * Multiplies one three-element vector by another.
   * @method mulVec3
   * @static
   * @param {Array(Number)} u First vector
   * @param {Array(Number)} v Second vector
   * @param  {Array(Number)} [dest] Destination vector
   * @return {Array(Number)} dest if specified, u otherwise
   */
  mulVec4: function mulVec4(u, v, dest) {
    if (!dest) {
      dest = u;
    }

    dest[0] = u[0] * v[0];
    dest[1] = u[1] * v[1];
    dest[2] = u[2] * v[2];
    dest[3] = u[3] * v[3];
    return dest;
  },

  /**
   * Multiplies each element of a four-element vector by a scalar.
   * @method mulVec34calar
   * @static
   * @param {Array(Number)} v The vector
   * @param {Number} s The scalar
   * @param  {Array(Number)} [dest] Destination vector
   * @return {Array(Number)} dest if specified, v otherwise
   */
  mulVec4Scalar: function mulVec4Scalar(v, s, dest) {
    if (!dest) {
      dest = v;
    }

    dest[0] = v[0] * s;
    dest[1] = v[1] * s;
    dest[2] = v[2] * s;
    dest[3] = v[3] * s;
    return dest;
  },

  /**
   * Multiplies each element of a three-element vector by a scalar.
   * @method mulVec3Scalar
   * @static
   * @param {Array(Number)} v The vector
   * @param {Number} s The scalar
   * @param  {Array(Number)} [dest] Destination vector
   * @return {Array(Number)} dest if specified, v otherwise
   */
  mulVec3Scalar: function mulVec3Scalar(v, s, dest) {
    if (!dest) {
      dest = v;
    }

    dest[0] = v[0] * s;
    dest[1] = v[1] * s;
    dest[2] = v[2] * s;
    return dest;
  },

  /**
   * Multiplies each element of a two-element vector by a scalar.
   * @method mulVec2Scalar
   * @static
   * @param {Array(Number)} v The vector
   * @param {Number} s The scalar
   * @param  {Array(Number)} [dest] Destination vector
   * @return {Array(Number)} dest if specified, v otherwise
   */
  mulVec2Scalar: function mulVec2Scalar(v, s, dest) {
    if (!dest) {
      dest = v;
    }

    dest[0] = v[0] * s;
    dest[1] = v[1] * s;
    return dest;
  },

  /**
   * Divides one three-element vector by another.
   * @method divVec3
   * @static
   * @param {Array(Number)} u First vector
   * @param {Array(Number)} v Second vector
   * @param  {Array(Number)} [dest] Destination vector
   * @return {Array(Number)} dest if specified, u otherwise
   */
  divVec3: function divVec3(u, v, dest) {
    if (!dest) {
      dest = u;
    }

    dest[0] = u[0] / v[0];
    dest[1] = u[1] / v[1];
    dest[2] = u[2] / v[2];
    return dest;
  },

  /**
   * Divides one four-element vector by another.
   * @method divVec4
   * @static
   * @param {Array(Number)} u First vector
   * @param {Array(Number)} v Second vector
   * @param  {Array(Number)} [dest] Destination vector
   * @return {Array(Number)} dest if specified, u otherwise
   */
  divVec4: function divVec4(u, v, dest) {
    if (!dest) {
      dest = u;
    }

    dest[0] = u[0] / v[0];
    dest[1] = u[1] / v[1];
    dest[2] = u[2] / v[2];
    dest[3] = u[3] / v[3];
    return dest;
  },

  /**
   * Divides a scalar by a three-element vector, returning a new vector.
   * @method divScalarVec3
   * @static
   * @param v vec3
   * @param s scalar
   * @param dest vec3 - optional destination
   * @return [] dest if specified, v otherwise
   */
  divScalarVec3: function divScalarVec3(s, v, dest) {
    if (!dest) {
      dest = v;
    }

    dest[0] = s / v[0];
    dest[1] = s / v[1];
    dest[2] = s / v[2];
    return dest;
  },

  /**
   * Divides a three-element vector by a scalar.
   * @method divVec3Scalar
   * @static
   * @param v vec3
   * @param s scalar
   * @param dest vec3 - optional destination
   * @return [] dest if specified, v otherwise
   */
  divVec3Scalar: function divVec3Scalar(v, s, dest) {
    if (!dest) {
      dest = v;
    }

    dest[0] = v[0] / s;
    dest[1] = v[1] / s;
    dest[2] = v[2] / s;
    return dest;
  },

  /**
   * Divides a four-element vector by a scalar.
   * @method divVec4Scalar
   * @static
   * @param v vec4
   * @param s scalar
   * @param dest vec4 - optional destination
   * @return [] dest if specified, v otherwise
   */
  divVec4Scalar: function divVec4Scalar(v, s, dest) {
    if (!dest) {
      dest = v;
    }

    dest[0] = v[0] / s;
    dest[1] = v[1] / s;
    dest[2] = v[2] / s;
    dest[3] = v[3] / s;
    return dest;
  },

  /**
   * Divides a scalar by a four-element vector, returning a new vector.
   * @method divScalarVec4
   * @static
   * @param s scalar
   * @param v vec4
   * @param dest vec4 - optional destination
   * @return [] dest if specified, v otherwise
   */
  divScalarVec4: function divScalarVec4(s, v, dest) {
    if (!dest) {
      dest = v;
    }

    dest[0] = s / v[0];
    dest[1] = s / v[1];
    dest[2] = s / v[2];
    dest[3] = s / v[3];
    return dest;
  },

  /**
   * Returns the dot product of two four-element vectors.
   * @method dotVec4
   * @static
   * @param {Array(Number)} u First vector
   * @param {Array(Number)} v Second vector
   * @return The dot product
   */
  dotVec4: function dotVec4(u, v) {
    return u[0] * v[0] + u[1] * v[1] + u[2] * v[2] + u[3] * v[3];
  },

  /**
   * Returns the cross product of two four-element vectors.
   * @method cross3Vec4
   * @static
   * @param {Array(Number)} u First vector
   * @param {Array(Number)} v Second vector
   * @return The cross product
   */
  cross3Vec4: function cross3Vec4(u, v) {
    var u0 = u[0];
    var u1 = u[1];
    var u2 = u[2];
    var v0 = v[0];
    var v1 = v[1];
    var v2 = v[2];
    return [u1 * v2 - u2 * v1, u2 * v0 - u0 * v2, u0 * v1 - u1 * v0, 0.0];
  },

  /**
   * Returns the cross product of two three-element vectors.
   * @method cross3Vec3
   * @static
   * @param {Array(Number)} u First vector
   * @param {Array(Number)} v Second vector
   * @return The cross product
   */
  cross3Vec3: function cross3Vec3(u, v, dest) {
    if (!dest) {
      dest = u;
    }

    var x = u[0];
    var y = u[1];
    var z = u[2];
    var x2 = v[0];
    var y2 = v[1];
    var z2 = v[2];
    dest[0] = y * z2 - z * y2;
    dest[1] = z * x2 - x * z2;
    dest[2] = x * y2 - y * x2;
    return dest;
  },
  sqLenVec4: function sqLenVec4(v) {
    // TODO
    return math.dotVec4(v, v);
  },

  /**
   * Returns the length of a four-element vector.
   * @method lenVec4
   * @static
   * @param {Array(Number)} v The vector
   * @return The length
   */
  lenVec4: function lenVec4(v) {
    return Math.sqrt(math.sqLenVec4(v));
  },

  /**
   * Returns the dot product of two three-element vectors.
   * @method dotVec3
   * @static
   * @param {Array(Number)} u First vector
   * @param {Array(Number)} v Second vector
   * @return The dot product
   */
  dotVec3: function dotVec3(u, v) {
    return u[0] * v[0] + u[1] * v[1] + u[2] * v[2];
  },

  /**
   * Returns the dot product of two two-element vectors.
   * @method dotVec4
   * @static
   * @param {Array(Number)} u First vector
   * @param {Array(Number)} v Second vector
   * @return The dot product
   */
  dotVec2: function dotVec2(u, v) {
    return u[0] * v[0] + u[1] * v[1];
  },
  sqLenVec3: function sqLenVec3(v) {
    return math.dotVec3(v, v);
  },
  sqLenVec2: function sqLenVec2(v) {
    return math.dotVec2(v, v);
  },

  /**
   * Returns the length of a three-element vector.
   * @method lenVec3
   * @static
   * @param {Array(Number)} v The vector
   * @return The length
   */
  lenVec3: function lenVec3(v) {
    return Math.sqrt(math.sqLenVec3(v));
  },
  distVec3: function () {
    var vec = new FloatArrayType(3);
    return function (v, w) {
      return math.lenVec3(math.subVec3(v, w, vec));
    };
  }(),

  /**
   * Returns the length of a two-element vector.
   * @method lenVec2
   * @static
   * @param {Array(Number)} v The vector
   * @return The length
   */
  lenVec2: function lenVec2(v) {
    return Math.sqrt(math.sqLenVec2(v));
  },
  distVec2: function () {
    var vec = new FloatArrayType(2);
    return function (v, w) {
      return math.lenVec2(math.subVec2(v, w, vec));
    };
  }(),

  /**
   * @method rcpVec3
   * @static
   * @param v vec3
   * @param dest vec3 - optional destination
   * @return [] dest if specified, v otherwise
   *
   */
  rcpVec3: function rcpVec3(v, dest) {
    return math.divScalarVec3(1.0, v, dest);
  },

  /**
   * Normalizes a four-element vector
   * @method normalizeVec4
   * @static
   * @param v vec4
   * @param dest vec4 - optional destination
   * @return [] dest if specified, v otherwise
   *
   */
  normalizeVec4: function normalizeVec4(v, dest) {
    var f = 1.0 / math.lenVec4(v);
    return math.mulVec4Scalar(v, f, dest);
  },

  /**
   * Normalizes a three-element vector
   * @method normalizeVec4
   * @static
   */
  normalizeVec3: function normalizeVec3(v, dest) {
    var f = 1.0 / math.lenVec3(v);
    return math.mulVec3Scalar(v, f, dest);
  },

  /**
   * Normalizes a two-element vector
   * @method normalizeVec2
   * @static
   */
  normalizeVec2: function normalizeVec2(v, dest) {
    var f = 1.0 / math.lenVec2(v);
    return math.mulVec2Scalar(v, f, dest);
  },

  /**
   * Gets the angle between two vectors
   * @method angleVec3
   * @param v
   * @param w
   * @returns {number}
   */
  angleVec3: function angleVec3(v, w) {
    var theta = math.dotVec3(v, w) / Math.sqrt(math.sqLenVec3(v) * math.sqLenVec3(w));
    theta = theta < -1 ? -1 : theta > 1 ? 1 : theta; // Clamp to handle numerical problems

    return Math.acos(theta);
  },

  /**
   * Creates a three-element vector from the rotation part of a sixteen-element matrix.
   * @param m
   * @param dest
   */
  vec3FromMat4Scale: function () {
    var tempVec3 = new FloatArrayType(3);
    return function (m, dest) {
      tempVec3[0] = m[0];
      tempVec3[1] = m[1];
      tempVec3[2] = m[2];
      dest[0] = math.lenVec3(tempVec3);
      tempVec3[0] = m[4];
      tempVec3[1] = m[5];
      tempVec3[2] = m[6];
      dest[1] = math.lenVec3(tempVec3);
      tempVec3[0] = m[8];
      tempVec3[1] = m[9];
      tempVec3[2] = m[10];
      dest[2] = math.lenVec3(tempVec3);
      return dest;
    };
  }(),

  /**
   * Converts an n-element vector to a JSON-serializable
   * array with values rounded to two decimal places.
   */
  vecToArray: function () {
    function trunc(v) {
      return Math.round(v * 100000) / 100000;
    }

    return function (v) {
      v = Array.prototype.slice.call(v);

      for (var i = 0, len = v.length; i < len; i++) {
        v[i] = trunc(v[i]);
      }

      return v;
    };
  }(),

  /**
   * Converts a 3-element vector from an array to an object of the form ````{x:999, y:999, z:999}````.
   * @param arr
   * @returns {{x: *, y: *, z: *}}
   */
  xyzArrayToObject: function xyzArrayToObject(arr) {
    return {
      "x": arr[0],
      "y": arr[1],
      "z": arr[2]
    };
  },

  /**
   * Converts a 3-element vector object of the form ````{x:999, y:999, z:999}```` to an array.
   * @param xyz
   * @param  [arry]
   * @returns {*[]}
   */
  xyzObjectToArray: function xyzObjectToArray(xyz, arry) {
    arry = arry || math.vec3();
    arry[0] = xyz.x;
    arry[1] = xyz.y;
    arry[2] = xyz.z;
    return arry;
  },

  /**
   * Duplicates a 4x4 identity matrix.
   * @method dupMat4
   * @static
   */
  dupMat4: function dupMat4(m) {
    return m.slice(0, 16);
  },

  /**
   * Extracts a 3x3 matrix from a 4x4 matrix.
   * @method mat4To3
   * @static
   */
  mat4To3: function mat4To3(m) {
    return [m[0], m[1], m[2], m[4], m[5], m[6], m[8], m[9], m[10]];
  },

  /**
   * Returns a 4x4 matrix with each element set to the given scalar value.
   * @method m4s
   * @static
   */
  m4s: function m4s(s) {
    return [s, s, s, s, s, s, s, s, s, s, s, s, s, s, s, s];
  },

  /**
   * Returns a 4x4 matrix with each element set to zero.
   * @method setMat4ToZeroes
   * @static
   */
  setMat4ToZeroes: function setMat4ToZeroes() {
    return math.m4s(0.0);
  },

  /**
   * Returns a 4x4 matrix with each element set to 1.0.
   * @method setMat4ToOnes
   * @static
   */
  setMat4ToOnes: function setMat4ToOnes() {
    return math.m4s(1.0);
  },

  /**
   * Returns a 4x4 matrix with each element set to 1.0.
   * @method setMat4ToOnes
   * @static
   */
  diagonalMat4v: function diagonalMat4v(v) {
    return new FloatArrayType([v[0], 0.0, 0.0, 0.0, 0.0, v[1], 0.0, 0.0, 0.0, 0.0, v[2], 0.0, 0.0, 0.0, 0.0, v[3]]);
  },

  /**
   * Returns a 4x4 matrix with diagonal elements set to the given vector.
   * @method diagonalMat4c
   * @static
   */
  diagonalMat4c: function diagonalMat4c(x, y, z, w) {
    return math.diagonalMat4v([x, y, z, w]);
  },

  /**
   * Returns a 4x4 matrix with diagonal elements set to the given scalar.
   * @method diagonalMat4s
   * @static
   */
  diagonalMat4s: function diagonalMat4s(s) {
    return math.diagonalMat4c(s, s, s, s);
  },

  /**
   * Returns a 4x4 identity matrix.
   * @method identityMat4
   * @static
   */
  identityMat4: function identityMat4() {
    var mat = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : new FloatArrayType(16);
    mat[0] = 1.0;
    mat[1] = 0.0;
    mat[2] = 0.0;
    mat[3] = 0.0;
    mat[4] = 0.0;
    mat[5] = 1.0;
    mat[6] = 0.0;
    mat[7] = 0.0;
    mat[8] = 0.0;
    mat[9] = 0.0;
    mat[10] = 1.0;
    mat[11] = 0.0;
    mat[12] = 0.0;
    mat[13] = 0.0;
    mat[14] = 0.0;
    mat[15] = 1.0;
    return mat;
  },

  /**
   * Returns a 3x3 identity matrix.
   * @method identityMat3
   * @static
   */
  identityMat3: function identityMat3() {
    var mat = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : new FloatArrayType(9);
    mat[0] = 1.0;
    mat[1] = 0.0;
    mat[2] = 0.0;
    mat[3] = 0.0;
    mat[4] = 1.0;
    mat[5] = 0.0;
    mat[6] = 0.0;
    mat[7] = 0.0;
    mat[8] = 1.0;
    return mat;
  },

  /**
   * Tests if the given 4x4 matrix is the identity matrix.
   * @method isIdentityMat4
   * @static
   */
  isIdentityMat4: function isIdentityMat4(m) {
    if (m[0] !== 1.0 || m[1] !== 0.0 || m[2] !== 0.0 || m[3] !== 0.0 || m[4] !== 0.0 || m[5] !== 1.0 || m[6] !== 0.0 || m[7] !== 0.0 || m[8] !== 0.0 || m[9] !== 0.0 || m[10] !== 1.0 || m[11] !== 0.0 || m[12] !== 0.0 || m[13] !== 0.0 || m[14] !== 0.0 || m[15] !== 1.0) {
      return false;
    }

    return true;
  },

  /**
   * Negates the given 4x4 matrix.
   * @method negateMat4
   * @static
   */
  negateMat4: function negateMat4(m, dest) {
    if (!dest) {
      dest = m;
    }

    dest[0] = -m[0];
    dest[1] = -m[1];
    dest[2] = -m[2];
    dest[3] = -m[3];
    dest[4] = -m[4];
    dest[5] = -m[5];
    dest[6] = -m[6];
    dest[7] = -m[7];
    dest[8] = -m[8];
    dest[9] = -m[9];
    dest[10] = -m[10];
    dest[11] = -m[11];
    dest[12] = -m[12];
    dest[13] = -m[13];
    dest[14] = -m[14];
    dest[15] = -m[15];
    return dest;
  },

  /**
   * Adds the given 4x4 matrices together.
   * @method addMat4
   * @static
   */
  addMat4: function addMat4(a, b, dest) {
    if (!dest) {
      dest = a;
    }

    dest[0] = a[0] + b[0];
    dest[1] = a[1] + b[1];
    dest[2] = a[2] + b[2];
    dest[3] = a[3] + b[3];
    dest[4] = a[4] + b[4];
    dest[5] = a[5] + b[5];
    dest[6] = a[6] + b[6];
    dest[7] = a[7] + b[7];
    dest[8] = a[8] + b[8];
    dest[9] = a[9] + b[9];
    dest[10] = a[10] + b[10];
    dest[11] = a[11] + b[11];
    dest[12] = a[12] + b[12];
    dest[13] = a[13] + b[13];
    dest[14] = a[14] + b[14];
    dest[15] = a[15] + b[15];
    return dest;
  },

  /**
   * Adds the given scalar to each element of the given 4x4 matrix.
   * @method addMat4Scalar
   * @static
   */
  addMat4Scalar: function addMat4Scalar(m, s, dest) {
    if (!dest) {
      dest = m;
    }

    dest[0] = m[0] + s;
    dest[1] = m[1] + s;
    dest[2] = m[2] + s;
    dest[3] = m[3] + s;
    dest[4] = m[4] + s;
    dest[5] = m[5] + s;
    dest[6] = m[6] + s;
    dest[7] = m[7] + s;
    dest[8] = m[8] + s;
    dest[9] = m[9] + s;
    dest[10] = m[10] + s;
    dest[11] = m[11] + s;
    dest[12] = m[12] + s;
    dest[13] = m[13] + s;
    dest[14] = m[14] + s;
    dest[15] = m[15] + s;
    return dest;
  },

  /**
   * Adds the given scalar to each element of the given 4x4 matrix.
   * @method addScalarMat4
   * @static
   */
  addScalarMat4: function addScalarMat4(s, m, dest) {
    return math.addMat4Scalar(m, s, dest);
  },

  /**
   * Subtracts the second 4x4 matrix from the first.
   * @method subMat4
   * @static
   */
  subMat4: function subMat4(a, b, dest) {
    if (!dest) {
      dest = a;
    }

    dest[0] = a[0] - b[0];
    dest[1] = a[1] - b[1];
    dest[2] = a[2] - b[2];
    dest[3] = a[3] - b[3];
    dest[4] = a[4] - b[4];
    dest[5] = a[5] - b[5];
    dest[6] = a[6] - b[6];
    dest[7] = a[7] - b[7];
    dest[8] = a[8] - b[8];
    dest[9] = a[9] - b[9];
    dest[10] = a[10] - b[10];
    dest[11] = a[11] - b[11];
    dest[12] = a[12] - b[12];
    dest[13] = a[13] - b[13];
    dest[14] = a[14] - b[14];
    dest[15] = a[15] - b[15];
    return dest;
  },

  /**
   * Subtracts the given scalar from each element of the given 4x4 matrix.
   * @method subMat4Scalar
   * @static
   */
  subMat4Scalar: function subMat4Scalar(m, s, dest) {
    if (!dest) {
      dest = m;
    }

    dest[0] = m[0] - s;
    dest[1] = m[1] - s;
    dest[2] = m[2] - s;
    dest[3] = m[3] - s;
    dest[4] = m[4] - s;
    dest[5] = m[5] - s;
    dest[6] = m[6] - s;
    dest[7] = m[7] - s;
    dest[8] = m[8] - s;
    dest[9] = m[9] - s;
    dest[10] = m[10] - s;
    dest[11] = m[11] - s;
    dest[12] = m[12] - s;
    dest[13] = m[13] - s;
    dest[14] = m[14] - s;
    dest[15] = m[15] - s;
    return dest;
  },

  /**
   * Subtracts the given scalar from each element of the given 4x4 matrix.
   * @method subScalarMat4
   * @static
   */
  subScalarMat4: function subScalarMat4(s, m, dest) {
    if (!dest) {
      dest = m;
    }

    dest[0] = s - m[0];
    dest[1] = s - m[1];
    dest[2] = s - m[2];
    dest[3] = s - m[3];
    dest[4] = s - m[4];
    dest[5] = s - m[5];
    dest[6] = s - m[6];
    dest[7] = s - m[7];
    dest[8] = s - m[8];
    dest[9] = s - m[9];
    dest[10] = s - m[10];
    dest[11] = s - m[11];
    dest[12] = s - m[12];
    dest[13] = s - m[13];
    dest[14] = s - m[14];
    dest[15] = s - m[15];
    return dest;
  },

  /**
   * Multiplies the two given 4x4 matrix by each other.
   * @method mulMat4
   * @static
   */
  mulMat4: function mulMat4(a, b, dest) {
    if (!dest) {
      dest = a;
    } // Cache the matrix values (makes for huge speed increases!)


    var a00 = a[0];
    var a01 = a[1];
    var a02 = a[2];
    var a03 = a[3];
    var a10 = a[4];
    var a11 = a[5];
    var a12 = a[6];
    var a13 = a[7];
    var a20 = a[8];
    var a21 = a[9];
    var a22 = a[10];
    var a23 = a[11];
    var a30 = a[12];
    var a31 = a[13];
    var a32 = a[14];
    var a33 = a[15];
    var b00 = b[0];
    var b01 = b[1];
    var b02 = b[2];
    var b03 = b[3];
    var b10 = b[4];
    var b11 = b[5];
    var b12 = b[6];
    var b13 = b[7];
    var b20 = b[8];
    var b21 = b[9];
    var b22 = b[10];
    var b23 = b[11];
    var b30 = b[12];
    var b31 = b[13];
    var b32 = b[14];
    var b33 = b[15];
    dest[0] = b00 * a00 + b01 * a10 + b02 * a20 + b03 * a30;
    dest[1] = b00 * a01 + b01 * a11 + b02 * a21 + b03 * a31;
    dest[2] = b00 * a02 + b01 * a12 + b02 * a22 + b03 * a32;
    dest[3] = b00 * a03 + b01 * a13 + b02 * a23 + b03 * a33;
    dest[4] = b10 * a00 + b11 * a10 + b12 * a20 + b13 * a30;
    dest[5] = b10 * a01 + b11 * a11 + b12 * a21 + b13 * a31;
    dest[6] = b10 * a02 + b11 * a12 + b12 * a22 + b13 * a32;
    dest[7] = b10 * a03 + b11 * a13 + b12 * a23 + b13 * a33;
    dest[8] = b20 * a00 + b21 * a10 + b22 * a20 + b23 * a30;
    dest[9] = b20 * a01 + b21 * a11 + b22 * a21 + b23 * a31;
    dest[10] = b20 * a02 + b21 * a12 + b22 * a22 + b23 * a32;
    dest[11] = b20 * a03 + b21 * a13 + b22 * a23 + b23 * a33;
    dest[12] = b30 * a00 + b31 * a10 + b32 * a20 + b33 * a30;
    dest[13] = b30 * a01 + b31 * a11 + b32 * a21 + b33 * a31;
    dest[14] = b30 * a02 + b31 * a12 + b32 * a22 + b33 * a32;
    dest[15] = b30 * a03 + b31 * a13 + b32 * a23 + b33 * a33;
    return dest;
  },

  /**
   * Multiplies the two given 3x3 matrices by each other.
   * @method mulMat4
   * @static
   */
  mulMat3: function mulMat3(a, b, dest) {
    if (!dest) {
      dest = new FloatArrayType(9);
    }

    var a11 = a[0];
    var a12 = a[3];
    var a13 = a[6];
    var a21 = a[1];
    var a22 = a[4];
    var a23 = a[7];
    var a31 = a[2];
    var a32 = a[5];
    var a33 = a[8];
    var b11 = b[0];
    var b12 = b[3];
    var b13 = b[6];
    var b21 = b[1];
    var b22 = b[4];
    var b23 = b[7];
    var b31 = b[2];
    var b32 = b[5];
    var b33 = b[8];
    dest[0] = a11 * b11 + a12 * b21 + a13 * b31;
    dest[3] = a11 * b12 + a12 * b22 + a13 * b32;
    dest[6] = a11 * b13 + a12 * b23 + a13 * b33;
    dest[1] = a21 * b11 + a22 * b21 + a23 * b31;
    dest[4] = a21 * b12 + a22 * b22 + a23 * b32;
    dest[7] = a21 * b13 + a22 * b23 + a23 * b33;
    dest[2] = a31 * b11 + a32 * b21 + a33 * b31;
    dest[5] = a31 * b12 + a32 * b22 + a33 * b32;
    dest[8] = a31 * b13 + a32 * b23 + a33 * b33;
    return dest;
  },

  /**
   * Multiplies each element of the given 4x4 matrix by the given scalar.
   * @method mulMat4Scalar
   * @static
   */
  mulMat4Scalar: function mulMat4Scalar(m, s, dest) {
    if (!dest) {
      dest = m;
    }

    dest[0] = m[0] * s;
    dest[1] = m[1] * s;
    dest[2] = m[2] * s;
    dest[3] = m[3] * s;
    dest[4] = m[4] * s;
    dest[5] = m[5] * s;
    dest[6] = m[6] * s;
    dest[7] = m[7] * s;
    dest[8] = m[8] * s;
    dest[9] = m[9] * s;
    dest[10] = m[10] * s;
    dest[11] = m[11] * s;
    dest[12] = m[12] * s;
    dest[13] = m[13] * s;
    dest[14] = m[14] * s;
    dest[15] = m[15] * s;
    return dest;
  },

  /**
   * Multiplies the given 4x4 matrix by the given four-element vector.
   * @method mulMat4v4
   * @static
   */
  mulMat4v4: function mulMat4v4(m, v) {
    var dest = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : math.vec4();
    var v0 = v[0];
    var v1 = v[1];
    var v2 = v[2];
    var v3 = v[3];
    dest[0] = m[0] * v0 + m[4] * v1 + m[8] * v2 + m[12] * v3;
    dest[1] = m[1] * v0 + m[5] * v1 + m[9] * v2 + m[13] * v3;
    dest[2] = m[2] * v0 + m[6] * v1 + m[10] * v2 + m[14] * v3;
    dest[3] = m[3] * v0 + m[7] * v1 + m[11] * v2 + m[15] * v3;
    return dest;
  },

  /**
   * Transposes the given 4x4 matrix.
   * @method transposeMat4
   * @static
   */
  transposeMat4: function transposeMat4(mat, dest) {
    // If we are transposing ourselves we can skip a few steps but have to cache some values
    var m4 = mat[4];
    var m14 = mat[14];
    var m8 = mat[8];
    var m13 = mat[13];
    var m12 = mat[12];
    var m9 = mat[9];

    if (!dest || mat === dest) {
      var a01 = mat[1];
      var a02 = mat[2];
      var a03 = mat[3];
      var a12 = mat[6];
      var a13 = mat[7];
      var a23 = mat[11];
      mat[1] = m4;
      mat[2] = m8;
      mat[3] = m12;
      mat[4] = a01;
      mat[6] = m9;
      mat[7] = m13;
      mat[8] = a02;
      mat[9] = a12;
      mat[11] = m14;
      mat[12] = a03;
      mat[13] = a13;
      mat[14] = a23;
      return mat;
    }

    dest[0] = mat[0];
    dest[1] = m4;
    dest[2] = m8;
    dest[3] = m12;
    dest[4] = mat[1];
    dest[5] = mat[5];
    dest[6] = m9;
    dest[7] = m13;
    dest[8] = mat[2];
    dest[9] = mat[6];
    dest[10] = mat[10];
    dest[11] = m14;
    dest[12] = mat[3];
    dest[13] = mat[7];
    dest[14] = mat[11];
    dest[15] = mat[15];
    return dest;
  },

  /**
   * Transposes the given 3x3 matrix.
   *
   * @method transposeMat3
   * @static
   */
  transposeMat3: function transposeMat3(mat, dest) {
    if (dest === mat) {
      var a01 = mat[1];
      var a02 = mat[2];
      var a12 = mat[5];
      dest[1] = mat[3];
      dest[2] = mat[6];
      dest[3] = a01;
      dest[5] = mat[7];
      dest[6] = a02;
      dest[7] = a12;
    } else {
      dest[0] = mat[0];
      dest[1] = mat[3];
      dest[2] = mat[6];
      dest[3] = mat[1];
      dest[4] = mat[4];
      dest[5] = mat[7];
      dest[6] = mat[2];
      dest[7] = mat[5];
      dest[8] = mat[8];
    }

    return dest;
  },

  /**
   * Returns the determinant of the given 4x4 matrix.
   * @method determinantMat4
   * @static
   */
  determinantMat4: function determinantMat4(mat) {
    // Cache the matrix values (makes for huge speed increases!)
    var a00 = mat[0];
    var a01 = mat[1];
    var a02 = mat[2];
    var a03 = mat[3];
    var a10 = mat[4];
    var a11 = mat[5];
    var a12 = mat[6];
    var a13 = mat[7];
    var a20 = mat[8];
    var a21 = mat[9];
    var a22 = mat[10];
    var a23 = mat[11];
    var a30 = mat[12];
    var a31 = mat[13];
    var a32 = mat[14];
    var a33 = mat[15];
    return a30 * a21 * a12 * a03 - a20 * a31 * a12 * a03 - a30 * a11 * a22 * a03 + a10 * a31 * a22 * a03 + a20 * a11 * a32 * a03 - a10 * a21 * a32 * a03 - a30 * a21 * a02 * a13 + a20 * a31 * a02 * a13 + a30 * a01 * a22 * a13 - a00 * a31 * a22 * a13 - a20 * a01 * a32 * a13 + a00 * a21 * a32 * a13 + a30 * a11 * a02 * a23 - a10 * a31 * a02 * a23 - a30 * a01 * a12 * a23 + a00 * a31 * a12 * a23 + a10 * a01 * a32 * a23 - a00 * a11 * a32 * a23 - a20 * a11 * a02 * a33 + a10 * a21 * a02 * a33 + a20 * a01 * a12 * a33 - a00 * a21 * a12 * a33 - a10 * a01 * a22 * a33 + a00 * a11 * a22 * a33;
  },

  /**
   * Returns the inverse of the given 4x4 matrix.
   * @method inverseMat4
   * @static
   */
  inverseMat4: function inverseMat4(mat, dest) {
    if (!dest) {
      dest = mat;
    } // Cache the matrix values (makes for huge speed increases!)


    var a00 = mat[0];
    var a01 = mat[1];
    var a02 = mat[2];
    var a03 = mat[3];
    var a10 = mat[4];
    var a11 = mat[5];
    var a12 = mat[6];
    var a13 = mat[7];
    var a20 = mat[8];
    var a21 = mat[9];
    var a22 = mat[10];
    var a23 = mat[11];
    var a30 = mat[12];
    var a31 = mat[13];
    var a32 = mat[14];
    var a33 = mat[15];
    var b00 = a00 * a11 - a01 * a10;
    var b01 = a00 * a12 - a02 * a10;
    var b02 = a00 * a13 - a03 * a10;
    var b03 = a01 * a12 - a02 * a11;
    var b04 = a01 * a13 - a03 * a11;
    var b05 = a02 * a13 - a03 * a12;
    var b06 = a20 * a31 - a21 * a30;
    var b07 = a20 * a32 - a22 * a30;
    var b08 = a20 * a33 - a23 * a30;
    var b09 = a21 * a32 - a22 * a31;
    var b10 = a21 * a33 - a23 * a31;
    var b11 = a22 * a33 - a23 * a32; // Calculate the determinant (inlined to avoid double-caching)

    var invDet = 1 / (b00 * b11 - b01 * b10 + b02 * b09 + b03 * b08 - b04 * b07 + b05 * b06);
    dest[0] = (a11 * b11 - a12 * b10 + a13 * b09) * invDet;
    dest[1] = (-a01 * b11 + a02 * b10 - a03 * b09) * invDet;
    dest[2] = (a31 * b05 - a32 * b04 + a33 * b03) * invDet;
    dest[3] = (-a21 * b05 + a22 * b04 - a23 * b03) * invDet;
    dest[4] = (-a10 * b11 + a12 * b08 - a13 * b07) * invDet;
    dest[5] = (a00 * b11 - a02 * b08 + a03 * b07) * invDet;
    dest[6] = (-a30 * b05 + a32 * b02 - a33 * b01) * invDet;
    dest[7] = (a20 * b05 - a22 * b02 + a23 * b01) * invDet;
    dest[8] = (a10 * b10 - a11 * b08 + a13 * b06) * invDet;
    dest[9] = (-a00 * b10 + a01 * b08 - a03 * b06) * invDet;
    dest[10] = (a30 * b04 - a31 * b02 + a33 * b00) * invDet;
    dest[11] = (-a20 * b04 + a21 * b02 - a23 * b00) * invDet;
    dest[12] = (-a10 * b09 + a11 * b07 - a12 * b06) * invDet;
    dest[13] = (a00 * b09 - a01 * b07 + a02 * b06) * invDet;
    dest[14] = (-a30 * b03 + a31 * b01 - a32 * b00) * invDet;
    dest[15] = (a20 * b03 - a21 * b01 + a22 * b00) * invDet;
    return dest;
  },

  /**
   * Returns the trace of the given 4x4 matrix.
   * @method traceMat4
   * @static
   */
  traceMat4: function traceMat4(m) {
    return m[0] + m[5] + m[10] + m[15];
  },

  /**
   * Returns 4x4 translation matrix.
   * @method translationMat4
   * @static
   */
  translationMat4v: function translationMat4v(v, dest) {
    var m = dest || math.identityMat4();
    m[12] = v[0];
    m[13] = v[1];
    m[14] = v[2];
    return m;
  },

  /**
   * Returns 3x3 translation matrix.
   * @method translationMat3
   * @static
   */
  translationMat3v: function translationMat3v(v, dest) {
    var m = dest || math.identityMat3();
    m[6] = v[0];
    m[7] = v[1];
    return m;
  },

  /**
   * Returns 4x4 translation matrix.
   * @method translationMat4c
   * @static
   */
  translationMat4c: function () {
    var xyz = new FloatArrayType(3);
    return function (x, y, z, dest) {
      xyz[0] = x;
      xyz[1] = y;
      xyz[2] = z;
      return math.translationMat4v(xyz, dest);
    };
  }(),

  /**
   * Returns 4x4 translation matrix.
   * @method translationMat4s
   * @static
   */
  translationMat4s: function translationMat4s(s, dest) {
    return math.translationMat4c(s, s, s, dest);
  },

  /**
   * Efficiently post-concatenates a translation to the given matrix.
   * @param v
   * @param m
   */
  translateMat4v: function translateMat4v(xyz, m) {
    return math.translateMat4c(xyz[0], xyz[1], xyz[2], m);
  },

  /**
   * Efficiently post-concatenates a translation to the given matrix.
   * @param x
   * @param y
   * @param z
   * @param m
   */
  translateMat4c: function translateMat4c(x, y, z, m) {
    var m3 = m[3];
    m[0] += m3 * x;
    m[1] += m3 * y;
    m[2] += m3 * z;
    var m7 = m[7];
    m[4] += m7 * x;
    m[5] += m7 * y;
    m[6] += m7 * z;
    var m11 = m[11];
    m[8] += m11 * x;
    m[9] += m11 * y;
    m[10] += m11 * z;
    var m15 = m[15];
    m[12] += m15 * x;
    m[13] += m15 * y;
    m[14] += m15 * z;
    return m;
  },

  /**
   * Creates a new matrix that replaces the translation in the rightmost column of the given
   * affine matrix with the given translation.
   * @param m
   * @param translation
   * @param dest
   * @returns {*}
   */
  setMat4Translation: function setMat4Translation(m, translation, dest) {
    dest[0] = m[0];
    dest[1] = m[1];
    dest[2] = m[2];
    dest[3] = m[3];
    dest[4] = m[4];
    dest[5] = m[5];
    dest[6] = m[6];
    dest[7] = m[7];
    dest[8] = m[8];
    dest[9] = m[9];
    dest[10] = m[10];
    dest[11] = m[11];
    dest[12] = translation[0];
    dest[13] = translation[1];
    dest[14] = translation[2];
    dest[15] = m[15];
    return dest;
  },

  /**
   * Returns 4x4 rotation matrix.
   * @method rotationMat4v
   * @static
   */
  rotationMat4v: function rotationMat4v(anglerad, axis, m) {
    var ax = math.normalizeVec4([axis[0], axis[1], axis[2], 0.0], []);
    var s = Math.sin(anglerad);
    var c = Math.cos(anglerad);
    var q = 1.0 - c;
    var x = ax[0];
    var y = ax[1];
    var z = ax[2];
    var xy;
    var yz;
    var zx;
    var xs;
    var ys;
    var zs; //xx = x * x; used once
    //yy = y * y; used once
    //zz = z * z; used once

    xy = x * y;
    yz = y * z;
    zx = z * x;
    xs = x * s;
    ys = y * s;
    zs = z * s;
    m = m || math.mat4();
    m[0] = q * x * x + c;
    m[1] = q * xy + zs;
    m[2] = q * zx - ys;
    m[3] = 0.0;
    m[4] = q * xy - zs;
    m[5] = q * y * y + c;
    m[6] = q * yz + xs;
    m[7] = 0.0;
    m[8] = q * zx + ys;
    m[9] = q * yz - xs;
    m[10] = q * z * z + c;
    m[11] = 0.0;
    m[12] = 0.0;
    m[13] = 0.0;
    m[14] = 0.0;
    m[15] = 1.0;
    return m;
  },

  /**
   * Returns 4x4 rotation matrix.
   * @method rotationMat4c
   * @static
   */
  rotationMat4c: function rotationMat4c(anglerad, x, y, z, mat) {
    return math.rotationMat4v(anglerad, [x, y, z], mat);
  },

  /**
   * Returns 4x4 scale matrix.
   * @method scalingMat4v
   * @static
   */
  scalingMat4v: function scalingMat4v(v) {
    var m = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : math.identityMat4();
    m[0] = v[0];
    m[5] = v[1];
    m[10] = v[2];
    return m;
  },

  /**
   * Returns 3x3 scale matrix.
   * @method scalingMat3v
   * @static
   */
  scalingMat3v: function scalingMat3v(v) {
    var m = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : math.identityMat3();
    m[0] = v[0];
    m[4] = v[1];
    return m;
  },

  /**
   * Returns 4x4 scale matrix.
   * @method scalingMat4c
   * @static
   */
  scalingMat4c: function () {
    var xyz = new FloatArrayType(3);
    return function (x, y, z, dest) {
      xyz[0] = x;
      xyz[1] = y;
      xyz[2] = z;
      return math.scalingMat4v(xyz, dest);
    };
  }(),

  /**
   * Efficiently post-concatenates a scaling to the given matrix.
   * @method scaleMat4c
   * @param x
   * @param y
   * @param z
   * @param m
   */
  scaleMat4c: function scaleMat4c(x, y, z, m) {
    m[0] *= x;
    m[4] *= y;
    m[8] *= z;
    m[1] *= x;
    m[5] *= y;
    m[9] *= z;
    m[2] *= x;
    m[6] *= y;
    m[10] *= z;
    m[3] *= x;
    m[7] *= y;
    m[11] *= z;
    return m;
  },

  /**
   * Efficiently post-concatenates a scaling to the given matrix.
   * @method scaleMat4c
   * @param xyz
   * @param m
   */
  scaleMat4v: function scaleMat4v(xyz, m) {
    var x = xyz[0];
    var y = xyz[1];
    var z = xyz[2];
    m[0] *= x;
    m[4] *= y;
    m[8] *= z;
    m[1] *= x;
    m[5] *= y;
    m[9] *= z;
    m[2] *= x;
    m[6] *= y;
    m[10] *= z;
    m[3] *= x;
    m[7] *= y;
    m[11] *= z;
    return m;
  },

  /**
   * Returns 4x4 scale matrix.
   * @method scalingMat4s
   * @static
   */
  scalingMat4s: function scalingMat4s(s) {
    return math.scalingMat4c(s, s, s);
  },

  /**
   * Creates a matrix from a quaternion rotation and vector translation
   *
   * @param {Number[]} q Rotation quaternion
   * @param {Number[]} v Translation vector
   * @param {Number[]} dest Destination matrix
   * @returns {Number[]} dest
   */
  rotationTranslationMat4: function rotationTranslationMat4(q, v) {
    var dest = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : math.mat4();
    var x = q[0];
    var y = q[1];
    var z = q[2];
    var w = q[3];
    var x2 = x + x;
    var y2 = y + y;
    var z2 = z + z;
    var xx = x * x2;
    var xy = x * y2;
    var xz = x * z2;
    var yy = y * y2;
    var yz = y * z2;
    var zz = z * z2;
    var wx = w * x2;
    var wy = w * y2;
    var wz = w * z2;
    dest[0] = 1 - (yy + zz);
    dest[1] = xy + wz;
    dest[2] = xz - wy;
    dest[3] = 0;
    dest[4] = xy - wz;
    dest[5] = 1 - (xx + zz);
    dest[6] = yz + wx;
    dest[7] = 0;
    dest[8] = xz + wy;
    dest[9] = yz - wx;
    dest[10] = 1 - (xx + yy);
    dest[11] = 0;
    dest[12] = v[0];
    dest[13] = v[1];
    dest[14] = v[2];
    dest[15] = 1;
    return dest;
  },

  /**
   * Gets Euler angles from a 4x4 matrix.
   *
   * @param {Number[]} mat The 4x4 matrix.
   * @param {String} order Desired Euler angle order: "XYZ", "YXZ", "ZXY" etc.
   * @param {Number[]} [dest] Destination Euler angles, created by default.
   * @returns {Number[]} The Euler angles.
   */
  mat4ToEuler: function mat4ToEuler(mat, order) {
    var dest = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : math.vec4();
    var clamp = math.clamp; // Assumes the upper 3x3 of m is a pure rotation matrix (i.e, unscaled)

    var m11 = mat[0];
    var m12 = mat[4];
    var m13 = mat[8];
    var m21 = mat[1];
    var m22 = mat[5];
    var m23 = mat[9];
    var m31 = mat[2];
    var m32 = mat[6];
    var m33 = mat[10];

    if (order === 'XYZ') {
      dest[1] = Math.asin(clamp(m13, -1, 1));

      if (Math.abs(m13) < 0.99999) {
        dest[0] = Math.atan2(-m23, m33);
        dest[2] = Math.atan2(-m12, m11);
      } else {
        dest[0] = Math.atan2(m32, m22);
        dest[2] = 0;
      }
    } else if (order === 'YXZ') {
      dest[0] = Math.asin(-clamp(m23, -1, 1));

      if (Math.abs(m23) < 0.99999) {
        dest[1] = Math.atan2(m13, m33);
        dest[2] = Math.atan2(m21, m22);
      } else {
        dest[1] = Math.atan2(-m31, m11);
        dest[2] = 0;
      }
    } else if (order === 'ZXY') {
      dest[0] = Math.asin(clamp(m32, -1, 1));

      if (Math.abs(m32) < 0.99999) {
        dest[1] = Math.atan2(-m31, m33);
        dest[2] = Math.atan2(-m12, m22);
      } else {
        dest[1] = 0;
        dest[2] = Math.atan2(m21, m11);
      }
    } else if (order === 'ZYX') {
      dest[1] = Math.asin(-clamp(m31, -1, 1));

      if (Math.abs(m31) < 0.99999) {
        dest[0] = Math.atan2(m32, m33);
        dest[2] = Math.atan2(m21, m11);
      } else {
        dest[0] = 0;
        dest[2] = Math.atan2(-m12, m22);
      }
    } else if (order === 'YZX') {
      dest[2] = Math.asin(clamp(m21, -1, 1));

      if (Math.abs(m21) < 0.99999) {
        dest[0] = Math.atan2(-m23, m22);
        dest[1] = Math.atan2(-m31, m11);
      } else {
        dest[0] = 0;
        dest[1] = Math.atan2(m13, m33);
      }
    } else if (order === 'XZY') {
      dest[2] = Math.asin(-clamp(m12, -1, 1));

      if (Math.abs(m12) < 0.99999) {
        dest[0] = Math.atan2(m32, m22);
        dest[1] = Math.atan2(m13, m11);
      } else {
        dest[0] = Math.atan2(-m23, m33);
        dest[1] = 0;
      }
    }

    return dest;
  },
  composeMat4: function composeMat4(position, quaternion, scale) {
    var mat = arguments.length > 3 && arguments[3] !== undefined ? arguments[3] : math.mat4();
    math.quaternionToRotationMat4(quaternion, mat);
    math.scaleMat4v(scale, mat);
    math.translateMat4v(position, mat);
    return mat;
  },
  decomposeMat4: function () {
    var vec = new FloatArrayType(3);
    var matrix = new FloatArrayType(16);
    return function decompose(mat, position, quaternion, scale) {
      vec[0] = mat[0];
      vec[1] = mat[1];
      vec[2] = mat[2];
      var sx = math.lenVec3(vec);
      vec[0] = mat[4];
      vec[1] = mat[5];
      vec[2] = mat[6];
      var sy = math.lenVec3(vec);
      vec[8] = mat[8];
      vec[9] = mat[9];
      vec[10] = mat[10];
      var sz = math.lenVec3(vec); // if determine is negative, we need to invert one scale

      var det = math.determinantMat4(mat);

      if (det < 0) {
        sx = -sx;
      }

      position[0] = mat[12];
      position[1] = mat[13];
      position[2] = mat[14]; // scale the rotation part

      matrix.set(mat);
      var invSX = 1 / sx;
      var invSY = 1 / sy;
      var invSZ = 1 / sz;
      matrix[0] *= invSX;
      matrix[1] *= invSX;
      matrix[2] *= invSX;
      matrix[4] *= invSY;
      matrix[5] *= invSY;
      matrix[6] *= invSY;
      matrix[8] *= invSZ;
      matrix[9] *= invSZ;
      matrix[10] *= invSZ;
      math.mat4ToQuaternion(matrix, quaternion);
      scale[0] = sx;
      scale[1] = sy;
      scale[2] = sz;
      return this;
    };
  }(),

  /** @private */
  getColMat4: function getColMat4(mat, c) {
    var i = c * 4;
    return [mat[i], mat[i + 1], mat[i + 2], mat[i + 3]];
  },

  /** @private */
  setRowMat4: function setRowMat4(mat, r, v) {
    mat[r] = v[0];
    mat[r + 4] = v[1];
    mat[r + 8] = v[2];
    mat[r + 12] = v[3];
  },

  /**
   * Returns a 4x4 'lookat' viewing transform matrix.
   * @method lookAtMat4v
   * @param pos vec3 position of the viewer
   * @param target vec3 point the viewer is looking at
   * @param up vec3 pointing "up"
   * @param dest mat4 Optional, mat4 matrix will be written into
   *
   * @return {mat4} dest if specified, a new mat4 otherwise
   */
  lookAtMat4v: function lookAtMat4v(pos, target, up, dest) {
    if (!dest) {
      dest = math.mat4();
    }

    var posx = pos[0];
    var posy = pos[1];
    var posz = pos[2];
    var upx = up[0];
    var upy = up[1];
    var upz = up[2];
    var targetx = target[0];
    var targety = target[1];
    var targetz = target[2];

    if (posx === targetx && posy === targety && posz === targetz) {
      return math.identityMat4();
    }

    var z0;
    var z1;
    var z2;
    var x0;
    var x1;
    var x2;
    var y0;
    var y1;
    var y2;
    var len; //vec3.direction(eye, center, z);

    z0 = posx - targetx;
    z1 = posy - targety;
    z2 = posz - targetz; // normalize (no check needed for 0 because of early return)

    len = 1 / Math.sqrt(z0 * z0 + z1 * z1 + z2 * z2);
    z0 *= len;
    z1 *= len;
    z2 *= len; //vec3.normalize(vec3.cross(up, z, x));

    x0 = upy * z2 - upz * z1;
    x1 = upz * z0 - upx * z2;
    x2 = upx * z1 - upy * z0;
    len = Math.sqrt(x0 * x0 + x1 * x1 + x2 * x2);

    if (!len) {
      x0 = 0;
      x1 = 0;
      x2 = 0;
    } else {
      len = 1 / len;
      x0 *= len;
      x1 *= len;
      x2 *= len;
    } //vec3.normalize(vec3.cross(z, x, y));


    y0 = z1 * x2 - z2 * x1;
    y1 = z2 * x0 - z0 * x2;
    y2 = z0 * x1 - z1 * x0;
    len = Math.sqrt(y0 * y0 + y1 * y1 + y2 * y2);

    if (!len) {
      y0 = 0;
      y1 = 0;
      y2 = 0;
    } else {
      len = 1 / len;
      y0 *= len;
      y1 *= len;
      y2 *= len;
    }

    dest[0] = x0;
    dest[1] = y0;
    dest[2] = z0;
    dest[3] = 0;
    dest[4] = x1;
    dest[5] = y1;
    dest[6] = z1;
    dest[7] = 0;
    dest[8] = x2;
    dest[9] = y2;
    dest[10] = z2;
    dest[11] = 0;
    dest[12] = -(x0 * posx + x1 * posy + x2 * posz);
    dest[13] = -(y0 * posx + y1 * posy + y2 * posz);
    dest[14] = -(z0 * posx + z1 * posy + z2 * posz);
    dest[15] = 1;
    return dest;
  },

  /**
   * Returns a 4x4 'lookat' viewing transform matrix.
   * @method lookAtMat4c
   * @static
   */
  lookAtMat4c: function lookAtMat4c(posx, posy, posz, targetx, targety, targetz, upx, upy, upz) {
    return math.lookAtMat4v([posx, posy, posz], [targetx, targety, targetz], [upx, upy, upz], []);
  },

  /**
   * Returns a 4x4 orthographic projection matrix.
   * @method orthoMat4c
   * @static
   */
  orthoMat4c: function orthoMat4c(left, right, bottom, top, near, far, dest) {
    if (!dest) {
      dest = math.mat4();
    }

    var rl = right - left;
    var tb = top - bottom;
    var fn = far - near;
    dest[0] = 2.0 / rl;
    dest[1] = 0.0;
    dest[2] = 0.0;
    dest[3] = 0.0;
    dest[4] = 0.0;
    dest[5] = 2.0 / tb;
    dest[6] = 0.0;
    dest[7] = 0.0;
    dest[8] = 0.0;
    dest[9] = 0.0;
    dest[10] = -2.0 / fn;
    dest[11] = 0.0;
    dest[12] = -(left + right) / rl;
    dest[13] = -(top + bottom) / tb;
    dest[14] = -(far + near) / fn;
    dest[15] = 1.0;
    return dest;
  },

  /**
   * Returns a 4x4 perspective projection matrix.
   * @method frustumMat4v
   * @static
   */
  frustumMat4v: function frustumMat4v(fmin, fmax, m) {
    if (!m) {
      m = math.mat4();
    }

    var fmin4 = [fmin[0], fmin[1], fmin[2], 0.0];
    var fmax4 = [fmax[0], fmax[1], fmax[2], 0.0];
    math.addVec4(fmax4, fmin4, tempMat1);
    math.subVec4(fmax4, fmin4, tempMat2);
    var t = 2.0 * fmin4[2];
    var tempMat20 = tempMat2[0];
    var tempMat21 = tempMat2[1];
    var tempMat22 = tempMat2[2];
    m[0] = t / tempMat20;
    m[1] = 0.0;
    m[2] = 0.0;
    m[3] = 0.0;
    m[4] = 0.0;
    m[5] = t / tempMat21;
    m[6] = 0.0;
    m[7] = 0.0;
    m[8] = tempMat1[0] / tempMat20;
    m[9] = tempMat1[1] / tempMat21;
    m[10] = -tempMat1[2] / tempMat22;
    m[11] = -1.0;
    m[12] = 0.0;
    m[13] = 0.0;
    m[14] = -t * fmax4[2] / tempMat22;
    m[15] = 0.0;
    return m;
  },

  /**
   * Returns a 4x4 perspective projection matrix.
   * @method frustumMat4v
   * @static
   */
  frustumMat4: function frustumMat4(left, right, bottom, top, near, far, dest) {
    if (!dest) {
      dest = math.mat4();
    }

    var rl = right - left;
    var tb = top - bottom;
    var fn = far - near;
    dest[0] = near * 2 / rl;
    dest[1] = 0;
    dest[2] = 0;
    dest[3] = 0;
    dest[4] = 0;
    dest[5] = near * 2 / tb;
    dest[6] = 0;
    dest[7] = 0;
    dest[8] = (right + left) / rl;
    dest[9] = (top + bottom) / tb;
    dest[10] = -(far + near) / fn;
    dest[11] = -1;
    dest[12] = 0;
    dest[13] = 0;
    dest[14] = -(far * near * 2) / fn;
    dest[15] = 0;
    return dest;
  },

  /**
   * Returns a 4x4 perspective projection matrix.
   * @method perspectiveMat4v
   * @static
   */
  perspectiveMat4: function perspectiveMat4(fovyrad, aspectratio, znear, zfar, m) {
    var pmin = [];
    var pmax = [];
    pmin[2] = znear;
    pmax[2] = zfar;
    pmax[1] = pmin[2] * Math.tan(fovyrad / 2.0);
    pmin[1] = -pmax[1];
    pmax[0] = pmax[1] * aspectratio;
    pmin[0] = -pmax[0];
    return math.frustumMat4v(pmin, pmax, m);
  },

  /**
   * Returns true if the two 4x4 matrices are the same.
   * @param m1
   * @param m2
   * @returns {Boolean}
   */
  compareMat4: function compareMat4(m1, m2) {
    return m1[0] === m2[0] && m1[1] === m2[1] && m1[2] === m2[2] && m1[3] === m2[3] && m1[4] === m2[4] && m1[5] === m2[5] && m1[6] === m2[6] && m1[7] === m2[7] && m1[8] === m2[8] && m1[9] === m2[9] && m1[10] === m2[10] && m1[11] === m2[11] && m1[12] === m2[12] && m1[13] === m2[13] && m1[14] === m2[14] && m1[15] === m2[15];
  },

  /**
   * Transforms a three-element position by a 4x4 matrix.
   * @method transformPoint3
   * @static
   */
  transformPoint3: function transformPoint3(m, p) {
    var dest = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : math.vec3();
    var x = p[0];
    var y = p[1];
    var z = p[2];
    dest[0] = m[0] * x + m[4] * y + m[8] * z + m[12];
    dest[1] = m[1] * x + m[5] * y + m[9] * z + m[13];
    dest[2] = m[2] * x + m[6] * y + m[10] * z + m[14];
    return dest;
  },

  /**
   * Transforms a homogeneous coordinate by a 4x4 matrix.
   * @method transformPoint3
   * @static
   */
  transformPoint4: function transformPoint4(m, v) {
    var dest = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : math.vec4();
    dest[0] = m[0] * v[0] + m[4] * v[1] + m[8] * v[2] + m[12] * v[3];
    dest[1] = m[1] * v[0] + m[5] * v[1] + m[9] * v[2] + m[13] * v[3];
    dest[2] = m[2] * v[0] + m[6] * v[1] + m[10] * v[2] + m[14] * v[3];
    dest[3] = m[3] * v[0] + m[7] * v[1] + m[11] * v[2] + m[15] * v[3];
    return dest;
  },

  /**
   * Transforms an array of three-element positions by a 4x4 matrix.
   * @method transformPoints3
   * @static
   */
  transformPoints3: function transformPoints3(m, points, points2) {
    var result = points2 || [];
    var len = points.length;
    var p0;
    var p1;
    var p2;
    var pi; // cache values

    var m0 = m[0];
    var m1 = m[1];
    var m2 = m[2];
    var m3 = m[3];
    var m4 = m[4];
    var m5 = m[5];
    var m6 = m[6];
    var m7 = m[7];
    var m8 = m[8];
    var m9 = m[9];
    var m10 = m[10];
    var m11 = m[11];
    var m12 = m[12];
    var m13 = m[13];
    var m14 = m[14];
    var m15 = m[15];
    var r;

    for (var i = 0; i < len; ++i) {
      // cache values
      pi = points[i];
      p0 = pi[0];
      p1 = pi[1];
      p2 = pi[2];
      r = result[i] || (result[i] = [0, 0, 0]);
      r[0] = m0 * p0 + m4 * p1 + m8 * p2 + m12;
      r[1] = m1 * p0 + m5 * p1 + m9 * p2 + m13;
      r[2] = m2 * p0 + m6 * p1 + m10 * p2 + m14;
      r[3] = m3 * p0 + m7 * p1 + m11 * p2 + m15;
    }

    result.length = len;
    return result;
  },

  /**
   * Transforms an array of positions by a 4x4 matrix.
   * @method transformPositions3
   * @static
   */
  transformPositions3: function transformPositions3(m, p) {
    var p2 = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : p;
    var i;
    var len = p.length;
    var x;
    var y;
    var z;
    var m0 = m[0];
    var m1 = m[1];
    var m2 = m[2];
    m[3];
    var m4 = m[4];
    var m5 = m[5];
    var m6 = m[6];
    m[7];
    var m8 = m[8];
    var m9 = m[9];
    var m10 = m[10];
    m[11];
    var m12 = m[12];
    var m13 = m[13];
    var m14 = m[14];
    m[15];

    for (i = 0; i < len; i += 3) {
      x = p[i + 0];
      y = p[i + 1];
      z = p[i + 2];
      p2[i + 0] = m0 * x + m4 * y + m8 * z + m12;
      p2[i + 1] = m1 * x + m5 * y + m9 * z + m13;
      p2[i + 2] = m2 * x + m6 * y + m10 * z + m14;
    }

    return p2;
  },

  /**
   * Transforms an array of positions by a 4x4 matrix.
   * @method transformPositions4
   * @static
   */
  transformPositions4: function transformPositions4(m, p) {
    var p2 = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : p;
    var i;
    var len = p.length;
    var x;
    var y;
    var z;
    var m0 = m[0];
    var m1 = m[1];
    var m2 = m[2];
    var m3 = m[3];
    var m4 = m[4];
    var m5 = m[5];
    var m6 = m[6];
    var m7 = m[7];
    var m8 = m[8];
    var m9 = m[9];
    var m10 = m[10];
    var m11 = m[11];
    var m12 = m[12];
    var m13 = m[13];
    var m14 = m[14];
    var m15 = m[15];

    for (i = 0; i < len; i += 4) {
      x = p[i + 0];
      y = p[i + 1];
      z = p[i + 2];
      p2[i + 0] = m0 * x + m4 * y + m8 * z + m12;
      p2[i + 1] = m1 * x + m5 * y + m9 * z + m13;
      p2[i + 2] = m2 * x + m6 * y + m10 * z + m14;
      p2[i + 3] = m3 * x + m7 * y + m11 * z + m15;
    }

    return p2;
  },

  /**
   * Transforms a three-element vector by a 4x4 matrix.
   * @method transformVec3
   * @static
   */
  transformVec3: function transformVec3(m, v, dest) {
    var v0 = v[0];
    var v1 = v[1];
    var v2 = v[2];
    dest = dest || this.vec3();
    dest[0] = m[0] * v0 + m[4] * v1 + m[8] * v2;
    dest[1] = m[1] * v0 + m[5] * v1 + m[9] * v2;
    dest[2] = m[2] * v0 + m[6] * v1 + m[10] * v2;
    return dest;
  },

  /**
   * Transforms a four-element vector by a 4x4 matrix.
   * @method transformVec4
   * @static
   */
  transformVec4: function transformVec4(m, v, dest) {
    var v0 = v[0];
    var v1 = v[1];
    var v2 = v[2];
    var v3 = v[3];
    dest = dest || math.vec4();
    dest[0] = m[0] * v0 + m[4] * v1 + m[8] * v2 + m[12] * v3;
    dest[1] = m[1] * v0 + m[5] * v1 + m[9] * v2 + m[13] * v3;
    dest[2] = m[2] * v0 + m[6] * v1 + m[10] * v2 + m[14] * v3;
    dest[3] = m[3] * v0 + m[7] * v1 + m[11] * v2 + m[15] * v3;
    return dest;
  },

  /**
   * Rotate a 2D vector around a center point.
   *
   * @param a
   * @param center
   * @param angle
   * @returns {math}
   */
  rotateVec2: function rotateVec2(a, center, angle) {
    var dest = arguments.length > 3 && arguments[3] !== undefined ? arguments[3] : a;
    var c = Math.cos(angle);
    var s = Math.sin(angle);
    var x = a[0] - center[0];
    var y = a[1] - center[1];
    dest[0] = x * c - y * s + center[0];
    dest[1] = x * s + y * c + center[1];
    return a;
  },

  /**
   * Rotate a 3D vector around the x-axis
   *
   * @method rotateVec3X
   * @param {Number[]} a The vec3 point to rotate
   * @param {Number[]} b The origin of the rotation
   * @param {Number} c The angle of rotation
   * @param {Number[]} dest The receiving vec3
   * @returns {Number[]} dest
   * @static
   */
  rotateVec3X: function rotateVec3X(a, b, c, dest) {
    var p = [];
    var r = []; //Translate point to the origin

    p[0] = a[0] - b[0];
    p[1] = a[1] - b[1];
    p[2] = a[2] - b[2]; //perform rotation

    r[0] = p[0];
    r[1] = p[1] * Math.cos(c) - p[2] * Math.sin(c);
    r[2] = p[1] * Math.sin(c) + p[2] * Math.cos(c); //translate to correct position

    dest[0] = r[0] + b[0];
    dest[1] = r[1] + b[1];
    dest[2] = r[2] + b[2];
    return dest;
  },

  /**
   * Rotate a 3D vector around the y-axis
   *
   * @method rotateVec3Y
   * @param {Number[]} a The vec3 point to rotate
   * @param {Number[]} b The origin of the rotation
   * @param {Number} c The angle of rotation
   * @param {Number[]} dest The receiving vec3
   * @returns {Number[]} dest
   * @static
   */
  rotateVec3Y: function rotateVec3Y(a, b, c, dest) {
    var p = [];
    var r = []; //Translate point to the origin

    p[0] = a[0] - b[0];
    p[1] = a[1] - b[1];
    p[2] = a[2] - b[2]; //perform rotation

    r[0] = p[2] * Math.sin(c) + p[0] * Math.cos(c);
    r[1] = p[1];
    r[2] = p[2] * Math.cos(c) - p[0] * Math.sin(c); //translate to correct position

    dest[0] = r[0] + b[0];
    dest[1] = r[1] + b[1];
    dest[2] = r[2] + b[2];
    return dest;
  },

  /**
   * Rotate a 3D vector around the z-axis
   *
   * @method rotateVec3Z
   * @param {Number[]} a The vec3 point to rotate
   * @param {Number[]} b The origin of the rotation
   * @param {Number} c The angle of rotation
   * @param {Number[]} dest The receiving vec3
   * @returns {Number[]} dest
   * @static
   */
  rotateVec3Z: function rotateVec3Z(a, b, c, dest) {
    var p = [];
    var r = []; //Translate point to the origin

    p[0] = a[0] - b[0];
    p[1] = a[1] - b[1];
    p[2] = a[2] - b[2]; //perform rotation

    r[0] = p[0] * Math.cos(c) - p[1] * Math.sin(c);
    r[1] = p[0] * Math.sin(c) + p[1] * Math.cos(c);
    r[2] = p[2]; //translate to correct position

    dest[0] = r[0] + b[0];
    dest[1] = r[1] + b[1];
    dest[2] = r[2] + b[2];
    return dest;
  },

  /**
   * Transforms a four-element vector by a 4x4 projection matrix.
   *
   * @method projectVec4
   * @param {Number[]} p 3D View-space coordinate
   * @param {Number[]} q 2D Projected coordinate
   * @returns {Number[]} 2D Projected coordinate
   * @static
   */
  projectVec4: function projectVec4(p, q) {
    var f = 1.0 / p[3];
    q = q || math.vec2();
    q[0] = p[0] * f;
    q[1] = p[1] * f;
    return q;
  },

  /**
   * Unprojects a three-element vector.
   *
   * @method unprojectVec3
   * @param {Number[]} p 3D Projected coordinate
   * @param {Number[]} viewMat View matrix
   * @returns {Number[]} projMat Projection matrix
   * @static
   */
  unprojectVec3: function () {
    var mat = new FloatArrayType(16);
    var mat2 = new FloatArrayType(16);
    var mat3 = new FloatArrayType(16);
    return function (p, viewMat, projMat, q) {
      return this.transformVec3(this.mulMat4(this.inverseMat4(viewMat, mat), this.inverseMat4(projMat, mat2), mat3), p, q);
    };
  }(),

  /**
   * Linearly interpolates between two 3D vectors.
   * @method lerpVec3
   * @static
   */
  lerpVec3: function lerpVec3(t, t1, t2, p1, p2, dest) {
    var result = dest || math.vec3();
    var f = (t - t1) / (t2 - t1);
    result[0] = p1[0] + f * (p2[0] - p1[0]);
    result[1] = p1[1] + f * (p2[1] - p1[1]);
    result[2] = p1[2] + f * (p2[2] - p1[2]);
    return result;
  },

  /**
   * Linearly interpolates between two 4x4 matrices.
   * @method lerpMat4
   * @static
   */
  lerpMat4: function lerpMat4(t, t1, t2, m1, m2, dest) {
    var result = dest || math.mat4();
    var f = (t - t1) / (t2 - t1);
    result[0] = m1[0] + f * (m2[0] - m1[0]);
    result[1] = m1[1] + f * (m2[1] - m1[1]);
    result[2] = m1[2] + f * (m2[2] - m1[2]);
    result[3] = m1[3] + f * (m2[3] - m1[3]);
    result[4] = m1[4] + f * (m2[4] - m1[4]);
    result[5] = m1[5] + f * (m2[5] - m1[5]);
    result[6] = m1[6] + f * (m2[6] - m1[6]);
    result[7] = m1[7] + f * (m2[7] - m1[7]);
    result[8] = m1[8] + f * (m2[8] - m1[8]);
    result[9] = m1[9] + f * (m2[9] - m1[9]);
    result[10] = m1[10] + f * (m2[10] - m1[10]);
    result[11] = m1[11] + f * (m2[11] - m1[11]);
    result[12] = m1[12] + f * (m2[12] - m1[12]);
    result[13] = m1[13] + f * (m2[13] - m1[13]);
    result[14] = m1[14] + f * (m2[14] - m1[14]);
    result[15] = m1[15] + f * (m2[15] - m1[15]);
    return result;
  },

  /**
   * Flattens a two-dimensional array into a one-dimensional array.
   *
   * @method flatten
   * @static
   * @param {Array of Arrays} a A 2D array
   * @returns Flattened 1D array
   */
  flatten: function flatten(a) {
    var result = [];
    var i;
    var leni;
    var j;
    var lenj;
    var item;

    for (i = 0, leni = a.length; i < leni; i++) {
      item = a[i];

      for (j = 0, lenj = item.length; j < lenj; j++) {
        result.push(item[j]);
      }
    }

    return result;
  },
  identityQuaternion: function identityQuaternion() {
    var dest = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : math.vec4();
    dest[0] = 0.0;
    dest[1] = 0.0;
    dest[2] = 0.0;
    dest[3] = 1.0;
    return dest;
  },

  /**
   * Initializes a quaternion from Euler angles.
   *
   * @param {Number[]} euler The Euler angles.
   * @param {String} order Euler angle order: "XYZ", "YXZ", "ZXY" etc.
   * @param {Number[]} [dest] Destination quaternion, created by default.
   * @returns {Number[]} The quaternion.
   */
  eulerToQuaternion: function eulerToQuaternion(euler, order) {
    var dest = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : math.vec4();
    // http://www.mathworks.com/matlabcentral/fileexchange/
    // 	20696-function-to-convert-between-dcm-euler-angles-quaternions-and-euler-vectors/
    //	content/SpinCalc.m
    var a = euler[0] * math.DEGTORAD / 2;
    var b = euler[1] * math.DEGTORAD / 2;
    var c = euler[2] * math.DEGTORAD / 2;
    var c1 = Math.cos(a);
    var c2 = Math.cos(b);
    var c3 = Math.cos(c);
    var s1 = Math.sin(a);
    var s2 = Math.sin(b);
    var s3 = Math.sin(c);

    if (order === 'XYZ') {
      dest[0] = s1 * c2 * c3 + c1 * s2 * s3;
      dest[1] = c1 * s2 * c3 - s1 * c2 * s3;
      dest[2] = c1 * c2 * s3 + s1 * s2 * c3;
      dest[3] = c1 * c2 * c3 - s1 * s2 * s3;
    } else if (order === 'YXZ') {
      dest[0] = s1 * c2 * c3 + c1 * s2 * s3;
      dest[1] = c1 * s2 * c3 - s1 * c2 * s3;
      dest[2] = c1 * c2 * s3 - s1 * s2 * c3;
      dest[3] = c1 * c2 * c3 + s1 * s2 * s3;
    } else if (order === 'ZXY') {
      dest[0] = s1 * c2 * c3 - c1 * s2 * s3;
      dest[1] = c1 * s2 * c3 + s1 * c2 * s3;
      dest[2] = c1 * c2 * s3 + s1 * s2 * c3;
      dest[3] = c1 * c2 * c3 - s1 * s2 * s3;
    } else if (order === 'ZYX') {
      dest[0] = s1 * c2 * c3 - c1 * s2 * s3;
      dest[1] = c1 * s2 * c3 + s1 * c2 * s3;
      dest[2] = c1 * c2 * s3 - s1 * s2 * c3;
      dest[3] = c1 * c2 * c3 + s1 * s2 * s3;
    } else if (order === 'YZX') {
      dest[0] = s1 * c2 * c3 + c1 * s2 * s3;
      dest[1] = c1 * s2 * c3 + s1 * c2 * s3;
      dest[2] = c1 * c2 * s3 - s1 * s2 * c3;
      dest[3] = c1 * c2 * c3 - s1 * s2 * s3;
    } else if (order === 'XZY') {
      dest[0] = s1 * c2 * c3 - c1 * s2 * s3;
      dest[1] = c1 * s2 * c3 - s1 * c2 * s3;
      dest[2] = c1 * c2 * s3 + s1 * s2 * c3;
      dest[3] = c1 * c2 * c3 + s1 * s2 * s3;
    }

    return dest;
  },
  mat4ToQuaternion: function mat4ToQuaternion(m) {
    var dest = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : math.vec4();
    // http://www.euclideanspace.com/maths/geometry/rotations/conversions/matrixToQuaternion/index.htm
    // Assumes the upper 3x3 of m is a pure rotation matrix (i.e, unscaled)
    var m11 = m[0];
    var m12 = m[4];
    var m13 = m[8];
    var m21 = m[1];
    var m22 = m[5];
    var m23 = m[9];
    var m31 = m[2];
    var m32 = m[6];
    var m33 = m[10];
    var s;
    var trace = m11 + m22 + m33;

    if (trace > 0) {
      s = 0.5 / Math.sqrt(trace + 1.0);
      dest[3] = 0.25 / s;
      dest[0] = (m32 - m23) * s;
      dest[1] = (m13 - m31) * s;
      dest[2] = (m21 - m12) * s;
    } else if (m11 > m22 && m11 > m33) {
      s = 2.0 * Math.sqrt(1.0 + m11 - m22 - m33);
      dest[3] = (m32 - m23) / s;
      dest[0] = 0.25 * s;
      dest[1] = (m12 + m21) / s;
      dest[2] = (m13 + m31) / s;
    } else if (m22 > m33) {
      s = 2.0 * Math.sqrt(1.0 + m22 - m11 - m33);
      dest[3] = (m13 - m31) / s;
      dest[0] = (m12 + m21) / s;
      dest[1] = 0.25 * s;
      dest[2] = (m23 + m32) / s;
    } else {
      s = 2.0 * Math.sqrt(1.0 + m33 - m11 - m22);
      dest[3] = (m21 - m12) / s;
      dest[0] = (m13 + m31) / s;
      dest[1] = (m23 + m32) / s;
      dest[2] = 0.25 * s;
    }

    return dest;
  },
  vec3PairToQuaternion: function vec3PairToQuaternion(u, v) {
    var dest = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : math.vec4();
    var norm_u_norm_v = Math.sqrt(math.dotVec3(u, u) * math.dotVec3(v, v));
    var real_part = norm_u_norm_v + math.dotVec3(u, v);

    if (real_part < 0.00000001 * norm_u_norm_v) {
      // If u and v are exactly opposite, rotate 180 degrees
      // around an arbitrary orthogonal axis. Axis normalisation
      // can happen later, when we normalise the quaternion.
      real_part = 0.0;

      if (Math.abs(u[0]) > Math.abs(u[2])) {
        dest[0] = -u[1];
        dest[1] = u[0];
        dest[2] = 0;
      } else {
        dest[0] = 0;
        dest[1] = -u[2];
        dest[2] = u[1];
      }
    } else {
      // Otherwise, build quaternion the standard way.
      math.cross3Vec3(u, v, dest);
    }

    dest[3] = real_part;
    return math.normalizeQuaternion(dest);
  },
  angleAxisToQuaternion: function angleAxisToQuaternion(angleAxis) {
    var dest = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : math.vec4();
    var halfAngle = angleAxis[3] / 2.0;
    var fsin = Math.sin(halfAngle);
    dest[0] = fsin * angleAxis[0];
    dest[1] = fsin * angleAxis[1];
    dest[2] = fsin * angleAxis[2];
    dest[3] = Math.cos(halfAngle);
    return dest;
  },
  quaternionToEuler: function () {
    var mat = new FloatArrayType(16);
    return function (q, order, dest) {
      dest = dest || math.vec3();
      math.quaternionToRotationMat4(q, mat);
      math.mat4ToEuler(mat, order, dest);
      return dest;
    };
  }(),
  mulQuaternions: function mulQuaternions(p, q) {
    var dest = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : math.vec4();
    var p0 = p[0];
    var p1 = p[1];
    var p2 = p[2];
    var p3 = p[3];
    var q0 = q[0];
    var q1 = q[1];
    var q2 = q[2];
    var q3 = q[3];
    dest[0] = p3 * q0 + p0 * q3 + p1 * q2 - p2 * q1;
    dest[1] = p3 * q1 + p1 * q3 + p2 * q0 - p0 * q2;
    dest[2] = p3 * q2 + p2 * q3 + p0 * q1 - p1 * q0;
    dest[3] = p3 * q3 - p0 * q0 - p1 * q1 - p2 * q2;
    return dest;
  },
  vec3ApplyQuaternion: function vec3ApplyQuaternion(q, vec) {
    var dest = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : math.vec3();
    var x = vec[0];
    var y = vec[1];
    var z = vec[2];
    var qx = q[0];
    var qy = q[1];
    var qz = q[2];
    var qw = q[3]; // calculate quat * vector

    var ix = qw * x + qy * z - qz * y;
    var iy = qw * y + qz * x - qx * z;
    var iz = qw * z + qx * y - qy * x;
    var iw = -qx * x - qy * y - qz * z; // calculate result * inverse quat

    dest[0] = ix * qw + iw * -qx + iy * -qz - iz * -qy;
    dest[1] = iy * qw + iw * -qy + iz * -qx - ix * -qz;
    dest[2] = iz * qw + iw * -qz + ix * -qy - iy * -qx;
    return dest;
  },
  quaternionToMat4: function quaternionToMat4(q, dest) {
    dest = math.identityMat4(dest);
    var q0 = q[0]; //x

    var q1 = q[1]; //y

    var q2 = q[2]; //z

    var q3 = q[3]; //w

    var tx = 2.0 * q0;
    var ty = 2.0 * q1;
    var tz = 2.0 * q2;
    var twx = tx * q3;
    var twy = ty * q3;
    var twz = tz * q3;
    var txx = tx * q0;
    var txy = ty * q0;
    var txz = tz * q0;
    var tyy = ty * q1;
    var tyz = tz * q1;
    var tzz = tz * q2;
    dest[0] = 1.0 - (tyy + tzz);
    dest[1] = txy + twz;
    dest[2] = txz - twy;
    dest[4] = txy - twz;
    dest[5] = 1.0 - (txx + tzz);
    dest[6] = tyz + twx;
    dest[8] = txz + twy;
    dest[9] = tyz - twx;
    dest[10] = 1.0 - (txx + tyy);
    return dest;
  },
  quaternionToRotationMat4: function quaternionToRotationMat4(q, m) {
    var x = q[0];
    var y = q[1];
    var z = q[2];
    var w = q[3];
    var x2 = x + x;
    var y2 = y + y;
    var z2 = z + z;
    var xx = x * x2;
    var xy = x * y2;
    var xz = x * z2;
    var yy = y * y2;
    var yz = y * z2;
    var zz = z * z2;
    var wx = w * x2;
    var wy = w * y2;
    var wz = w * z2;
    m[0] = 1 - (yy + zz);
    m[4] = xy - wz;
    m[8] = xz + wy;
    m[1] = xy + wz;
    m[5] = 1 - (xx + zz);
    m[9] = yz - wx;
    m[2] = xz - wy;
    m[6] = yz + wx;
    m[10] = 1 - (xx + yy); // last column

    m[3] = 0;
    m[7] = 0;
    m[11] = 0; // bottom row

    m[12] = 0;
    m[13] = 0;
    m[14] = 0;
    m[15] = 1;
    return m;
  },
  normalizeQuaternion: function normalizeQuaternion(q) {
    var dest = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : q;
    var len = math.lenVec4([q[0], q[1], q[2], q[3]]);
    dest[0] = q[0] / len;
    dest[1] = q[1] / len;
    dest[2] = q[2] / len;
    dest[3] = q[3] / len;
    return dest;
  },
  conjugateQuaternion: function conjugateQuaternion(q) {
    var dest = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : q;
    dest[0] = -q[0];
    dest[1] = -q[1];
    dest[2] = -q[2];
    dest[3] = q[3];
    return dest;
  },
  inverseQuaternion: function inverseQuaternion(q, dest) {
    return math.normalizeQuaternion(math.conjugateQuaternion(q, dest));
  },
  quaternionToAngleAxis: function quaternionToAngleAxis(q) {
    var angleAxis = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : math.vec4();
    q = math.normalizeQuaternion(q, tempVec4);
    var q3 = q[3];
    var angle = 2 * Math.acos(q3);
    var s = Math.sqrt(1 - q3 * q3);

    if (s < 0.001) {
      // test to avoid divide by zero, s is always positive due to sqrt
      angleAxis[0] = q[0];
      angleAxis[1] = q[1];
      angleAxis[2] = q[2];
    } else {
      angleAxis[0] = q[0] / s;
      angleAxis[1] = q[1] / s;
      angleAxis[2] = q[2] / s;
    }

    angleAxis[3] = angle; // * 57.295779579;

    return angleAxis;
  },
  //------------------------------------------------------------------------------------------------------------------
  // Boundaries
  //------------------------------------------------------------------------------------------------------------------

  /**
   * Returns a new, uninitialized 3D axis-aligned bounding box.
   *
   * @private
   */
  AABB3: function AABB3(values) {
    return new FloatArrayType(values || 6);
  },

  /**
   * Returns a new, uninitialized 2D axis-aligned bounding box.
   *
   * @private
   */
  AABB2: function AABB2(values) {
    return new FloatArrayType(values || 4);
  },

  /**
   * Returns a new, uninitialized 3D oriented bounding box (OBB).
   *
   * @private
   */
  OBB3: function OBB3(values) {
    return new FloatArrayType(values || 32);
  },

  /**
   * Returns a new, uninitialized 2D oriented bounding box (OBB).
   *
   * @private
   */
  OBB2: function OBB2(values) {
    return new FloatArrayType(values || 16);
  },

  /** Returns a new 3D bounding sphere */
  Sphere3: function Sphere3(x, y, z, r) {
    return new FloatArrayType([x, y, z, r]);
  },

  /**
   * Transforms an OBB3 by a 4x4 matrix.
   *
   * @private
   */
  transformOBB3: function transformOBB3(m, p) {
    var p2 = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : p;
    var i;
    var len = p.length;
    var x;
    var y;
    var z;
    var m0 = m[0];
    var m1 = m[1];
    var m2 = m[2];
    var m3 = m[3];
    var m4 = m[4];
    var m5 = m[5];
    var m6 = m[6];
    var m7 = m[7];
    var m8 = m[8];
    var m9 = m[9];
    var m10 = m[10];
    var m11 = m[11];
    var m12 = m[12];
    var m13 = m[13];
    var m14 = m[14];
    var m15 = m[15];

    for (i = 0; i < len; i += 4) {
      x = p[i + 0];
      y = p[i + 1];
      z = p[i + 2];
      p2[i + 0] = m0 * x + m4 * y + m8 * z + m12;
      p2[i + 1] = m1 * x + m5 * y + m9 * z + m13;
      p2[i + 2] = m2 * x + m6 * y + m10 * z + m14;
      p2[i + 3] = m3 * x + m7 * y + m11 * z + m15;
    }

    return p2;
  },

  /** Returns true if the first AABB contains the second AABB.
   * @param aabb1
   * @param aabb2
   * @returns {Boolean}
   */
  containsAABB3: function containsAABB3(aabb1, aabb2) {
    var result = aabb1[0] <= aabb2[0] && aabb2[3] <= aabb1[3] && aabb1[1] <= aabb2[1] && aabb2[4] <= aabb1[4] && aabb1[2] <= aabb2[2] && aabb2[5] <= aabb1[5];
    return result;
  },

  /**
   * Gets the diagonal size of an AABB3 given as minima and maxima.
   *
   * @private
   */
  getAABB3Diag: function () {
    var min = new FloatArrayType(3);
    var max = new FloatArrayType(3);
    var tempVec3 = new FloatArrayType(3);
    return function (aabb) {
      min[0] = aabb[0];
      min[1] = aabb[1];
      min[2] = aabb[2];
      max[0] = aabb[3];
      max[1] = aabb[4];
      max[2] = aabb[5];
      math.subVec3(max, min, tempVec3);
      return Math.abs(math.lenVec3(tempVec3));
    };
  }(),

  /**
   * Get a diagonal boundary size that is symmetrical about the given point.
   *
   * @private
   */
  getAABB3DiagPoint: function () {
    var min = new FloatArrayType(3);
    var max = new FloatArrayType(3);
    var tempVec3 = new FloatArrayType(3);
    return function (aabb, p) {
      min[0] = aabb[0];
      min[1] = aabb[1];
      min[2] = aabb[2];
      max[0] = aabb[3];
      max[1] = aabb[4];
      max[2] = aabb[5];
      var diagVec = math.subVec3(max, min, tempVec3);
      var xneg = p[0] - aabb[0];
      var xpos = aabb[3] - p[0];
      var yneg = p[1] - aabb[1];
      var ypos = aabb[4] - p[1];
      var zneg = p[2] - aabb[2];
      var zpos = aabb[5] - p[2];
      diagVec[0] += xneg > xpos ? xneg : xpos;
      diagVec[1] += yneg > ypos ? yneg : ypos;
      diagVec[2] += zneg > zpos ? zneg : zpos;
      return Math.abs(math.lenVec3(diagVec));
    };
  }(),

  /**
   * Gets the area of an AABB.
   *
   * @private
   */
  getAABB3Area: function getAABB3Area(aabb) {
    var width = aabb[3] - aabb[0];
    var height = aabb[4] - aabb[1];
    var depth = aabb[5] - aabb[2];
    return width * height * depth;
  },

  /**
   * Gets the center of an AABB.
   *
   * @private
   */
  getAABB3Center: function getAABB3Center(aabb, dest) {
    var r = dest || math.vec3();
    r[0] = (aabb[0] + aabb[3]) / 2;
    r[1] = (aabb[1] + aabb[4]) / 2;
    r[2] = (aabb[2] + aabb[5]) / 2;
    return r;
  },

  /**
   * Gets the center of a 2D AABB.
   *
   * @private
   */
  getAABB2Center: function getAABB2Center(aabb, dest) {
    var r = dest || math.vec2();
    r[0] = (aabb[2] + aabb[0]) / 2;
    r[1] = (aabb[3] + aabb[1]) / 2;
    return r;
  },

  /**
   * Collapses a 3D axis-aligned boundary, ready to expand to fit 3D points.
   * Creates new AABB if none supplied.
   *
   * @private
   */
  collapseAABB3: function collapseAABB3() {
    var aabb = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : math.AABB3();
    aabb[0] = math.MAX_DOUBLE;
    aabb[1] = math.MAX_DOUBLE;
    aabb[2] = math.MAX_DOUBLE;
    aabb[3] = math.MIN_DOUBLE;
    aabb[4] = math.MIN_DOUBLE;
    aabb[5] = math.MIN_DOUBLE;
    return aabb;
  },

  /**
   * Converts an axis-aligned 3D boundary into an oriented boundary consisting of
   * an array of eight 3D positions, one for each corner of the boundary.
   *
   * @private
   */
  AABB3ToOBB3: function AABB3ToOBB3(aabb) {
    var obb = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : math.OBB3();
    obb[0] = aabb[0];
    obb[1] = aabb[1];
    obb[2] = aabb[2];
    obb[3] = 1;
    obb[4] = aabb[3];
    obb[5] = aabb[1];
    obb[6] = aabb[2];
    obb[7] = 1;
    obb[8] = aabb[3];
    obb[9] = aabb[4];
    obb[10] = aabb[2];
    obb[11] = 1;
    obb[12] = aabb[0];
    obb[13] = aabb[4];
    obb[14] = aabb[2];
    obb[15] = 1;
    obb[16] = aabb[0];
    obb[17] = aabb[1];
    obb[18] = aabb[5];
    obb[19] = 1;
    obb[20] = aabb[3];
    obb[21] = aabb[1];
    obb[22] = aabb[5];
    obb[23] = 1;
    obb[24] = aabb[3];
    obb[25] = aabb[4];
    obb[26] = aabb[5];
    obb[27] = 1;
    obb[28] = aabb[0];
    obb[29] = aabb[4];
    obb[30] = aabb[5];
    obb[31] = 1;
    return obb;
  },

  /**
   * Finds the minimum axis-aligned 3D boundary enclosing the homogeneous 3D points (x,y,z,w) given in a flattened array.
   *
   * @private
   */
  positions3ToAABB3: function () {
    var p = new FloatArrayType(3);
    return function (positions, aabb, positionsDecodeMatrix) {
      aabb = aabb || math.AABB3();
      var xmin = math.MAX_DOUBLE;
      var ymin = math.MAX_DOUBLE;
      var zmin = math.MAX_DOUBLE;
      var xmax = math.MIN_DOUBLE;
      var ymax = math.MIN_DOUBLE;
      var zmax = math.MIN_DOUBLE;
      var x;
      var y;
      var z;

      for (var i = 0, len = positions.length; i < len; i += 3) {
        if (positionsDecodeMatrix) {
          p[0] = positions[i + 0];
          p[1] = positions[i + 1];
          p[2] = positions[i + 2];
          math.decompressPosition(p, positionsDecodeMatrix, p);
          x = p[0];
          y = p[1];
          z = p[2];
        } else {
          x = positions[i + 0];
          y = positions[i + 1];
          z = positions[i + 2];
        }

        if (x < xmin) {
          xmin = x;
        }

        if (y < ymin) {
          ymin = y;
        }

        if (z < zmin) {
          zmin = z;
        }

        if (x > xmax) {
          xmax = x;
        }

        if (y > ymax) {
          ymax = y;
        }

        if (z > zmax) {
          zmax = z;
        }
      }

      aabb[0] = xmin;
      aabb[1] = ymin;
      aabb[2] = zmin;
      aabb[3] = xmax;
      aabb[4] = ymax;
      aabb[5] = zmax;
      return aabb;
    };
  }(),

  /**
   * Finds the minimum axis-aligned 3D boundary enclosing the homogeneous 3D points (x,y,z,w) given in a flattened array.
   *
   * @private
   */
  OBB3ToAABB3: function OBB3ToAABB3(obb) {
    var aabb = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : math.AABB3();
    var xmin = math.MAX_DOUBLE;
    var ymin = math.MAX_DOUBLE;
    var zmin = math.MAX_DOUBLE;
    var xmax = math.MIN_DOUBLE;
    var ymax = math.MIN_DOUBLE;
    var zmax = math.MIN_DOUBLE;
    var x;
    var y;
    var z;

    for (var i = 0, len = obb.length; i < len; i += 4) {
      x = obb[i + 0];
      y = obb[i + 1];
      z = obb[i + 2];

      if (x < xmin) {
        xmin = x;
      }

      if (y < ymin) {
        ymin = y;
      }

      if (z < zmin) {
        zmin = z;
      }

      if (x > xmax) {
        xmax = x;
      }

      if (y > ymax) {
        ymax = y;
      }

      if (z > zmax) {
        zmax = z;
      }
    }

    aabb[0] = xmin;
    aabb[1] = ymin;
    aabb[2] = zmin;
    aabb[3] = xmax;
    aabb[4] = ymax;
    aabb[5] = zmax;
    return aabb;
  },

  /**
   * Finds the minimum axis-aligned 3D boundary enclosing the given 3D points.
   *
   * @private
   */
  points3ToAABB3: function points3ToAABB3(points) {
    var aabb = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : math.AABB3();
    var xmin = math.MAX_DOUBLE;
    var ymin = math.MAX_DOUBLE;
    var zmin = math.MAX_DOUBLE;
    var xmax = math.MIN_DOUBLE;
    var ymax = math.MIN_DOUBLE;
    var zmax = math.MIN_DOUBLE;
    var x;
    var y;
    var z;

    for (var i = 0, len = points.length; i < len; i++) {
      x = points[i][0];
      y = points[i][1];
      z = points[i][2];

      if (x < xmin) {
        xmin = x;
      }

      if (y < ymin) {
        ymin = y;
      }

      if (z < zmin) {
        zmin = z;
      }

      if (x > xmax) {
        xmax = x;
      }

      if (y > ymax) {
        ymax = y;
      }

      if (z > zmax) {
        zmax = z;
      }
    }

    aabb[0] = xmin;
    aabb[1] = ymin;
    aabb[2] = zmin;
    aabb[3] = xmax;
    aabb[4] = ymax;
    aabb[5] = zmax;
    return aabb;
  },

  /**
   * Finds the minimum boundary sphere enclosing the given 3D points.
   *
   * @private
   */
  points3ToSphere3: function () {
    var tempVec3 = new FloatArrayType(3);
    return function (points, sphere) {
      sphere = sphere || math.vec4();
      var x = 0;
      var y = 0;
      var z = 0;
      var i;
      var numPoints = points.length;

      for (i = 0; i < numPoints; i++) {
        x += points[i][0];
        y += points[i][1];
        z += points[i][2];
      }

      sphere[0] = x / numPoints;
      sphere[1] = y / numPoints;
      sphere[2] = z / numPoints;
      var radius = 0;
      var dist;

      for (i = 0; i < numPoints; i++) {
        dist = Math.abs(math.lenVec3(math.subVec3(points[i], sphere, tempVec3)));

        if (dist > radius) {
          radius = dist;
        }
      }

      sphere[3] = radius;
      return sphere;
    };
  }(),

  /**
   * Finds the minimum boundary sphere enclosing the given 3D positions.
   *
   * @private
   */
  positions3ToSphere3: function () {
    var tempVec3a = new FloatArrayType(3);
    var tempVec3b = new FloatArrayType(3);
    return function (positions, sphere) {
      sphere = sphere || math.vec4();
      var x = 0;
      var y = 0;
      var z = 0;
      var i;
      var lenPositions = positions.length;
      var radius = 0;

      for (i = 0; i < lenPositions; i += 3) {
        x += positions[i];
        y += positions[i + 1];
        z += positions[i + 2];
      }

      var numPositions = lenPositions / 3;
      sphere[0] = x / numPositions;
      sphere[1] = y / numPositions;
      sphere[2] = z / numPositions;
      var dist;

      for (i = 0; i < lenPositions; i += 3) {
        tempVec3a[0] = positions[i];
        tempVec3a[1] = positions[i + 1];
        tempVec3a[2] = positions[i + 2];
        dist = Math.abs(math.lenVec3(math.subVec3(tempVec3a, sphere, tempVec3b)));

        if (dist > radius) {
          radius = dist;
        }
      }

      sphere[3] = radius;
      return sphere;
    };
  }(),

  /**
   * Finds the minimum boundary sphere enclosing the given 3D points.
   *
   * @private
   */
  OBB3ToSphere3: function () {
    var point = new FloatArrayType(3);
    var tempVec3 = new FloatArrayType(3);
    return function (points, sphere) {
      sphere = sphere || math.vec4();
      var x = 0;
      var y = 0;
      var z = 0;
      var i;
      var lenPoints = points.length;
      var numPoints = lenPoints / 4;

      for (i = 0; i < lenPoints; i += 4) {
        x += points[i + 0];
        y += points[i + 1];
        z += points[i + 2];
      }

      sphere[0] = x / numPoints;
      sphere[1] = y / numPoints;
      sphere[2] = z / numPoints;
      var radius = 0;
      var dist;

      for (i = 0; i < lenPoints; i += 4) {
        point[0] = points[i + 0];
        point[1] = points[i + 1];
        point[2] = points[i + 2];
        dist = Math.abs(math.lenVec3(math.subVec3(point, sphere, tempVec3)));

        if (dist > radius) {
          radius = dist;
        }
      }

      sphere[3] = radius;
      return sphere;
    };
  }(),

  /**
   * Gets the center of a bounding sphere.
   *
   * @private
   */
  getSphere3Center: function getSphere3Center(sphere) {
    var dest = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : math.vec3();
    dest[0] = sphere[0];
    dest[1] = sphere[1];
    dest[2] = sphere[2];
    return dest;
  },

  /**
   * Gets the 3D center of the given flat array of 3D positions.
   *
   * @private
   */
  getPositionsCenter: function getPositionsCenter(positions) {
    var center = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : math.vec3();
    var xCenter = 0;
    var yCenter = 0;
    var zCenter = 0;

    for (var i = 0, len = positions.length; i < len; i += 3) {
      xCenter += positions[i + 0];
      yCenter += positions[i + 1];
      zCenter += positions[i + 2];
    }

    var numPositions = positions.length / 3;
    center[0] = xCenter / numPositions;
    center[1] = yCenter / numPositions;
    center[2] = zCenter / numPositions;
    return center;
  },

  /**
   * Expands the first axis-aligned 3D boundary to enclose the second, if required.
   *
   * @private
   */
  expandAABB3: function expandAABB3(aabb1, aabb2) {
    if (aabb1[0] > aabb2[0]) {
      aabb1[0] = aabb2[0];
    }

    if (aabb1[1] > aabb2[1]) {
      aabb1[1] = aabb2[1];
    }

    if (aabb1[2] > aabb2[2]) {
      aabb1[2] = aabb2[2];
    }

    if (aabb1[3] < aabb2[3]) {
      aabb1[3] = aabb2[3];
    }

    if (aabb1[4] < aabb2[4]) {
      aabb1[4] = aabb2[4];
    }

    if (aabb1[5] < aabb2[5]) {
      aabb1[5] = aabb2[5];
    }

    return aabb1;
  },

  /**
   * Expands an axis-aligned 3D boundary to enclose the given point, if needed.
   *
   * @private
   */
  expandAABB3Point3: function expandAABB3Point3(aabb, p) {
    if (aabb[0] > p[0]) {
      aabb[0] = p[0];
    }

    if (aabb[1] > p[1]) {
      aabb[1] = p[1];
    }

    if (aabb[2] > p[2]) {
      aabb[2] = p[2];
    }

    if (aabb[3] < p[0]) {
      aabb[3] = p[0];
    }

    if (aabb[4] < p[1]) {
      aabb[4] = p[1];
    }

    if (aabb[5] < p[2]) {
      aabb[5] = p[2];
    }

    return aabb;
  },

  /**
   * Expands an axis-aligned 3D boundary to enclose the given points, if needed.
   *
   * @private
   */
  expandAABB3Points3: function expandAABB3Points3(aabb, positions) {
    var x;
    var y;
    var z;

    for (var i = 0, len = positions.length; i < len; i += 3) {
      x = positions[i];
      y = positions[i + 1];
      z = positions[i + 2];

      if (aabb[0] > x) {
        aabb[0] = x;
      }

      if (aabb[1] > y) {
        aabb[1] = y;
      }

      if (aabb[2] > z) {
        aabb[2] = z;
      }

      if (aabb[3] < x) {
        aabb[3] = x;
      }

      if (aabb[4] < y) {
        aabb[4] = y;
      }

      if (aabb[5] < z) {
        aabb[5] = z;
      }
    }

    return aabb;
  },

  /**
   * Collapses a 2D axis-aligned boundary, ready to expand to fit 2D points.
   * Creates new AABB if none supplied.
   *
   * @private
   */
  collapseAABB2: function collapseAABB2() {
    var aabb = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : math.AABB2();
    aabb[0] = math.MAX_DOUBLE;
    aabb[1] = math.MAX_DOUBLE;
    aabb[2] = math.MIN_DOUBLE;
    aabb[3] = math.MIN_DOUBLE;
    return aabb;
  },
  point3AABB3Intersect: function point3AABB3Intersect(aabb, p) {
    return aabb[0] > p[0] || aabb[3] < p[0] || aabb[1] > p[1] || aabb[4] < p[1] || aabb[2] > p[2] || aabb[5] < p[2];
  },

  /**
   *
   * @param dir
   * @param constant
   * @param aabb
   * @returns {number}
   */
  planeAABB3Intersect: function planeAABB3Intersect(dir, constant, aabb) {
    var min, max;

    if (dir[0] > 0) {
      min = dir[0] * aabb[0];
      max = dir[0] * aabb[3];
    } else {
      min = dir[0] * aabb[3];
      max = dir[0] * aabb[0];
    }

    if (dir[1] > 0) {
      min += dir[1] * aabb[1];
      max += dir[1] * aabb[4];
    } else {
      min += dir[1] * aabb[4];
      max += dir[1] * aabb[1];
    }

    if (dir[2] > 0) {
      min += dir[2] * aabb[2];
      max += dir[2] * aabb[5];
    } else {
      min += dir[2] * aabb[5];
      max += dir[2] * aabb[2];
    }

    var outside = min <= -constant && max <= -constant;

    if (outside) {
      return -1;
    }

    var inside = min >= -constant && max >= -constant;

    if (inside) {
      return 1;
    }

    return 0;
  },

  /**
   * Finds the minimum 2D projected axis-aligned boundary enclosing the given 3D points.
   *
   * @private
   */
  OBB3ToAABB2: function OBB3ToAABB2(points) {
    var aabb = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : math.AABB2();
    var xmin = math.MAX_DOUBLE;
    var ymin = math.MAX_DOUBLE;
    var xmax = math.MIN_DOUBLE;
    var ymax = math.MIN_DOUBLE;
    var x;
    var y;
    var w;
    var f;

    for (var i = 0, len = points.length; i < len; i += 4) {
      x = points[i + 0];
      y = points[i + 1];
      w = points[i + 3] || 1.0;
      f = 1.0 / w;
      x *= f;
      y *= f;

      if (x < xmin) {
        xmin = x;
      }

      if (y < ymin) {
        ymin = y;
      }

      if (x > xmax) {
        xmax = x;
      }

      if (y > ymax) {
        ymax = y;
      }
    }

    aabb[0] = xmin;
    aabb[1] = ymin;
    aabb[2] = xmax;
    aabb[3] = ymax;
    return aabb;
  },

  /**
   * Expands the first axis-aligned 2D boundary to enclose the second, if required.
   *
   * @private
   */
  expandAABB2: function expandAABB2(aabb1, aabb2) {
    if (aabb1[0] > aabb2[0]) {
      aabb1[0] = aabb2[0];
    }

    if (aabb1[1] > aabb2[1]) {
      aabb1[1] = aabb2[1];
    }

    if (aabb1[2] < aabb2[2]) {
      aabb1[2] = aabb2[2];
    }

    if (aabb1[3] < aabb2[3]) {
      aabb1[3] = aabb2[3];
    }

    return aabb1;
  },

  /**
   * Expands an axis-aligned 2D boundary to enclose the given point, if required.
   *
   * @private
   */
  expandAABB2Point2: function expandAABB2Point2(aabb, p) {
    if (aabb[0] > p[0]) {
      aabb[0] = p[0];
    }

    if (aabb[1] > p[1]) {
      aabb[1] = p[1];
    }

    if (aabb[2] < p[0]) {
      aabb[2] = p[0];
    }

    if (aabb[3] < p[1]) {
      aabb[3] = p[1];
    }

    return aabb;
  },
  AABB2ToCanvas: function AABB2ToCanvas(aabb, canvasWidth, canvasHeight) {
    var aabb2 = arguments.length > 3 && arguments[3] !== undefined ? arguments[3] : aabb;
    var xmin = (aabb[0] + 1.0) * 0.5;
    var ymin = (aabb[1] + 1.0) * 0.5;
    var xmax = (aabb[2] + 1.0) * 0.5;
    var ymax = (aabb[3] + 1.0) * 0.5;
    aabb2[0] = Math.floor(xmin * canvasWidth);
    aabb2[1] = canvasHeight - Math.floor(ymax * canvasHeight);
    aabb2[2] = Math.floor(xmax * canvasWidth);
    aabb2[3] = canvasHeight - Math.floor(ymin * canvasHeight);
    return aabb2;
  },
  //------------------------------------------------------------------------------------------------------------------
  // Curves
  //------------------------------------------------------------------------------------------------------------------
  tangentQuadraticBezier: function tangentQuadraticBezier(t, p0, p1, p2) {
    return 2 * (1 - t) * (p1 - p0) + 2 * t * (p2 - p1);
  },
  tangentQuadraticBezier3: function tangentQuadraticBezier3(t, p0, p1, p2, p3) {
    return -3 * p0 * (1 - t) * (1 - t) + 3 * p1 * (1 - t) * (1 - t) - 6 * t * p1 * (1 - t) + 6 * t * p2 * (1 - t) - 3 * t * t * p2 + 3 * t * t * p3;
  },
  tangentSpline: function tangentSpline(t) {
    var h00 = 6 * t * t - 6 * t;
    var h10 = 3 * t * t - 4 * t + 1;
    var h01 = -6 * t * t + 6 * t;
    var h11 = 3 * t * t - 2 * t;
    return h00 + h10 + h01 + h11;
  },
  catmullRomInterpolate: function catmullRomInterpolate(p0, p1, p2, p3, t) {
    var v0 = (p2 - p0) * 0.5;
    var v1 = (p3 - p1) * 0.5;
    var t2 = t * t;
    var t3 = t * t2;
    return (2 * p1 - 2 * p2 + v0 + v1) * t3 + (-3 * p1 + 3 * p2 - 2 * v0 - v1) * t2 + v0 * t + p1;
  },
  // Bezier Curve formulii from http://en.wikipedia.org/wiki/B%C3%A9zier_curve
  // Quad Bezier Functions
  b2p0: function b2p0(t, p) {
    var k = 1 - t;
    return k * k * p;
  },
  b2p1: function b2p1(t, p) {
    return 2 * (1 - t) * t * p;
  },
  b2p2: function b2p2(t, p) {
    return t * t * p;
  },
  b2: function b2(t, p0, p1, p2) {
    return this.b2p0(t, p0) + this.b2p1(t, p1) + this.b2p2(t, p2);
  },
  // Cubic Bezier Functions
  b3p0: function b3p0(t, p) {
    var k = 1 - t;
    return k * k * k * p;
  },
  b3p1: function b3p1(t, p) {
    var k = 1 - t;
    return 3 * k * k * t * p;
  },
  b3p2: function b3p2(t, p) {
    var k = 1 - t;
    return 3 * k * t * t * p;
  },
  b3p3: function b3p3(t, p) {
    return t * t * t * p;
  },
  b3: function b3(t, p0, p1, p2, p3) {
    return this.b3p0(t, p0) + this.b3p1(t, p1) + this.b3p2(t, p2) + this.b3p3(t, p3);
  },
  //------------------------------------------------------------------------------------------------------------------
  // Geometry
  //------------------------------------------------------------------------------------------------------------------

  /**
   * Calculates the normal vector of a triangle.
   *
   * @private
   */
  triangleNormal: function triangleNormal(a, b, c) {
    var normal = arguments.length > 3 && arguments[3] !== undefined ? arguments[3] : math.vec3();
    var p1x = b[0] - a[0];
    var p1y = b[1] - a[1];
    var p1z = b[2] - a[2];
    var p2x = c[0] - a[0];
    var p2y = c[1] - a[1];
    var p2z = c[2] - a[2];
    var p3x = p1y * p2z - p1z * p2y;
    var p3y = p1z * p2x - p1x * p2z;
    var p3z = p1x * p2y - p1y * p2x;
    var mag = Math.sqrt(p3x * p3x + p3y * p3y + p3z * p3z);

    if (mag === 0) {
      normal[0] = 0;
      normal[1] = 0;
      normal[2] = 0;
    } else {
      normal[0] = p3x / mag;
      normal[1] = p3y / mag;
      normal[2] = p3z / mag;
    }

    return normal;
  },

  /**
   * Finds the intersection of a 3D ray with a 3D triangle.
   *
   * @private
   */
  rayTriangleIntersect: function () {
    var tempVec3 = new FloatArrayType(3);
    var tempVec3b = new FloatArrayType(3);
    var tempVec3c = new FloatArrayType(3);
    var tempVec3d = new FloatArrayType(3);
    var tempVec3e = new FloatArrayType(3);
    return function (origin, dir, a, b, c, isect) {
      isect = isect || math.vec3();
      var EPSILON = 0.000001;
      var edge1 = math.subVec3(b, a, tempVec3);
      var edge2 = math.subVec3(c, a, tempVec3b);
      var pvec = math.cross3Vec3(dir, edge2, tempVec3c);
      var det = math.dotVec3(edge1, pvec);

      if (det < EPSILON) {
        return null;
      }

      var tvec = math.subVec3(origin, a, tempVec3d);
      var u = math.dotVec3(tvec, pvec);

      if (u < 0 || u > det) {
        return null;
      }

      var qvec = math.cross3Vec3(tvec, edge1, tempVec3e);
      var v = math.dotVec3(dir, qvec);

      if (v < 0 || u + v > det) {
        return null;
      }

      var t = math.dotVec3(edge2, qvec) / det;
      isect[0] = origin[0] + t * dir[0];
      isect[1] = origin[1] + t * dir[1];
      isect[2] = origin[2] + t * dir[2];
      return isect;
    };
  }(),

  /**
   * Finds the intersection of a 3D ray with a plane defined by 3 points.
   *
   * @private
   */
  rayPlaneIntersect: function () {
    var tempVec3 = new FloatArrayType(3);
    var tempVec3b = new FloatArrayType(3);
    var tempVec3c = new FloatArrayType(3);
    var tempVec3d = new FloatArrayType(3);
    return function (origin, dir, a, b, c, isect) {
      isect = isect || math.vec3();
      dir = math.normalizeVec3(dir, tempVec3);
      var edge1 = math.subVec3(b, a, tempVec3b);
      var edge2 = math.subVec3(c, a, tempVec3c);
      var n = math.cross3Vec3(edge1, edge2, tempVec3d);
      math.normalizeVec3(n, n);
      var d = -math.dotVec3(a, n);
      var t = -(math.dotVec3(origin, n) + d) / math.dotVec3(dir, n);
      isect[0] = origin[0] + t * dir[0];
      isect[1] = origin[1] + t * dir[1];
      isect[2] = origin[2] + t * dir[2];
      return isect;
    };
  }(),

  /**
   * Gets barycentric coordinates from cartesian coordinates within a triangle.
   * Gets barycentric coordinates from cartesian coordinates within a triangle.
   *
   * @private
   */
  cartesianToBarycentric: function () {
    var tempVec3 = new FloatArrayType(3);
    var tempVec3b = new FloatArrayType(3);
    var tempVec3c = new FloatArrayType(3);
    return function (cartesian, a, b, c, dest) {
      var v0 = math.subVec3(c, a, tempVec3);
      var v1 = math.subVec3(b, a, tempVec3b);
      var v2 = math.subVec3(cartesian, a, tempVec3c);
      var dot00 = math.dotVec3(v0, v0);
      var dot01 = math.dotVec3(v0, v1);
      var dot02 = math.dotVec3(v0, v2);
      var dot11 = math.dotVec3(v1, v1);
      var dot12 = math.dotVec3(v1, v2);
      var denom = dot00 * dot11 - dot01 * dot01; // Colinear or singular triangle

      if (denom === 0) {
        // Arbitrary location outside of triangle
        return null;
      }

      var invDenom = 1 / denom;
      var u = (dot11 * dot02 - dot01 * dot12) * invDenom;
      var v = (dot00 * dot12 - dot01 * dot02) * invDenom;
      dest[0] = 1 - u - v;
      dest[1] = v;
      dest[2] = u;
      return dest;
    };
  }(),

  /**
   * Returns true if the given barycentric coordinates are within their triangle.
   *
   * @private
   */
  barycentricInsideTriangle: function barycentricInsideTriangle(bary) {
    var v = bary[1];
    var u = bary[2];
    return u >= 0 && v >= 0 && u + v < 1;
  },

  /**
   * Gets cartesian coordinates from barycentric coordinates within a triangle.
   *
   * @private
   */
  barycentricToCartesian: function barycentricToCartesian(bary, a, b, c) {
    var cartesian = arguments.length > 4 && arguments[4] !== undefined ? arguments[4] : math.vec3();
    var u = bary[0];
    var v = bary[1];
    var w = bary[2];
    cartesian[0] = a[0] * u + b[0] * v + c[0] * w;
    cartesian[1] = a[1] * u + b[1] * v + c[1] * w;
    cartesian[2] = a[2] * u + b[2] * v + c[2] * w;
    return cartesian;
  },

  /**
   * Given geometry defined as an array of positions, optional normals, option uv and an array of indices, returns
   * modified arrays that have duplicate vertices removed.
   *
   * Note: does not work well when co-incident vertices have same positions but different normals and UVs.
   *
   * @param positions
   * @param normals
   * @param uv
   * @param indices
   * @returns {{positions: Array, indices: Array}}
   * @private
   */
  mergeVertices: function mergeVertices(positions, normals, uv, indices) {
    var positionsMap = {}; // Hashmap for looking up vertices by position coordinates (and making sure they are unique)

    var indicesLookup = [];
    var uniquePositions = [];
    var uniqueNormals = normals ? [] : null;
    var uniqueUV = uv ? [] : null;
    var indices2 = [];
    var vx;
    var vy;
    var vz;
    var key;
    var precisionPoints = 4; // number of decimal points, e.g. 4 for epsilon of 0.0001

    var precision = Math.pow(10, precisionPoints);
    var i;
    var len;
    var uvi = 0;

    for (i = 0, len = positions.length; i < len; i += 3) {
      vx = positions[i];
      vy = positions[i + 1];
      vz = positions[i + 2];
      key = "".concat(Math.round(vx * precision), "_").concat(Math.round(vy * precision), "_").concat(Math.round(vz * precision));

      if (positionsMap[key] === undefined) {
        positionsMap[key] = uniquePositions.length / 3;
        uniquePositions.push(vx);
        uniquePositions.push(vy);
        uniquePositions.push(vz);

        if (normals) {
          uniqueNormals.push(normals[i]);
          uniqueNormals.push(normals[i + 1]);
          uniqueNormals.push(normals[i + 2]);
        }

        if (uv) {
          uniqueUV.push(uv[uvi]);
          uniqueUV.push(uv[uvi + 1]);
        }
      }

      indicesLookup[i / 3] = positionsMap[key];
      uvi += 2;
    }

    for (i = 0, len = indices.length; i < len; i++) {
      indices2[i] = indicesLookup[indices[i]];
    }

    var result = {
      positions: uniquePositions,
      indices: indices2
    };

    if (uniqueNormals) {
      result.normals = uniqueNormals;
    }

    if (uniqueUV) {
      result.uv = uniqueUV;
    }

    return result;
  },

  /**
   * Builds normal vectors from positions and indices.
   *
   * @private
   */
  buildNormals: function () {
    var a = new FloatArrayType(3);
    var b = new FloatArrayType(3);
    var c = new FloatArrayType(3);
    var ab = new FloatArrayType(3);
    var ac = new FloatArrayType(3);
    var crossVec = new FloatArrayType(3);
    return function (positions, indices, normals) {
      var i;
      var len;
      var nvecs = new Array(positions.length / 3);
      var j0;
      var j1;
      var j2;

      for (i = 0, len = indices.length; i < len; i += 3) {
        j0 = indices[i];
        j1 = indices[i + 1];
        j2 = indices[i + 2];
        a[0] = positions[j0 * 3];
        a[1] = positions[j0 * 3 + 1];
        a[2] = positions[j0 * 3 + 2];
        b[0] = positions[j1 * 3];
        b[1] = positions[j1 * 3 + 1];
        b[2] = positions[j1 * 3 + 2];
        c[0] = positions[j2 * 3];
        c[1] = positions[j2 * 3 + 1];
        c[2] = positions[j2 * 3 + 2];
        math.subVec3(b, a, ab);
        math.subVec3(c, a, ac);
        var normVec = math.vec3();
        math.normalizeVec3(math.cross3Vec3(ab, ac, crossVec), normVec);

        if (!nvecs[j0]) {
          nvecs[j0] = [];
        }

        if (!nvecs[j1]) {
          nvecs[j1] = [];
        }

        if (!nvecs[j2]) {
          nvecs[j2] = [];
        }

        nvecs[j0].push(normVec);
        nvecs[j1].push(normVec);
        nvecs[j2].push(normVec);
      }

      normals = normals && normals.length === positions.length ? normals : new Float32Array(positions.length);
      var count;
      var x;
      var y;
      var z;

      for (i = 0, len = nvecs.length; i < len; i++) {
        // Now go through and average out everything
        count = nvecs[i].length;
        x = 0;
        y = 0;
        z = 0;

        for (var j = 0; j < count; j++) {
          x += nvecs[i][j][0];
          y += nvecs[i][j][1];
          z += nvecs[i][j][2];
        }

        normals[i * 3] = x / count;
        normals[i * 3 + 1] = y / count;
        normals[i * 3 + 2] = z / count;
      }

      return normals;
    };
  }(),

  /**
   * Builds vertex tangent vectors from positions, UVs and indices.
   *
   * @private
   */
  buildTangents: function () {
    var tempVec3 = new FloatArrayType(3);
    var tempVec3b = new FloatArrayType(3);
    var tempVec3c = new FloatArrayType(3);
    var tempVec3d = new FloatArrayType(3);
    var tempVec3e = new FloatArrayType(3);
    var tempVec3f = new FloatArrayType(3);
    var tempVec3g = new FloatArrayType(3);
    return function (positions, indices, uv) {
      var tangents = new Float32Array(positions.length); // The vertex arrays needs to be calculated
      // before the calculation of the tangents

      for (var location = 0; location < indices.length; location += 3) {
        // Recontructing each vertex and UV coordinate into the respective vectors
        var index = indices[location];
        var v0 = positions.subarray(index * 3, index * 3 + 3);
        var uv0 = uv.subarray(index * 2, index * 2 + 2);
        index = indices[location + 1];
        var v1 = positions.subarray(index * 3, index * 3 + 3);
        var uv1 = uv.subarray(index * 2, index * 2 + 2);
        index = indices[location + 2];
        var v2 = positions.subarray(index * 3, index * 3 + 3);
        var uv2 = uv.subarray(index * 2, index * 2 + 2);
        var deltaPos1 = math.subVec3(v1, v0, tempVec3);
        var deltaPos2 = math.subVec3(v2, v0, tempVec3b);
        var deltaUV1 = math.subVec2(uv1, uv0, tempVec3c);
        var deltaUV2 = math.subVec2(uv2, uv0, tempVec3d);
        var r = 1 / (deltaUV1[0] * deltaUV2[1] - deltaUV1[1] * deltaUV2[0]);
        var tangent = math.mulVec3Scalar(math.subVec3(math.mulVec3Scalar(deltaPos1, deltaUV2[1], tempVec3e), math.mulVec3Scalar(deltaPos2, deltaUV1[1], tempVec3f), tempVec3g), r, tempVec3f); // Average the value of the vectors

        var addTo = void 0;

        for (var v = 0; v < 3; v++) {
          addTo = indices[location + v] * 3;
          tangents[addTo] += tangent[0];
          tangents[addTo + 1] += tangent[1];
          tangents[addTo + 2] += tangent[2];
        }
      }

      return tangents;
    };
  }(),

  /**
   * Builds vertex and index arrays needed by color-indexed triangle picking.
   *
   * @private
   */
  buildPickTriangles: function buildPickTriangles(positions, indices, compressGeometry) {
    var numIndices = indices.length;
    var pickPositions = compressGeometry ? new Uint16Array(numIndices * 9) : new Float32Array(numIndices * 9);
    var pickColors = new Uint8Array(numIndices * 12);
    var primIndex = 0;
    var vi; // Positions array index

    var pvi = 0; // Picking positions array index

    var pci = 0; // Picking color array index
    // Triangle indices

    var i;
    var r;
    var g;
    var b;
    var a;

    for (var location = 0; location < numIndices; location += 3) {
      // Primitive-indexed triangle pick color
      a = primIndex >> 24 & 0xFF;
      b = primIndex >> 16 & 0xFF;
      g = primIndex >> 8 & 0xFF;
      r = primIndex & 0xFF; // A

      i = indices[location];
      vi = i * 3;
      pickPositions[pvi++] = positions[vi];
      pickPositions[pvi++] = positions[vi + 1];
      pickPositions[pvi++] = positions[vi + 2];
      pickColors[pci++] = r;
      pickColors[pci++] = g;
      pickColors[pci++] = b;
      pickColors[pci++] = a; // B

      i = indices[location + 1];
      vi = i * 3;
      pickPositions[pvi++] = positions[vi];
      pickPositions[pvi++] = positions[vi + 1];
      pickPositions[pvi++] = positions[vi + 2];
      pickColors[pci++] = r;
      pickColors[pci++] = g;
      pickColors[pci++] = b;
      pickColors[pci++] = a; // C

      i = indices[location + 2];
      vi = i * 3;
      pickPositions[pvi++] = positions[vi];
      pickPositions[pvi++] = positions[vi + 1];
      pickPositions[pvi++] = positions[vi + 2];
      pickColors[pci++] = r;
      pickColors[pci++] = g;
      pickColors[pci++] = b;
      pickColors[pci++] = a;
      primIndex++;
    }

    return {
      positions: pickPositions,
      colors: pickColors
    };
  },

  /**
   * Converts surface-perpendicular face normals to vertex normals. Assumes that the mesh contains disjoint triangles
   * that don't share vertex array elements. Works by finding groups of vertices that have the same location and
   * averaging their normal vectors.
   *
   * @returns {{positions: Array, normals: *}}
   */
  faceToVertexNormals: function faceToVertexNormals(positions, normals) {
    var options = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : {};
    var smoothNormalsAngleThreshold = options.smoothNormalsAngleThreshold || 20;
    var vertexMap = {};
    var vertexNormals = [];
    var vertexNormalAccum = {};
    var acc;
    var vx;
    var vy;
    var vz;
    var key;
    var precisionPoints = 4; // number of decimal points, e.g. 4 for epsilon of 0.0001

    var precision = Math.pow(10, precisionPoints);
    var posi;
    var i;
    var j;
    var len;
    var a;
    var b;

    for (i = 0, len = positions.length; i < len; i += 3) {
      posi = i / 3;
      vx = positions[i];
      vy = positions[i + 1];
      vz = positions[i + 2];
      key = "".concat(Math.round(vx * precision), "_").concat(Math.round(vy * precision), "_").concat(Math.round(vz * precision));

      if (vertexMap[key] === undefined) {
        vertexMap[key] = [posi];
      } else {
        vertexMap[key].push(posi);
      }

      var normal = math.normalizeVec3([normals[i], normals[i + 1], normals[i + 2]]);
      vertexNormals[posi] = normal;
      acc = math.vec4([normal[0], normal[1], normal[2], 1]);
      vertexNormalAccum[posi] = acc;
    }

    for (key in vertexMap) {
      if (vertexMap.hasOwnProperty(key)) {
        var vertices = vertexMap[key];
        var numVerts = vertices.length;

        for (i = 0; i < numVerts; i++) {
          var ii = vertices[i];
          acc = vertexNormalAccum[ii];

          for (j = 0; j < numVerts; j++) {
            if (i === j) {
              continue;
            }

            var jj = vertices[j];
            a = vertexNormals[ii];
            b = vertexNormals[jj];
            var angle = Math.abs(math.angleVec3(a, b) / math.DEGTORAD);

            if (angle < smoothNormalsAngleThreshold) {
              acc[0] += b[0];
              acc[1] += b[1];
              acc[2] += b[2];
              acc[3] += 1.0;
            }
          }
        }
      }
    }

    for (i = 0, len = normals.length; i < len; i += 3) {
      acc = vertexNormalAccum[i / 3];
      normals[i + 0] = acc[0] / acc[3];
      normals[i + 1] = acc[1] / acc[3];
      normals[i + 2] = acc[2] / acc[3];
    }
  },
  //------------------------------------------------------------------------------------------------------------------
  // Ray casting
  //------------------------------------------------------------------------------------------------------------------

  /**
   Transforms a ray by a matrix.
   @method transformRay
   @static
   @param {Number[]} matrix 4x4 matrix
   @param {Number[]} rayOrigin The ray origin
   @param {Number[]} rayDir The ray direction
   @param {Number[]} rayOriginDest The transformed ray origin
   @param {Number[]} rayDirDest The transformed ray direction
   */
  transformRay: function () {
    var tempVec4a = new FloatArrayType(4);
    var tempVec4b = new FloatArrayType(4);
    return function (matrix, rayOrigin, rayDir, rayOriginDest, rayDirDest) {
      tempVec4a[0] = rayOrigin[0];
      tempVec4a[1] = rayOrigin[1];
      tempVec4a[2] = rayOrigin[2];
      tempVec4a[3] = 1;
      math.transformVec4(matrix, tempVec4a, tempVec4b);
      rayOriginDest[0] = tempVec4b[0];
      rayOriginDest[1] = tempVec4b[1];
      rayOriginDest[2] = tempVec4b[2];
      tempVec4a[0] = rayDir[0];
      tempVec4a[1] = rayDir[1];
      tempVec4a[2] = rayDir[2];
      math.transformVec3(matrix, tempVec4a, tempVec4b);
      math.normalizeVec3(tempVec4b);
      rayDirDest[0] = tempVec4b[0];
      rayDirDest[1] = tempVec4b[1];
      rayDirDest[2] = tempVec4b[2];
    };
  }(),

  /**
   Transforms a Canvas-space position into a World-space ray, in the context of a Camera.
   @method canvasPosToWorldRay
   @static
   @param {Number[]} viewMatrix View matrix
   @param {Number[]} projMatrix Projection matrix
   @param {Number[]} canvasPos The Canvas-space position.
   @param {Number[]} worldRayOrigin The World-space ray origin.
   @param {Number[]} worldRayDir The World-space ray direction.
   */
  canvasPosToWorldRay: function () {
    var tempMat4b = new FloatArrayType(16);
    var tempMat4c = new FloatArrayType(16);
    var tempVec4a = new FloatArrayType(4);
    var tempVec4b = new FloatArrayType(4);
    var tempVec4c = new FloatArrayType(4);
    var tempVec4d = new FloatArrayType(4);
    return function (canvas, viewMatrix, projMatrix, canvasPos, worldRayOrigin, worldRayDir) {
      var pvMat = math.mulMat4(projMatrix, viewMatrix, tempMat4b);
      var pvMatInverse = math.inverseMat4(pvMat, tempMat4c); // Calculate clip space coordinates, which will be in range
      // of x=[-1..1] and y=[-1..1], with y=(+1) at top

      var canvasWidth = canvas.width;
      var canvasHeight = canvas.height;
      var clipX = (canvasPos[0] - canvasWidth / 2) / (canvasWidth / 2); // Calculate clip space coordinates

      var clipY = -(canvasPos[1] - canvasHeight / 2) / (canvasHeight / 2);
      tempVec4a[0] = clipX;
      tempVec4a[1] = clipY;
      tempVec4a[2] = -1;
      tempVec4a[3] = 1;
      math.transformVec4(pvMatInverse, tempVec4a, tempVec4b);
      math.mulVec4Scalar(tempVec4b, 1 / tempVec4b[3]);
      tempVec4c[0] = clipX;
      tempVec4c[1] = clipY;
      tempVec4c[2] = 1;
      tempVec4c[3] = 1;
      math.transformVec4(pvMatInverse, tempVec4c, tempVec4d);
      math.mulVec4Scalar(tempVec4d, 1 / tempVec4d[3]);
      worldRayOrigin[0] = tempVec4d[0];
      worldRayOrigin[1] = tempVec4d[1];
      worldRayOrigin[2] = tempVec4d[2];
      math.subVec3(tempVec4d, tempVec4b, worldRayDir);
      math.normalizeVec3(worldRayDir);
    };
  }(),

  /**
   Transforms a Canvas-space position to a Mesh's Local-space coordinate system, in the context of a Camera.
   @method canvasPosToLocalRay
   @static
   @param {Camera} camera The Camera.
   @param {Mesh} mesh The Mesh.
   @param {Number[]} viewMatrix View matrix
   @param {Number[]} projMatrix Projection matrix
   @param {Number[]} worldMatrix Modeling matrix
   @param {Number[]} canvasPos The Canvas-space position.
   @param {Number[]} localRayOrigin The Local-space ray origin.
   @param {Number[]} localRayDir The Local-space ray direction.
   */
  canvasPosToLocalRay: function () {
    var worldRayOrigin = new FloatArrayType(3);
    var worldRayDir = new FloatArrayType(3);
    return function (canvas, viewMatrix, projMatrix, worldMatrix, canvasPos, localRayOrigin, localRayDir) {
      math.canvasPosToWorldRay(canvas, viewMatrix, projMatrix, canvasPos, worldRayOrigin, worldRayDir);
      math.worldRayToLocalRay(worldMatrix, worldRayOrigin, worldRayDir, localRayOrigin, localRayDir);
    };
  }(),

  /**
   Transforms a ray from World-space to a Mesh's Local-space coordinate system.
   @method worldRayToLocalRay
   @static
   @param {Number[]} worldMatrix The World transform matrix
   @param {Number[]} worldRayOrigin The World-space ray origin.
   @param {Number[]} worldRayDir The World-space ray direction.
   @param {Number[]} localRayOrigin The Local-space ray origin.
   @param {Number[]} localRayDir The Local-space ray direction.
   */
  worldRayToLocalRay: function () {
    var tempMat4 = new FloatArrayType(16);
    var tempVec4a = new FloatArrayType(4);
    var tempVec4b = new FloatArrayType(4);
    return function (worldMatrix, worldRayOrigin, worldRayDir, localRayOrigin, localRayDir) {
      var modelMatInverse = math.inverseMat4(worldMatrix, tempMat4);
      tempVec4a[0] = worldRayOrigin[0];
      tempVec4a[1] = worldRayOrigin[1];
      tempVec4a[2] = worldRayOrigin[2];
      tempVec4a[3] = 1;
      math.transformVec4(modelMatInverse, tempVec4a, tempVec4b);
      localRayOrigin[0] = tempVec4b[0];
      localRayOrigin[1] = tempVec4b[1];
      localRayOrigin[2] = tempVec4b[2];
      math.transformVec3(modelMatInverse, worldRayDir, localRayDir);
    };
  }(),
  buildKDTree: function () {
    var KD_TREE_MAX_DEPTH = 10;
    var KD_TREE_MIN_TRIANGLES = 20;
    var dimLength = new Float32Array();

    function buildNode(triangles, indices, positions, depth) {
      var aabb = new FloatArrayType(6);
      var node = {
        triangles: null,
        left: null,
        right: null,
        leaf: false,
        splitDim: 0,
        aabb: aabb
      };
      aabb[0] = aabb[1] = aabb[2] = Number.POSITIVE_INFINITY;
      aabb[3] = aabb[4] = aabb[5] = Number.NEGATIVE_INFINITY;
      var t;
      var len;

      for (t = 0, len = triangles.length; t < len; ++t) {
        var ii = triangles[t] * 3;

        for (var j = 0; j < 3; ++j) {
          var pi = indices[ii + j] * 3;

          if (positions[pi] < aabb[0]) {
            aabb[0] = positions[pi];
          }

          if (positions[pi] > aabb[3]) {
            aabb[3] = positions[pi];
          }

          if (positions[pi + 1] < aabb[1]) {
            aabb[1] = positions[pi + 1];
          }

          if (positions[pi + 1] > aabb[4]) {
            aabb[4] = positions[pi + 1];
          }

          if (positions[pi + 2] < aabb[2]) {
            aabb[2] = positions[pi + 2];
          }

          if (positions[pi + 2] > aabb[5]) {
            aabb[5] = positions[pi + 2];
          }
        }
      }

      if (triangles.length < KD_TREE_MIN_TRIANGLES || depth > KD_TREE_MAX_DEPTH) {
        node.triangles = triangles;
        node.leaf = true;
        return node;
      }

      dimLength[0] = aabb[3] - aabb[0];
      dimLength[1] = aabb[4] - aabb[1];
      dimLength[2] = aabb[5] - aabb[2];
      var dim = 0;

      if (dimLength[1] > dimLength[dim]) {
        dim = 1;
      }

      if (dimLength[2] > dimLength[dim]) {
        dim = 2;
      }

      node.splitDim = dim;
      var mid = (aabb[dim] + aabb[dim + 3]) / 2;
      var left = new Array(triangles.length);
      var numLeft = 0;
      var right = new Array(triangles.length);
      var numRight = 0;

      for (t = 0, len = triangles.length; t < len; ++t) {
        var ii = triangles[t] * 3;
        var i0 = indices[ii];
        var i1 = indices[ii + 1];
        var i2 = indices[ii + 2];
        var pi0 = i0 * 3;
        var pi1 = i1 * 3;
        var pi2 = i2 * 3;

        if (positions[pi0 + dim] <= mid || positions[pi1 + dim] <= mid || positions[pi2 + dim] <= mid) {
          left[numLeft++] = triangles[t];
        } else {
          right[numRight++] = triangles[t];
        }
      }

      left.length = numLeft;
      right.length = numRight;
      node.left = buildNode(left, indices, positions, depth + 1);
      node.right = buildNode(right, indices, positions, depth + 1);
      return node;
    }

    return function (indices, positions) {
      var numTris = indices.length / 3;
      var triangles = new Array(numTris);

      for (var i = 0; i < numTris; ++i) {
        triangles[i] = i;
      }

      return buildNode(triangles, indices, positions, 0);
    };
  }(),
  decompressPosition: function decompressPosition(position, decodeMatrix, dest) {
    dest = dest || position;
    dest[0] = position[0] * decodeMatrix[0] + decodeMatrix[12];
    dest[1] = position[1] * decodeMatrix[5] + decodeMatrix[13];
    dest[2] = position[2] * decodeMatrix[10] + decodeMatrix[14];
  },
  decompressPositions: function decompressPositions(positions, decodeMatrix) {
    var dest = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : new Float32Array(positions.length);

    for (var i = 0, len = positions.length; i < len; i += 3) {
      dest[i + 0] = positions[i + 0] * decodeMatrix[0] + decodeMatrix[12];
      dest[i + 1] = positions[i + 1] * decodeMatrix[5] + decodeMatrix[13];
      dest[i + 2] = positions[i + 2] * decodeMatrix[10] + decodeMatrix[14];
    }

    return dest;
  },
  decompressUV: function decompressUV(uv, decodeMatrix, dest) {
    dest[0] = uv[0] * decodeMatrix[0] + decodeMatrix[6];
    dest[1] = uv[1] * decodeMatrix[4] + decodeMatrix[7];
  },
  decompressUVs: function decompressUVs(uvs, decodeMatrix) {
    var dest = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : new Float32Array(uvs.length);

    for (var i = 0, len = uvs.length; i < len; i += 3) {
      dest[i + 0] = uvs[i + 0] * decodeMatrix[0] + decodeMatrix[6];
      dest[i + 1] = uvs[i + 1] * decodeMatrix[4] + decodeMatrix[7];
    }

    return dest;
  },
  octDecodeVec2: function octDecodeVec2(oct, result) {
    var x = oct[0];
    var y = oct[1];
    x = (2 * x + 1) / 255;
    y = (2 * y + 1) / 255;
    var z = 1 - Math.abs(x) - Math.abs(y);

    if (z < 0) {
      x = (1 - Math.abs(y)) * (x >= 0 ? 1 : -1);
      y = (1 - Math.abs(x)) * (y >= 0 ? 1 : -1);
    }

    var length = Math.sqrt(x * x + y * y + z * z);
    result[0] = x / length;
    result[1] = y / length;
    result[2] = z / length;
    return result;
  },
  octDecodeVec2s: function octDecodeVec2s(octs, result) {
    for (var i = 0, j = 0, len = octs.length; i < len; i += 2) {
      var x = octs[i + 0];
      var y = octs[i + 1];
      x = (2 * x + 1) / 255;
      y = (2 * y + 1) / 255;
      var z = 1 - Math.abs(x) - Math.abs(y);

      if (z < 0) {
        x = (1 - Math.abs(y)) * (x >= 0 ? 1 : -1);
        y = (1 - Math.abs(x)) * (y >= 0 ? 1 : -1);
      }

      var length = Math.sqrt(x * x + y * y + z * z);
      result[j + 0] = x / length;
      result[j + 1] = y / length;
      result[j + 2] = z / length;
      j += 3;
    }

    return result;
  }
};

math.buildEdgeIndices = function () {
  var uniquePositions = [];
  var indicesLookup = [];
  var indicesReverseLookup = [];
  var weldedIndices = []; // TODO: Optimize with caching, but need to cater to both compressed and uncompressed positions

  var faces = [];
  var numFaces = 0;
  var compa = new Uint16Array(3);
  var compb = new Uint16Array(3);
  var compc = new Uint16Array(3);
  var a = math.vec3();
  var b = math.vec3();
  var c = math.vec3();
  var cb = math.vec3();
  var ab = math.vec3();
  var cross = math.vec3();
  var normal = math.vec3();

  function weldVertices(positions, indices) {
    var positionsMap = {}; // Hashmap for looking up vertices by position coordinates (and making sure they are unique)

    var vx;
    var vy;
    var vz;
    var key;
    var precisionPoints = 4; // number of decimal points, e.g. 4 for epsilon of 0.0001

    var precision = Math.pow(10, precisionPoints);
    var i;
    var len;
    var lenUniquePositions = 0;

    for (i = 0, len = positions.length; i < len; i += 3) {
      vx = positions[i];
      vy = positions[i + 1];
      vz = positions[i + 2];
      key = Math.round(vx * precision) + '_' + Math.round(vy * precision) + '_' + Math.round(vz * precision);

      if (positionsMap[key] === undefined) {
        positionsMap[key] = lenUniquePositions / 3;
        uniquePositions[lenUniquePositions++] = vx;
        uniquePositions[lenUniquePositions++] = vy;
        uniquePositions[lenUniquePositions++] = vz;
      }

      indicesLookup[i / 3] = positionsMap[key];
    }

    for (i = 0, len = indices.length; i < len; i++) {
      weldedIndices[i] = indicesLookup[indices[i]];
      indicesReverseLookup[weldedIndices[i]] = indices[i];
    }
  }

  function buildFaces(numIndices, positionsDecodeMatrix) {
    numFaces = 0;

    for (var i = 0, len = numIndices; i < len; i += 3) {
      var ia = weldedIndices[i] * 3;
      var ib = weldedIndices[i + 1] * 3;
      var ic = weldedIndices[i + 2] * 3;

      if (positionsDecodeMatrix) {
        compa[0] = uniquePositions[ia];
        compa[1] = uniquePositions[ia + 1];
        compa[2] = uniquePositions[ia + 2];
        compb[0] = uniquePositions[ib];
        compb[1] = uniquePositions[ib + 1];
        compb[2] = uniquePositions[ib + 2];
        compc[0] = uniquePositions[ic];
        compc[1] = uniquePositions[ic + 1];
        compc[2] = uniquePositions[ic + 2]; // Decode

        math.decompressPosition(compa, positionsDecodeMatrix, a);
        math.decompressPosition(compb, positionsDecodeMatrix, b);
        math.decompressPosition(compc, positionsDecodeMatrix, c);
      } else {
        a[0] = uniquePositions[ia];
        a[1] = uniquePositions[ia + 1];
        a[2] = uniquePositions[ia + 2];
        b[0] = uniquePositions[ib];
        b[1] = uniquePositions[ib + 1];
        b[2] = uniquePositions[ib + 2];
        c[0] = uniquePositions[ic];
        c[1] = uniquePositions[ic + 1];
        c[2] = uniquePositions[ic + 2];
      }

      math.subVec3(c, b, cb);
      math.subVec3(a, b, ab);
      math.cross3Vec3(cb, ab, cross);
      math.normalizeVec3(cross, normal);
      var face = faces[numFaces] || (faces[numFaces] = {
        normal: math.vec3()
      });
      face.normal[0] = normal[0];
      face.normal[1] = normal[1];
      face.normal[2] = normal[2];
      numFaces++;
    }
  }

  return function (positions, indices, positionsDecodeMatrix, edgeThreshold) {
    weldVertices(positions, indices);
    buildFaces(indices.length, positionsDecodeMatrix);
    var edgeIndices = [];
    var thresholdDot = Math.cos(math.DEGTORAD * edgeThreshold);
    var edges = {};
    var edge1;
    var edge2;
    var index1;
    var index2;
    var key;
    var largeIndex = false;
    var edge;
    var normal1;
    var normal2;
    var dot;
    var ia;
    var ib;

    for (var i = 0, len = indices.length; i < len; i += 3) {
      var faceIndex = i / 3;

      for (var j = 0; j < 3; j++) {
        edge1 = weldedIndices[i + j];
        edge2 = weldedIndices[i + (j + 1) % 3];
        index1 = Math.min(edge1, edge2);
        index2 = Math.max(edge1, edge2);
        key = index1 + "," + index2;

        if (edges[key] === undefined) {
          edges[key] = {
            index1: index1,
            index2: index2,
            face1: faceIndex,
            face2: undefined
          };
        } else {
          edges[key].face2 = faceIndex;
        }
      }
    }

    for (key in edges) {
      edge = edges[key]; // an edge is only rendered if the angle (in degrees) between the face normals of the adjoining faces exceeds this value. default = 1 degree.

      if (edge.face2 !== undefined) {
        normal1 = faces[edge.face1].normal;
        normal2 = faces[edge.face2].normal;
        dot = math.dotVec3(normal1, normal2);

        if (dot > thresholdDot) {
          continue;
        }
      }

      ia = indicesReverseLookup[edge.index1];
      ib = indicesReverseLookup[edge.index2];

      if (!largeIndex && ia > 65535 || ib > 65535) {
        largeIndex = true;
      }

      edgeIndices.push(ia);
      edgeIndices.push(ib);
    }

    return largeIndex ? new Uint32Array(edgeIndices) : new Uint16Array(edgeIndices);
  };
}();

math.vec3();

math.vec3();
math.vec3();
math.vec3();
math.vec3();
math.vec3();

new Map({});

/**
 * @private
 */

(function () {
  var uniquePositions = [];
  var indicesLookup = [];
  var indicesReverseLookup = [];
  var weldedIndices = []; // TODO: Optimize with caching, but need to cater to both compressed and uncompressed positions

  var faces = [];
  var numFaces = 0;
  var compa = new Uint16Array(3);
  var compb = new Uint16Array(3);
  var compc = new Uint16Array(3);
  var a = math.vec3();
  var b = math.vec3();
  var c = math.vec3();
  var cb = math.vec3();
  var ab = math.vec3();
  var cross = math.vec3();
  var normal = math.vec3();

  function weldVertices(positions, indices) {
    var positionsMap = {}; // Hashmap for looking up vertices by position coordinates (and making sure they are unique)

    var vx;
    var vy;
    var vz;
    var key;
    var precisionPoints = 4; // number of decimal points, e.g. 4 for epsilon of 0.0001

    var precision = Math.pow(10, precisionPoints);
    var i;
    var len;
    var lenUniquePositions = 0;

    for (i = 0, len = positions.length; i < len; i += 3) {
      vx = positions[i];
      vy = positions[i + 1];
      vz = positions[i + 2];
      key = Math.round(vx * precision) + '_' + Math.round(vy * precision) + '_' + Math.round(vz * precision);

      if (positionsMap[key] === undefined) {
        positionsMap[key] = lenUniquePositions / 3;
        uniquePositions[lenUniquePositions++] = vx;
        uniquePositions[lenUniquePositions++] = vy;
        uniquePositions[lenUniquePositions++] = vz;
      }

      indicesLookup[i / 3] = positionsMap[key];
    }

    for (i = 0, len = indices.length; i < len; i++) {
      weldedIndices[i] = indicesLookup[indices[i]];
      indicesReverseLookup[weldedIndices[i]] = indices[i];
    }
  }

  function buildFaces(numIndices, positionsDecodeMatrix) {
    numFaces = 0;

    for (var i = 0, len = numIndices; i < len; i += 3) {
      var ia = weldedIndices[i] * 3;
      var ib = weldedIndices[i + 1] * 3;
      var ic = weldedIndices[i + 2] * 3;

      if (positionsDecodeMatrix) {
        compa[0] = uniquePositions[ia];
        compa[1] = uniquePositions[ia + 1];
        compa[2] = uniquePositions[ia + 2];
        compb[0] = uniquePositions[ib];
        compb[1] = uniquePositions[ib + 1];
        compb[2] = uniquePositions[ib + 2];
        compc[0] = uniquePositions[ic];
        compc[1] = uniquePositions[ic + 1];
        compc[2] = uniquePositions[ic + 2]; // Decode

        math.decompressPosition(compa, positionsDecodeMatrix, a);
        math.decompressPosition(compb, positionsDecodeMatrix, b);
        math.decompressPosition(compc, positionsDecodeMatrix, c);
      } else {
        a[0] = uniquePositions[ia];
        a[1] = uniquePositions[ia + 1];
        a[2] = uniquePositions[ia + 2];
        b[0] = uniquePositions[ib];
        b[1] = uniquePositions[ib + 1];
        b[2] = uniquePositions[ib + 2];
        c[0] = uniquePositions[ic];
        c[1] = uniquePositions[ic + 1];
        c[2] = uniquePositions[ic + 2];
      }

      math.subVec3(c, b, cb);
      math.subVec3(a, b, ab);
      math.cross3Vec3(cb, ab, cross);
      math.normalizeVec3(cross, normal);
      var face = faces[numFaces] || (faces[numFaces] = {
        normal: math.vec3()
      });
      face.normal[0] = normal[0];
      face.normal[1] = normal[1];
      face.normal[2] = normal[2];
      numFaces++;
    }
  }

  return function (positions, indices, positionsDecodeMatrix, edgeThreshold) {
    weldVertices(positions, indices);
    buildFaces(indices.length, positionsDecodeMatrix);
    var edgeIndices = [];
    var thresholdDot = Math.cos(math.DEGTORAD * edgeThreshold);
    var edges = {};
    var edge1;
    var edge2;
    var index1;
    var index2;
    var key;
    var largeIndex = false;
    var edge;
    var normal1;
    var normal2;
    var dot;
    var ia;
    var ib;

    for (var i = 0, len = indices.length; i < len; i += 3) {
      var faceIndex = i / 3;

      for (var j = 0; j < 3; j++) {
        edge1 = weldedIndices[i + j];
        edge2 = weldedIndices[i + (j + 1) % 3];
        index1 = Math.min(edge1, edge2);
        index2 = Math.max(edge1, edge2);
        key = index1 + "," + index2;

        if (edges[key] === undefined) {
          edges[key] = {
            index1: index1,
            index2: index2,
            face1: faceIndex,
            face2: undefined
          };
        } else {
          edges[key].face2 = faceIndex;
        }
      }
    }

    for (key in edges) {
      edge = edges[key]; // an edge is only rendered if the angle (in degrees) between the face normals of the adjoining faces exceeds this value. default = 1 degree.

      if (edge.face2 !== undefined) {
        normal1 = faces[edge.face1].normal;
        normal2 = faces[edge.face2].normal;
        dot = math.dotVec3(normal1, normal2);

        if (dot > thresholdDot) {
          continue;
        }
      }

      ia = indicesReverseLookup[edge.index1];
      ib = indicesReverseLookup[edge.index2];

      if (!largeIndex && ia > 65535 || ib > 65535) {
        largeIndex = true;
      }

      edgeIndices.push(ia);
      edgeIndices.push(ib);
    }

    return largeIndex ? new Uint32Array(edgeIndices) : new Uint16Array(edgeIndices);
  };
})();

/**
 * Private geometry compression and decompression utilities.
 */
/**
 * @private
 * @param array
 * @returns {{min: Float32Array, max: Float32Array}}
 */

function getPositionsBounds(array) {
  var min = new Float32Array(3);
  var max = new Float32Array(3);
  var i, j;

  for (i = 0; i < 3; i++) {
    min[i] = Number.MAX_VALUE;
    max[i] = -Number.MAX_VALUE;
  }

  for (i = 0; i < array.length; i += 3) {
    for (j = 0; j < 3; j++) {
      min[j] = Math.min(min[j], array[i + j]);
      max[j] = Math.max(max[j], array[i + j]);
    }
  }

  return {
    min: min,
    max: max
  };
}

var createPositionsDecodeMatrix = function () {
  var translate = math.mat4();
  var scale = math.mat4();
  return function (aabb, positionsDecodeMatrix) {
    positionsDecodeMatrix = positionsDecodeMatrix || math.mat4();
    var xmin = aabb[0];
    var ymin = aabb[1];
    var zmin = aabb[2];
    var xwid = aabb[3] - xmin;
    var ywid = aabb[4] - ymin;
    var zwid = aabb[5] - zmin;
    var maxInt = 65535;
    math.identityMat4(translate);
    math.translationMat4v(aabb, translate);
    math.identityMat4(scale);
    math.scalingMat4v([xwid / maxInt, ywid / maxInt, zwid / maxInt], scale);
    math.mulMat4(translate, scale, positionsDecodeMatrix);
    return positionsDecodeMatrix;
  };
}();
/**
 * @private
 */


var compressPositions = function () {
  // http://cg.postech.ac.kr/research/mesh_comp_mobile/mesh_comp_mobile_conference.pdf
  var translate = math.mat4();
  var scale = math.mat4();
  return function (array, min, max) {
    var quantized = new Uint16Array(array.length);
    var multiplier = new Float32Array([max[0] !== min[0] ? 65535 / (max[0] - min[0]) : 0, max[1] !== min[1] ? 65535 / (max[1] - min[1]) : 0, max[2] !== min[2] ? 65535 / (max[2] - min[2]) : 0]);
    var i;

    for (i = 0; i < array.length; i += 3) {
      quantized[i + 0] = Math.max(0, Math.min(65535, Math.floor((array[i + 0] - min[0]) * multiplier[0])));
      quantized[i + 1] = Math.max(0, Math.min(65535, Math.floor((array[i + 1] - min[1]) * multiplier[1])));
      quantized[i + 2] = Math.max(0, Math.min(65535, Math.floor((array[i + 2] - min[2]) * multiplier[2])));
    }

    math.identityMat4(translate);
    math.translationMat4v(min, translate);
    math.identityMat4(scale);
    math.scalingMat4v([(max[0] - min[0]) / 65535, (max[1] - min[1]) / 65535, (max[2] - min[2]) / 65535], scale);
    var decodeMat = math.mulMat4(translate, scale, math.identityMat4());
    return {
      quantized: quantized,
      decodeMatrix: decodeMat
    };
  };
}();

function compressPosition(p, aabb, q) {
  var multiplier = new Float32Array([aabb[3] !== aabb[0] ? 65535 / (aabb[3] - aabb[0]) : 0, aabb[4] !== aabb[1] ? 65535 / (aabb[4] - aabb[1]) : 0, aabb[5] !== aabb[2] ? 65535 / (aabb[5] - aabb[2]) : 0]);
  q[0] = Math.max(0, Math.min(65535, Math.floor((p[0] - aabb[0]) * multiplier[0])));
  q[1] = Math.max(0, Math.min(65535, Math.floor((p[1] - aabb[1]) * multiplier[1])));
  q[2] = Math.max(0, Math.min(65535, Math.floor((p[2] - aabb[2]) * multiplier[2])));
}

function decompressPosition(position, decodeMatrix, dest) {
  dest[0] = position[0] * decodeMatrix[0] + decodeMatrix[12];
  dest[1] = position[1] * decodeMatrix[5] + decodeMatrix[13];
  dest[2] = position[2] * decodeMatrix[10] + decodeMatrix[14];
  return dest;
}

function decompressAABB(aabb, decodeMatrix) {
  var dest = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : aabb;
  dest[0] = aabb[0] * decodeMatrix[0] + decodeMatrix[12];
  dest[1] = aabb[1] * decodeMatrix[5] + decodeMatrix[13];
  dest[2] = aabb[2] * decodeMatrix[10] + decodeMatrix[14];
  dest[3] = aabb[3] * decodeMatrix[0] + decodeMatrix[12];
  dest[4] = aabb[4] * decodeMatrix[5] + decodeMatrix[13];
  dest[5] = aabb[5] * decodeMatrix[10] + decodeMatrix[14];
  return dest;
}
/**
 * @private
 */


function decompressPositions(positions, decodeMatrix) {
  var dest = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : new Float32Array(positions.length);

  for (var i = 0, len = positions.length; i < len; i += 3) {
    dest[i + 0] = positions[i + 0] * decodeMatrix[0] + decodeMatrix[12];
    dest[i + 1] = positions[i + 1] * decodeMatrix[5] + decodeMatrix[13];
    dest[i + 2] = positions[i + 2] * decodeMatrix[10] + decodeMatrix[14];
  }

  return dest;
} //--------------- UVs --------------------------------------------------------------------------------------------------

/**
 * @private
 * @param array
 * @returns {{min: Float32Array, max: Float32Array}}
 */


function getUVBounds(array) {
  var min = new Float32Array(2);
  var max = new Float32Array(2);
  var i, j;

  for (i = 0; i < 2; i++) {
    min[i] = Number.MAX_VALUE;
    max[i] = -Number.MAX_VALUE;
  }

  for (i = 0; i < array.length; i += 2) {
    for (j = 0; j < 2; j++) {
      min[j] = Math.min(min[j], array[i + j]);
      max[j] = Math.max(max[j], array[i + j]);
    }
  }

  return {
    min: min,
    max: max
  };
}
/**
 * @private
 */


var compressUVs = function () {
  var translate = math.mat3();
  var scale = math.mat3();
  return function (array, min, max) {
    var quantized = new Uint16Array(array.length);
    var multiplier = new Float32Array([65535 / (max[0] - min[0]), 65535 / (max[1] - min[1])]);
    var i;

    for (i = 0; i < array.length; i += 2) {
      quantized[i + 0] = Math.max(0, Math.min(65535, Math.floor((array[i + 0] - min[0]) * multiplier[0])));
      quantized[i + 1] = Math.max(0, Math.min(65535, Math.floor((array[i + 1] - min[1]) * multiplier[1])));
    }

    math.identityMat3(translate);
    math.translationMat3v(min, translate);
    math.identityMat3(scale);
    math.scalingMat3v([(max[0] - min[0]) / 65535, (max[1] - min[1]) / 65535], scale);
    var decodeMat = math.mulMat3(translate, scale, math.identityMat3());
    return {
      quantized: quantized,
      decodeMatrix: decodeMat
    };
  };
}(); //--------------- Normals ----------------------------------------------------------------------------------------------

/**
 * @private
 */


function compressNormals(array) {
  // http://jcgt.org/published/0003/02/01/
  // Note: three elements for each encoded normal, in which the last element in each triplet is redundant.
  // This is to work around a mysterious WebGL issue where 2-element normals just wouldn't work in the shader :/
  var encoded = new Int8Array(array.length);
  var oct, dec, best, currentCos, bestCos;

  for (var i = 0; i < array.length; i += 3) {
    // Test various combinations of ceil and floor
    // to minimize rounding errors
    best = oct = octEncodeVec3(array, i, "floor", "floor");
    dec = octDecodeVec2(oct);
    currentCos = bestCos = dot(array, i, dec);
    oct = octEncodeVec3(array, i, "ceil", "floor");
    dec = octDecodeVec2(oct);
    currentCos = dot(array, i, dec);

    if (currentCos > bestCos) {
      best = oct;
      bestCos = currentCos;
    }

    oct = octEncodeVec3(array, i, "floor", "ceil");
    dec = octDecodeVec2(oct);
    currentCos = dot(array, i, dec);

    if (currentCos > bestCos) {
      best = oct;
      bestCos = currentCos;
    }

    oct = octEncodeVec3(array, i, "ceil", "ceil");
    dec = octDecodeVec2(oct);
    currentCos = dot(array, i, dec);

    if (currentCos > bestCos) {
      best = oct;
      bestCos = currentCos;
    }

    encoded[i] = best[0];
    encoded[i + 1] = best[1];
  }

  return encoded;
}
/**
 * @private
 */


function octEncodeVec3(array, i, xfunc, yfunc) {
  // Oct-encode single normal vector in 2 bytes
  var x = array[i] / (Math.abs(array[i]) + Math.abs(array[i + 1]) + Math.abs(array[i + 2]));
  var y = array[i + 1] / (Math.abs(array[i]) + Math.abs(array[i + 1]) + Math.abs(array[i + 2]));

  if (array[i + 2] < 0) {
    var tempx = (1 - Math.abs(y)) * (x >= 0 ? 1 : -1);
    var tempy = (1 - Math.abs(x)) * (y >= 0 ? 1 : -1);
    x = tempx;
    y = tempy;
  }

  return new Int8Array([Math[xfunc](x * 127.5 + (x < 0 ? -1 : 0)), Math[yfunc](y * 127.5 + (y < 0 ? -1 : 0))]);
}
/**
 * Decode an oct-encoded normal
 */


function octDecodeVec2(oct) {
  var x = oct[0];
  var y = oct[1];
  x /= x < 0 ? 127 : 128;
  y /= y < 0 ? 127 : 128;
  var z = 1 - Math.abs(x) - Math.abs(y);

  if (z < 0) {
    x = (1 - Math.abs(y)) * (x >= 0 ? 1 : -1);
    y = (1 - Math.abs(x)) * (y >= 0 ? 1 : -1);
  }

  var length = Math.sqrt(x * x + y * y + z * z);
  return [x / length, y / length, z / length];
}
/**
 * Dot product of a normal in an array against a candidate decoding
 * @private
 */


function dot(array, i, vec3) {
  return array[i] * vec3[0] + array[i + 1] * vec3[1] + array[i + 2] * vec3[2];
}
/**
 * @private
 */


function decompressUV(uv, decodeMatrix, dest) {
  dest[0] = uv[0] * decodeMatrix[0] + decodeMatrix[6];
  dest[1] = uv[1] * decodeMatrix[4] + decodeMatrix[7];
}
/**
 * @private
 */


function decompressUVs(uvs, decodeMatrix) {
  var dest = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : new Float32Array(uvs.length);

  for (var i = 0, len = uvs.length; i < len; i += 3) {
    dest[i + 0] = uvs[i + 0] * decodeMatrix[0] + decodeMatrix[6];
    dest[i + 1] = uvs[i + 1] * decodeMatrix[4] + decodeMatrix[7];
  }

  return dest;
}
/**
 * @private
 */


function decompressNormal(oct, result) {
  var x = oct[0];
  var y = oct[1];
  x = (2 * x + 1) / 255;
  y = (2 * y + 1) / 255;
  var z = 1 - Math.abs(x) - Math.abs(y);

  if (z < 0) {
    x = (1 - Math.abs(y)) * (x >= 0 ? 1 : -1);
    y = (1 - Math.abs(x)) * (y >= 0 ? 1 : -1);
  }

  var length = Math.sqrt(x * x + y * y + z * z);
  result[0] = x / length;
  result[1] = y / length;
  result[2] = z / length;
  return result;
}
/**
 * @private
 */


function decompressNormals(octs, result) {
  for (var i = 0, j = 0, len = octs.length; i < len; i += 2) {
    var x = octs[i + 0];
    var y = octs[i + 1];
    x = (2 * x + 1) / 255;
    y = (2 * y + 1) / 255;
    var z = 1 - Math.abs(x) - Math.abs(y);

    if (z < 0) {
      x = (1 - Math.abs(y)) * (x >= 0 ? 1 : -1);
      y = (1 - Math.abs(x)) * (y >= 0 ? 1 : -1);
    }

    var length = Math.sqrt(x * x + y * y + z * z);
    result[j + 0] = x / length;
    result[j + 1] = y / length;
    result[j + 2] = z / length;
    j += 3;
  }

  return result;
}
/**
 * @private
 */


var geometryCompressionUtils = {
  getPositionsBounds: getPositionsBounds,
  createPositionsDecodeMatrix: createPositionsDecodeMatrix,
  compressPositions: compressPositions,
  compressPosition: compressPosition,
  decompressPositions: decompressPositions,
  decompressPosition: decompressPosition,
  decompressAABB: decompressAABB,
  getUVBounds: getUVBounds,
  compressUVs: compressUVs,
  decompressUVs: decompressUVs,
  decompressUV: decompressUV,
  compressNormals: compressNormals,
  decompressNormals: decompressNormals,
  decompressNormal: decompressNormal
};

math.AABB3();

math.AABB3();

/**
 * @private
 */
var K3D = {};

K3D.load = function (path, resp) {
  var request = new XMLHttpRequest();
  request.open("GET", path, true);
  request.responseType = "arraybuffer";

  request.onload = function (e) {
    resp(e.target.response);
  };

  request.send();
};

K3D.save = function (buff, path) {
  var dataURI = "data:application/octet-stream;base64," + btoa(K3D.parse._buffToStr(buff));
  window.location.href = dataURI;
};

K3D.clone = function (o) {
  return JSON.parse(JSON.stringify(o));
};

K3D.bin = {};
K3D.bin.f = new Float32Array(1);
K3D.bin.fb = new Uint8Array(K3D.bin.f.buffer);

K3D.bin.rf = function (buff, off) {
  var f = K3D.bin.f,
      fb = K3D.bin.fb;

  for (var i = 0; i < 4; i++) {
    fb[i] = buff[off + i];
  }

  return f[0];
};

K3D.bin.rsl = function (buff, off) {
  return buff[off] | buff[off + 1] << 8;
};

K3D.bin.ril = function (buff, off) {
  return buff[off] | buff[off + 1] << 8 | buff[off + 2] << 16 | buff[off + 3] << 24;
};

K3D.bin.rASCII0 = function (buff, off) {
  var s = "";

  while (buff[off] != 0) {
    s += String.fromCharCode(buff[off++]);
  }

  return s;
};

K3D.bin.wf = function (buff, off, v) {
  var f = new Float32Array(buff.buffer, off, 1);
  f[0] = v;
};

K3D.bin.wsl = function (buff, off, v) {
  buff[off] = v;
  buff[off + 1] = v >> 8;
};

K3D.bin.wil = function (buff, off, v) {
  buff[off] = v;
  buff[off + 1] = v >> 8;
  buff[off + 2] = v >> 16;
  buff[off + 3] >> 24;
};

K3D.parse = {};

K3D.parse._buffToStr = function (buff) {
  var a = new Uint8Array(buff);
  var s = "";

  for (var i = 0; i < a.length; i++) {
    s = s.concat(String.fromCharCode(a[i]));
  }

  return s;
};

K3D.parse._strToBuff = function (str) {
  var buf = new ArrayBuffer(str.length);
  var bufView = new Uint8Array(buf);

  for (var i = 0; i < str.length; i++) {
    bufView[i] = str.charCodeAt(i);
  }

  return buf;
};

K3D.parse._readLine = function (a, off) // Uint8Array, offset
{
  var s = "";

  while (a[off] != 10) {
    s += String.fromCharCode(a[off++]);
  }

  return s;
};

K3D.parse.fromJSON = function (buff) {
  var json = JSON.parse(K3D.parse._buffToStr(buff));
  return json;
};

K3D.parse.toJSON = function (object) {
  var str = JSON.stringify(object);
  return K3D.parse._strToBuff(str);
};

K3D.parse.fromOBJ = function (buff) {
  var res = {};
  res.groups = {};
  res.c_verts = [];
  res.c_uvt = [];
  res.c_norms = [];
  res.i_verts = [];
  res.i_uvt = [];
  res.i_norms = [];
  var cg = {
    from: 0,
    to: 0
  }; // current group

  var off = 0;
  var a = new Uint8Array(buff);

  while (off < a.length) {
    var line = K3D.parse._readLine(a, off);

    off += line.length + 1;
    line = line.replace(/ +(?= )/g, '');
    line = line.replace(/(^\s+|\s+$)/g, '');
    var cds = line.split(" ");

    if (cds[0] == "g") {
      cg.to = res.i_verts.length;
      if (res.groups[cds[1]] == null) res.groups[cds[1]] = {
        from: res.i_verts.length,
        to: 0
      };
      cg = res.groups[cds[1]];
    }

    if (cds[0] == "v") {
      var x = parseFloat(cds[1]);
      var y = parseFloat(cds[2]);
      var z = parseFloat(cds[3]);
      res.c_verts.push(x, y, z);
    }

    if (cds[0] == "vt") {
      var x = parseFloat(cds[1]);
      var y = 1 - parseFloat(cds[2]);
      res.c_uvt.push(x, y);
    }

    if (cds[0] == "vn") {
      var x = parseFloat(cds[1]);
      var y = parseFloat(cds[2]);
      var z = parseFloat(cds[3]);
      res.c_norms.push(x, y, z);
    }

    if (cds[0] == "f") {
      var v0a = cds[1].split("/"),
          v1a = cds[2].split("/"),
          v2a = cds[3].split("/");
      var vi0 = parseInt(v0a[0]) - 1,
          vi1 = parseInt(v1a[0]) - 1,
          vi2 = parseInt(v2a[0]) - 1;
      var ui0 = parseInt(v0a[1]) - 1,
          ui1 = parseInt(v1a[1]) - 1,
          ui2 = parseInt(v2a[1]) - 1;
      var ni0 = parseInt(v0a[2]) - 1,
          ni1 = parseInt(v1a[2]) - 1,
          ni2 = parseInt(v2a[2]) - 1;
      var vlen = res.c_verts.length / 3,
          ulen = res.c_uvt.length / 2,
          nlen = res.c_norms.length / 3;
      if (vi0 < 0) vi0 = vlen + vi0 + 1;
      if (vi1 < 0) vi1 = vlen + vi1 + 1;
      if (vi2 < 0) vi2 = vlen + vi2 + 1;
      if (ui0 < 0) ui0 = ulen + ui0 + 1;
      if (ui1 < 0) ui1 = ulen + ui1 + 1;
      if (ui2 < 0) ui2 = ulen + ui2 + 1;
      if (ni0 < 0) ni0 = nlen + ni0 + 1;
      if (ni1 < 0) ni1 = nlen + ni1 + 1;
      if (ni2 < 0) ni2 = nlen + ni2 + 1;
      res.i_verts.push(vi0, vi1, vi2); //cg.i_verts.push(vi0, vi1, vi2)

      res.i_uvt.push(ui0, ui1, ui2); //cg.i_uvt  .push(ui0, ui1, ui2);

      res.i_norms.push(ni0, ni1, ni2); //cg.i_norms.push(ni0, ni1, ni2);

      if (cds.length == 5) {
        var v3a = cds[4].split("/");
        var vi3 = parseInt(v3a[0]) - 1,
            ui3 = parseInt(v3a[1]) - 1,
            ni3 = parseInt(v3a[2]) - 1;
        if (vi3 < 0) vi3 = vlen + vi3 + 1;
        if (ui3 < 0) ui3 = ulen + ui3 + 1;
        if (ni3 < 0) ni3 = nlen + ni3 + 1;
        res.i_verts.push(vi0, vi2, vi3); //cg.i_verts.push(vi0, vi2, vi3);

        res.i_uvt.push(ui0, ui2, ui3); //cg.i_uvt  .push(ui0, ui2, ui3);

        res.i_norms.push(ni0, ni2, ni3); //cg.i_norms.push(ni0, ni2, ni3);
      }
    }
  }

  cg.to = res.i_verts.length;
  return res;
};

K3D.parse.fromMD2 = function (buff) {
  buff = new Uint8Array(buff);
  var res = {};
  var head = {}; //res.head = head;

  head.ident = K3D.bin.ril(buff, 0);
  /* magic number: "IDP2" */

  head.version = K3D.bin.ril(buff, 4);
  /* version: must be 8 */

  head.skinwidth = K3D.bin.ril(buff, 8);
  /* texture width */

  head.skinheight = K3D.bin.ril(buff, 12);
  /* texture height */

  head.framesize = K3D.bin.ril(buff, 16);
  /* size in bytes of a frame */

  head.num_skins = K3D.bin.ril(buff, 20);
  /* number of skins */

  head.num_vertices = K3D.bin.ril(buff, 24);
  /* number of vertices per frame */

  head.num_st = K3D.bin.ril(buff, 28);
  /* number of texture coordinates */

  head.num_tris = K3D.bin.ril(buff, 32);
  /* number of triangles */

  head.num_glcmds = K3D.bin.ril(buff, 36);
  /* number of opengl commands */

  head.num_frames = K3D.bin.ril(buff, 40);
  /* number of frames */

  head.offset_skins = K3D.bin.ril(buff, 44);
  /* offset skin data */

  head.offset_st = K3D.bin.ril(buff, 48);
  /* offset texture coordinate data */

  head.offset_tris = K3D.bin.ril(buff, 52);
  /* offset triangle data */

  head.offset_frames = K3D.bin.ril(buff, 56);
  /* offset frame data */

  head.offset_glcmds = K3D.bin.ril(buff, 60);
  /* offset OpenGL command data */

  head.offset_end = K3D.bin.ril(buff, 64);
  /* offset end of file */

  var off = head.offset_st;
  res.c_uvt = [];

  for (var i = 0; i < head.num_st; i++) {
    var x = K3D.bin.rsl(buff, off) / head.skinwidth;
    var y = K3D.bin.rsl(buff, off + 2) / head.skinheight;
    res.c_uvt.push(x, y);
    off += 4;
  }

  var off = head.offset_tris;
  var vi = [],
      ti = [];
  res.i_verts = vi;
  res.i_uvt = ti; //res.tris = {i_verts : vi, i_uvt : ti};

  for (var i = 0; i < head.num_tris; i++) {
    vi.push(K3D.bin.rsl(buff, off), K3D.bin.rsl(buff, off + 2), K3D.bin.rsl(buff, off + 4));
    ti.push(K3D.bin.rsl(buff, off + 6), K3D.bin.rsl(buff, off + 8), K3D.bin.rsl(buff, off + 10));
    off += 12;
  }

  var off = head.offset_skins;
  res.skins = [];

  for (var i = 0; i < head.num_skins; i++) {
    res.skins.push(K3D.bin.rASCII0(buff, off));
    off += 64;
  }

  var off = head.offset_frames;
  res.frames = [];
  var nms = K3D.parse.fromMD2._normals;

  for (var i = 0; i < head.num_frames; i++) {
    var fr = {};
    var sx = K3D.bin.rf(buff, off),
        sy = K3D.bin.rf(buff, off + 4),
        sz = K3D.bin.rf(buff, off + 8);
    off += 12;
    var tx = K3D.bin.rf(buff, off),
        ty = K3D.bin.rf(buff, off + 4),
        tz = K3D.bin.rf(buff, off + 8);
    off += 12;
    fr.name = K3D.bin.rASCII0(buff, off);
    off += 16;
    fr.verts = [];
    fr.norms = [];

    for (var j = 0; j < head.num_vertices; j++) {
      fr.verts.push(buff[off] * sx + tx, buff[off + 1] * sy + ty, buff[off + 2] * sz + tz);
      fr.norms.push(nms[3 * buff[off + 3]], nms[3 * buff[off + 3] + 1], nms[3 * buff[off + 3] + 2]);
      off += 4;
    }

    res.frames.push(fr);
  }

  return res;
};
/*
 static MD2 normals
 */


K3D.parse.fromMD2._normals = [-0.525731, 0.000000, 0.850651, -0.442863, 0.238856, 0.864188, -0.295242, 0.000000, 0.955423, -0.309017, 0.500000, 0.809017, -0.162460, 0.262866, 0.951056, 0.000000, 0.000000, 1.000000, 0.000000, 0.850651, 0.525731, -0.147621, 0.716567, 0.681718, 0.147621, 0.716567, 0.681718, 0.000000, 0.525731, 0.850651, 0.309017, 0.500000, 0.809017, 0.525731, 0.000000, 0.850651, 0.295242, 0.000000, 0.955423, 0.442863, 0.238856, 0.864188, 0.162460, 0.262866, 0.951056, -0.681718, 0.147621, 0.716567, -0.809017, 0.309017, 0.500000, -0.587785, 0.425325, 0.688191, -0.850651, 0.525731, 0.000000, -0.864188, 0.442863, 0.238856, -0.716567, 0.681718, 0.147621, -0.688191, 0.587785, 0.425325, -0.500000, 0.809017, 0.309017, -0.238856, 0.864188, 0.442863, -0.425325, 0.688191, 0.587785, -0.716567, 0.681718, -0.147621, -0.500000, 0.809017, -0.309017, -0.525731, 0.850651, 0.000000, 0.000000, 0.850651, -0.525731, -0.238856, 0.864188, -0.442863, 0.000000, 0.955423, -0.295242, -0.262866, 0.951056, -0.162460, 0.000000, 1.000000, 0.000000, 0.000000, 0.955423, 0.295242, -0.262866, 0.951056, 0.162460, 0.238856, 0.864188, 0.442863, 0.262866, 0.951056, 0.162460, 0.500000, 0.809017, 0.309017, 0.238856, 0.864188, -0.442863, 0.262866, 0.951056, -0.162460, 0.500000, 0.809017, -0.309017, 0.850651, 0.525731, 0.000000, 0.716567, 0.681718, 0.147621, 0.716567, 0.681718, -0.147621, 0.525731, 0.850651, 0.000000, 0.425325, 0.688191, 0.587785, 0.864188, 0.442863, 0.238856, 0.688191, 0.587785, 0.425325, 0.809017, 0.309017, 0.500000, 0.681718, 0.147621, 0.716567, 0.587785, 0.425325, 0.688191, 0.955423, 0.295242, 0.000000, 1.000000, 0.000000, 0.000000, 0.951056, 0.162460, 0.262866, 0.850651, -0.525731, 0.000000, 0.955423, -0.295242, 0.000000, 0.864188, -0.442863, 0.238856, 0.951056, -0.162460, 0.262866, 0.809017, -0.309017, 0.500000, 0.681718, -0.147621, 0.716567, 0.850651, 0.000000, 0.525731, 0.864188, 0.442863, -0.238856, 0.809017, 0.309017, -0.500000, 0.951056, 0.162460, -0.262866, 0.525731, 0.000000, -0.850651, 0.681718, 0.147621, -0.716567, 0.681718, -0.147621, -0.716567, 0.850651, 0.000000, -0.525731, 0.809017, -0.309017, -0.500000, 0.864188, -0.442863, -0.238856, 0.951056, -0.162460, -0.262866, 0.147621, 0.716567, -0.681718, 0.309017, 0.500000, -0.809017, 0.425325, 0.688191, -0.587785, 0.442863, 0.238856, -0.864188, 0.587785, 0.425325, -0.688191, 0.688191, 0.587785, -0.425325, -0.147621, 0.716567, -0.681718, -0.309017, 0.500000, -0.809017, 0.000000, 0.525731, -0.850651, -0.525731, 0.000000, -0.850651, -0.442863, 0.238856, -0.864188, -0.295242, 0.000000, -0.955423, -0.162460, 0.262866, -0.951056, 0.000000, 0.000000, -1.000000, 0.295242, 0.000000, -0.955423, 0.162460, 0.262866, -0.951056, -0.442863, -0.238856, -0.864188, -0.309017, -0.500000, -0.809017, -0.162460, -0.262866, -0.951056, 0.000000, -0.850651, -0.525731, -0.147621, -0.716567, -0.681718, 0.147621, -0.716567, -0.681718, 0.000000, -0.525731, -0.850651, 0.309017, -0.500000, -0.809017, 0.442863, -0.238856, -0.864188, 0.162460, -0.262866, -0.951056, 0.238856, -0.864188, -0.442863, 0.500000, -0.809017, -0.309017, 0.425325, -0.688191, -0.587785, 0.716567, -0.681718, -0.147621, 0.688191, -0.587785, -0.425325, 0.587785, -0.425325, -0.688191, 0.000000, -0.955423, -0.295242, 0.000000, -1.000000, 0.000000, 0.262866, -0.951056, -0.162460, 0.000000, -0.850651, 0.525731, 0.000000, -0.955423, 0.295242, 0.238856, -0.864188, 0.442863, 0.262866, -0.951056, 0.162460, 0.500000, -0.809017, 0.309017, 0.716567, -0.681718, 0.147621, 0.525731, -0.850651, 0.000000, -0.238856, -0.864188, -0.442863, -0.500000, -0.809017, -0.309017, -0.262866, -0.951056, -0.162460, -0.850651, -0.525731, 0.000000, -0.716567, -0.681718, -0.147621, -0.716567, -0.681718, 0.147621, -0.525731, -0.850651, 0.000000, -0.500000, -0.809017, 0.309017, -0.238856, -0.864188, 0.442863, -0.262866, -0.951056, 0.162460, -0.864188, -0.442863, 0.238856, -0.809017, -0.309017, 0.500000, -0.688191, -0.587785, 0.425325, -0.681718, -0.147621, 0.716567, -0.442863, -0.238856, 0.864188, -0.587785, -0.425325, 0.688191, -0.309017, -0.500000, 0.809017, -0.147621, -0.716567, 0.681718, -0.425325, -0.688191, 0.587785, -0.162460, -0.262866, 0.951056, 0.442863, -0.238856, 0.864188, 0.162460, -0.262866, 0.951056, 0.309017, -0.500000, 0.809017, 0.147621, -0.716567, 0.681718, 0.000000, -0.525731, 0.850651, 0.425325, -0.688191, 0.587785, 0.587785, -0.425325, 0.688191, 0.688191, -0.587785, 0.425325, -0.955423, 0.295242, 0.000000, -0.951056, 0.162460, 0.262866, -1.000000, 0.000000, 0.000000, -0.850651, 0.000000, 0.525731, -0.955423, -0.295242, 0.000000, -0.951056, -0.162460, 0.262866, -0.864188, 0.442863, -0.238856, -0.951056, 0.162460, -0.262866, -0.809017, 0.309017, -0.500000, -0.864188, -0.442863, -0.238856, -0.951056, -0.162460, -0.262866, -0.809017, -0.309017, -0.500000, -0.681718, 0.147621, -0.716567, -0.681718, -0.147621, -0.716567, -0.850651, 0.000000, -0.525731, -0.688191, 0.587785, -0.425325, -0.587785, 0.425325, -0.688191, -0.425325, 0.688191, -0.587785, -0.425325, -0.688191, -0.587785, -0.587785, -0.425325, -0.688191, -0.688191, -0.587785, -0.425325];

K3D.parse.fromCollada = function (buff) {
  var str = K3D.parse._buffToStr(buff);

  var xml = new DOMParser().parseFromString(str, "text/xml");
  xml = xml.childNodes[0];
  var resp = {}; //console.log(xml);

  var ass = xml.getElementsByTagName("asset")[0];
  var geo = xml.getElementsByTagName("library_geometries")[0];
  var ima = xml.getElementsByTagName("library_images")[0];
  var mat = xml.getElementsByTagName("library_materials")[0];
  var eff = xml.getElementsByTagName("library_effects")[0]; //console.log(xml);

  if (ass) resp.asset = K3D.parse.fromCollada._asset(ass);
  if (geo) resp.geometries = K3D.parse.fromCollada._libGeometries(geo);
  if (ima) resp.images = K3D.parse.fromCollada._libImages(ima);
  if (mat) resp.materials = K3D.parse.fromCollada._libMaterials(mat);
  if (eff) resp.effects = K3D.parse.fromCollada._libEffects(eff);
  return resp;
};

K3D.parse.fromCollada._asset = function (xml) {
  //console.log(xml);
  return {
    created: xml.getElementsByTagName("created")[0].textContent,
    modified: xml.getElementsByTagName("modified")[0].textContent,
    up_axis: xml.getElementsByTagName("up_axis")[0].textContent
  };
};

K3D.parse.fromCollada._libGeometries = function (xml) {
  xml = xml.getElementsByTagName("geometry");
  var res = [];

  for (var i = 0; i < xml.length; i++) {
    var g = xml[i];

    var o = K3D.parse.fromCollada._getMesh(g.getElementsByTagName("mesh")[0]);

    res.push(o);
  }

  return res;
};

K3D.parse.fromCollada._getMesh = function (mesh) {
  //console.log(mesh);
  var res = {};
  var ss = mesh.getElementsByTagName("source");
  var sources = res.sources = {};

  for (var i = 0; i < ss.length; i++) {
    var farr = ss[i].getElementsByTagName("float_array")[0].textContent.split(" ");
    var fl = farr.length - (farr[farr.length - 1] == "" ? 1 : 0);
    var arr = new Array(fl);

    for (var j = 0; j < fl; j++) {
      arr[j] = parseFloat(farr[j]);
    }

    sources[ss[i].getAttribute("id")] = arr;
  }

  res.triangles = [];
  var tgs = mesh.getElementsByTagName("triangles");
  if (tgs == null) return res;

  for (var i = 0; i < tgs.length; i++) {
    var t = {};
    var tnode = tgs[i];
    t.material = tnode.getAttribute("material");
    var inputs = tnode.getElementsByTagName("input");
    var inds = [];

    for (var j = 0; j < inputs.length; j++) {
      var inp = inputs[j],
          arr = [];
      inds[parseInt(inp.getAttribute("offset"))] = arr;
      var par = inp.getAttribute("semantic");
      t["s_" + par] = par == "VERTEX" ? mesh.getElementsByTagName("vertices")[0].getElementsByTagName("input")[0].getAttribute("source").substring(1) : inp.getAttribute("source").substring(1);
      t["i_" + par] = arr;
      sources[t["s_" + par]];
    }

    var indices = tnode.getElementsByTagName("p")[0].textContent.split(" ");
    var inum = 3 * Math.floor(indices.length / 3);

    for (var j = 0; j < inum; j++) {
      inds[j % inputs.length].push(parseInt(indices[j]));
    }
    /*
     if(t.s_VERTEX  ) t.u_VERTEX   = K3D.edit.unwrap(t.i_VERTEX  , sources[t.s_VERTEX  ], 3);
     if(t.s_TEXCOORD) t.u_TEXCOORD = K3D.edit.unwrap(t.i_TEXCOORD, sources[t.s_TEXCOORD], 2);
     if(t.s_NORMAL  ) t.u_NORMAL   = K3D.edit.unwrap(t.i_NORMAL  , sources[t.s_NORMAL  ], 3);
     //*/
    //if(t.s_TEXCOORD) for(var j=1; j<t.u_TEXCOORD.length; j+=2) t.u_TEXCOORD[j] = 1 - t.u_TEXCOORD[j];

    /*
     t.u_INDEX = new Array(t.i_VERTEX.length);
     for(var j=0; j<t.i_VERTEX.length; j++) t.u_INDEX[j] = j;
     */


    res.triangles.push(t);
  }

  return res;
};

K3D.parse.fromCollada._libImages = function (xml) {
  xml = xml.getElementsByTagName("image");
  var res = {};

  for (var i = 0; i < xml.length; i++) {
    res[xml[i].getAttribute("id")] = xml[i].getElementsByTagName("init_from")[0].textContent;
  }

  return res;
};

K3D.parse.fromCollada._libMaterials = function (xml) {
  xml = xml.getElementsByTagName("material");
  var res = {};

  for (var i = 0; i < xml.length; i++) {
    res[xml[i].getAttribute("name")] = xml[i].getElementsByTagName("instance_effect")[0].getAttribute("url").substring(1);
  }

  return res;
};

K3D.parse.fromCollada._libEffects = function (xml) {
  xml = xml.getElementsByTagName("effect");
  var res = {};

  for (var i = 0; i < xml.length; i++) {
    var eff = {};
    var params = xml[i].getElementsByTagName("newparam");

    for (var j = 0; j < params.length; j++) {
      var srf = params[j].getElementsByTagName("surface")[0];
      if (srf) eff.surface = srf.getElementsByTagName("init_from")[0].textContent;
    }

    res[xml[i].getAttribute("id")] = eff;
  }

  return res;
};

K3D.parse.from3DS = function (buff) {
  buff = new Uint8Array(buff);
  var res = {};
  if (K3D.bin.rsl(buff, 0) != 0x4d4d) return null;
  var lim = K3D.bin.ril(buff, 2);
  var off = 6;

  while (off < lim) {
    var cid = K3D.bin.rsl(buff, off);
    var lng = K3D.bin.ril(buff, off + 2); //console.log(cid.toString(16), lng);

    if (cid == 0x3d3d) res.edit = K3D.parse.from3DS._edit3ds(buff, off, lng);
    if (cid == 0xb000) res.keyf = K3D.parse.from3DS._keyf3ds(buff, off, lng);
    off += lng;
  }

  return res;
};

K3D.parse.from3DS._edit3ds = function (buff, coff, clng) // buffer, chunk offset, length
{
  var res = {};
  var off = coff + 6;

  while (off < coff + clng) {
    var cid = K3D.bin.rsl(buff, off);
    var lng = K3D.bin.ril(buff, off + 2); //console.log("\t", cid.toString(16), lng);

    if (cid == 0x4000) {
      if (res.objects == null) res.objects = [];
      res.objects.push(K3D.parse.from3DS._edit_object(buff, off, lng));
    } //if(cid == 0xb000) res.KEYF3DS = K3D.parse.from3DS._keyf3ds(buff, off, lng);


    off += lng;
  }

  return res;
};

K3D.parse.from3DS._keyf3ds = function (buff, coff, clng) {
  var res = {};
  var off = coff + 6;

  while (off < coff + clng) {
    var cid = K3D.bin.rsl(buff, off);
    var lng = K3D.bin.ril(buff, off + 2); //console.log("\t\t", cid.toString(16), lng);
    //if(cid == 0x4000) { res.objects.push(K3D.parse.from3DS._edit_object(buff, off, lng)); }

    if (cid == 0xb002) {
      if (res.desc == null) res.desc = [];
      res.desc.push(K3D.parse.from3DS._keyf_objdes(buff, off, lng));
    }

    off += lng;
  }

  return res;
};

K3D.parse.from3DS._keyf_objdes = function (buff, coff, clng) {
  var res = {};
  var off = coff + 6;

  while (off < coff + clng) {
    var cid = K3D.bin.rsl(buff, off);
    var lng = K3D.bin.ril(buff, off + 2); //console.log("\t\t\t", cid.toString(16), lng);

    if (cid == 0xb010) res.hierarchy = K3D.parse.from3DS._keyf_objhierarch(buff, off, lng);
    if (cid == 0xb011) res.dummy_name = K3D.bin.rASCII0(buff, off + 6);
    off += lng;
  }

  return res;
};

K3D.parse.from3DS._keyf_objhierarch = function (buff, coff, clng) {
  var res = {};
  var off = coff + 6;
  res.name = K3D.bin.rASCII0(buff, off);
  off += res.name.length + 1;
  res.hierarchy = K3D.bin.rsl(buff, off + 4);
  return res;
};

K3D.parse.from3DS._edit_object = function (buff, coff, clng) // buffer, chunk offset, length
{
  var res = {};
  var off = coff + 6;
  res.name = K3D.bin.rASCII0(buff, off);
  off += res.name.length + 1; //console.log(res.name);

  while (off < coff + clng) {
    var cid = K3D.bin.rsl(buff, off);
    var lng = K3D.bin.ril(buff, off + 2); //console.log("\t\t", cid.toString(16), lng);

    if (cid == 0x4100) res.mesh = K3D.parse.from3DS._obj_trimesh(buff, off, lng); //if(cid == 0xb000) res.KEYF3DS = K3D.parse.from3DS._keyf3ds(buff, off, lng);

    off += lng;
  }

  return res;
};

K3D.parse.from3DS._obj_trimesh = function (buff, coff, clng) // buffer, chunk offset, length
{
  var res = {};
  var off = coff + 6;

  while (off < coff + clng) {
    var cid = K3D.bin.rsl(buff, off);
    var lng = K3D.bin.ril(buff, off + 2); //console.log("\t\t\t", cid.toString(16), lng);

    if (cid == 0x4110) res.vertices = K3D.parse.from3DS._tri_vertexl(buff, off, lng);
    if (cid == 0x4120) res.indices = K3D.parse.from3DS._tri_facel1(buff, off, lng);
    if (cid == 0x4140) res.uvt = K3D.parse.from3DS._tri_mappingcoors(buff, off, lng);
    if (cid == 0x4160) res.local = K3D.parse.from3DS._tri_local(buff, off, lng);
    off += lng;
  }

  return res;
};

K3D.parse.from3DS._tri_vertexl = function (buff, coff, clng) // buffer, chunk offset, length
{
  var res = [];
  var off = coff + 6;
  var n = K3D.bin.rsl(buff, off);
  off += 2;

  for (var i = 0; i < n; i++) {
    res.push(K3D.bin.rf(buff, off));
    res.push(K3D.bin.rf(buff, off + 4));
    res.push(K3D.bin.rf(buff, off + 8));
    off += 12;
  }

  return res;
};

K3D.parse.from3DS._tri_facel1 = function (buff, coff, clng) // buffer, chunk offset, length
{
  var res = [];
  var off = coff + 6;
  var n = K3D.bin.rsl(buff, off);
  off += 2;

  for (var i = 0; i < n; i++) {
    res.push(K3D.bin.rsl(buff, off));
    res.push(K3D.bin.rsl(buff, off + 2));
    res.push(K3D.bin.rsl(buff, off + 4));
    off += 8;
  }

  return res;
};

K3D.parse.from3DS._tri_mappingcoors = function (buff, coff, clng) // buffer, chunk offset, length
{
  var res = [];
  var off = coff + 6;
  var n = K3D.bin.rsl(buff, off);
  off += 2;

  for (var i = 0; i < n; i++) {
    res.push(K3D.bin.rf(buff, off));
    res.push(1 - K3D.bin.rf(buff, off + 4));
    off += 8;
  }

  return res;
};

K3D.parse.from3DS._tri_local = function (buff, coff, clng) // buffer, chunk offset, length
{
  var res = {};
  var off = coff + 6;
  res.X = [K3D.bin.rf(buff, off), K3D.bin.rf(buff, off + 4), K3D.bin.rf(buff, off + 8)];
  off += 12;
  res.Y = [K3D.bin.rf(buff, off), K3D.bin.rf(buff, off + 4), K3D.bin.rf(buff, off + 8)];
  off += 12;
  res.Z = [K3D.bin.rf(buff, off), K3D.bin.rf(buff, off + 4), K3D.bin.rf(buff, off + 8)];
  off += 12;
  res.C = [K3D.bin.rf(buff, off), K3D.bin.rf(buff, off + 4), K3D.bin.rf(buff, off + 8)];
  off += 12;
  return res;
};

K3D.parse.fromBIV = function (buff) {
  buff = new Uint8Array(buff);
  var res = {};
  var head = {};
  head.id = K3D.bin.ril(buff, 0);
  head.verS = K3D.bin.ril(buff, 4);
  head.texS = K3D.bin.ril(buff, 8);
  head.indS = K3D.bin.ril(buff, 12);
  head.verO = K3D.bin.ril(buff, 16);
  head.verL = K3D.bin.ril(buff, 20);
  head.texO = K3D.bin.ril(buff, 24);
  head.texL = K3D.bin.ril(buff, 28);
  head.indO = K3D.bin.ril(buff, 32);
  head.indL = K3D.bin.ril(buff, 36);
  if (head.verO != 0) res.vertices = K3D.parse.fromBIV._readFloats(buff, head.verO, head.verL);
  if (head.texO != 0) res.uvt = K3D.parse.fromBIV._readFloats(buff, head.texO, head.texL);
  if (head.indO != 0) res.indices = K3D.parse.fromBIV._readInts(buff, head.indO, head.indL, head.indS);
  return res;
};

K3D.parse.toBIV = function (obj) {
  var maxi = 0;

  for (var i = 0; i < obj.indices.length; i++) {
    maxi = Math.max(maxi, obj.indices[i]);
  }

  var indS = 32;
  if (maxi <= 0xffff) indS = 16;
  var len = 40;
  if (obj.vertices) len += obj.vertices.length * 4;
  if (obj.uvt) len += obj.uvt.length * 4;
  if (obj.indices) len += obj.indices.length * indS / 8;
  var buff = new Uint8Array(len);
  K3D.bin.wil(buff, 0, 0x6976616e);
  K3D.bin.wil(buff, 4, 32);
  K3D.bin.wil(buff, 8, 32);
  K3D.bin.wil(buff, 12, indS);
  var off = 40;

  if (obj.vertices) {
    K3D.bin.wil(buff, 16, off);
    K3D.bin.wil(buff, 20, 4 * obj.vertices.length);

    K3D.parse.fromBIV._writeFloats(buff, off, obj.vertices);

    off += 4 * obj.vertices.length;
  }

  if (obj.uvt) {
    K3D.bin.wil(buff, 24, off);
    K3D.bin.wil(buff, 28, 4 * obj.uvt.length);

    K3D.parse.fromBIV._writeFloats(buff, off, obj.uvt);

    off += 4 * obj.uvt.length;
  }

  if (obj.indices) {
    K3D.bin.wil(buff, 32, off);
    K3D.bin.wil(buff, 36, 4 * obj.indices.length);

    K3D.parse.fromBIV._writeInts(buff, off, obj.indices, indS);
  }

  return buff.buffer;
};

K3D.parse.fromBIV._readFloats = function (buff, off, len) {
  var arr = [];

  for (var i = 0; i < len / 4; i++) {
    arr.push(K3D.bin.rf(buff, off + 4 * i));
  }

  return arr;
};

K3D.parse.fromBIV._writeFloats = function (buff, off, arr) {
  for (var i = 0; i < arr.length; i++) {
    K3D.bin.wf(buff, off + 4 * i, arr[i]);
  }
};

K3D.parse.fromBIV._readInts = function (buff, off, len, cs) {
  var arr = [];

  for (var i = 0; i < len / 4; i++) {
    if (cs == 16) arr.push(K3D.bin.rsl(buff, off + 2 * i));
    if (cs == 32) arr.push(K3D.bin.ril(buff, off + 4 * i));
  }

  return arr;
};

K3D.parse.fromBIV._writeInts = function (buff, off, arr, cs) {
  for (var i = 0; i < arr.length; i++) {
    if (cs == 16) K3D.bin.wsl(buff, off + 2 * i, arr[i]);
    if (cs == 32) K3D.bin.wil(buff, off + 4 * i, arr[i]);
  }
};

K3D.gen = {};

K3D.gen.Plane = function (sw, sh, tsw, tsh) {
  if (!tsw) tsw = 1;
  if (!tsh) tsh = 1;
  var r = {
    verts: [],
    inds: [],
    uvt: []
  };
  var ssw = sw + 1,
      ssh = sh + 1;

  for (var i = 0; i < ssh; i++) {
    for (var j = 0; j < ssw; j++) {
      var x = -1 + j * (2 / sw);
      var y = -1 + i * (2 / sh);
      r.verts.push(x, y, 0);
      r.uvt.push(tsw * j / sw, tsh * i / sh);
      if (i < sh && j < sw) r.inds.push(i * ssw + j, i * ssw + j + 1, (i + 1) * ssw + j, i * ssw + j + 1, (i + 1) * ssw + j, (i + 1) * ssw + j + 1);
    }
  }

  return r;
};

K3D.gen.Cube = function () {
  var r = {
    verts: [-1, 1, -1, 1, 1, -1, -1, -1, -1, 1, -1, -1, // front
    -1, 1, 1, 1, 1, 1, -1, -1, 1, 1, -1, 1, // back
    -1, 1, 1, -1, 1, -1, -1, -1, 1, -1, -1, -1, // left
    1, 1, 1, 1, 1, -1, 1, -1, 1, 1, -1, -1, // right
    -1, 1, -1, 1, 1, -1, -1, 1, 1, 1, 1, 1, // top
    -1, -1, -1, 1, -1, -1, -1, -1, 1, 1, -1, 1 // bottom
    ],
    inds: [0, 1, 2, 1, 2, 3, 4, 5, 6, 5, 6, 7, 8, 9, 10, 9, 10, 11, 12, 13, 14, 13, 14, 15, 16, 17, 18, 17, 18, 19, 20, 21, 22, 21, 22, 23],
    uvt: [1 / 4, 1 / 4, 2 / 4, 1 / 4, 1 / 4, 2 / 4, 2 / 4, 2 / 4, // front
    4 / 4, 1 / 4, 3 / 4, 1 / 4, 4 / 4, 2 / 4, 3 / 4, 2 / 4, // back
    0 / 4, 1 / 4, 1 / 4, 1 / 4, 0 / 4, 2 / 4, 1 / 4, 2 / 4, // left
    3 / 4, 1 / 4, 2 / 4, 1 / 4, 3 / 4, 2 / 4, 2 / 4, 2 / 4, // right
    1 / 4, 1 / 4, 2 / 4, 1 / 4, 1 / 4, 0 / 4, 2 / 4, 0 / 4, // top
    1 / 4, 2 / 4, 2 / 4, 2 / 4, 1 / 4, 3 / 4, 2 / 4, 3 / 4 // bottom
    ]
  };
  return r;
};

K3D.gen.Sphere = function (sx, sy) {
  var r = {
    verts: [],
    inds: [],
    uvt: []
  };
  var nx = sx + 1,
      ny = sy + 1;

  for (var i = 0; i < ny; i++) // rows
  {
    for (var j = 0; j < nx; j++) // cols
    {
      var lat = -Math.PI / 2 + i * Math.PI / sy;
      var lon = j * 2 * Math.PI / sx;
      var x = Math.cos(lat) * Math.cos(lon);
      var y = Math.sin(lat);
      var z = Math.cos(lat) * Math.sin(lon);
      r.verts.push(x, y, z);
      r.uvt.push(j / sx, i / sy);
      if (i < sy && j < sx) // 6 indices for 2 triangles
        r.inds.push(nx * i + j, nx * i + j + 1, nx * (i + 1) + j, nx * i + j + 1, nx * (i + 1) + j, nx * (i + 1) + j + 1);
    }
  }

  return r;
};

K3D.mat = {};

K3D.mat.scale = function (x, y, z) {
  return [x, 0, 0, 0, 0, y, 0, 0, 0, 0, z, 0, 0, 0, 0, 1];
};

K3D.mat.translate = function (x, y, z) {
  return [1, 0, 0, 0, 0, 1, 0, 0, 0, 0, 1, 0, x, y, z, 1];
};

K3D.mat.rotateDeg = function (x, y, z) {
  var r = Math.PI / 180;
  return K3D.mat.rotate(x * r, y * r, z * r);
};

K3D.mat.rotate = function (x, y, z) {
  var m = [1, 0, 0, 0, 0, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, 1];
  var a = x; // alpha

  var b = y; // beta

  var g = z; // gama

  var ca = Math.cos(a),
      cb = Math.cos(b),
      cg = Math.cos(g);
  var sa = Math.sin(a),
      sb = Math.sin(b),
      sg = Math.sin(g);
  m[0] = cb * cg;
  m[1] = -cb * sg;
  m[2] = sb;
  m[4] = ca * sg + sa * sb * cg;
  m[5] = ca * cg - sa * sb * sg;
  m[6] = -sa * cb;
  m[8] = sa * sg - ca * sb * cg;
  m[9] = sa * cg + ca * sb * sg;
  m[10] = ca * cb;
  return m;
};

K3D.edit = {};

K3D.edit.interpolate = function (a, b, d, t) {
  for (var i = 0; i < a.length; i++) {
    d[i] = a[i] + t * (b[i] - a[i]);
  }
};

K3D.edit.transform = function (a, m) {
  for (var i = 0; i < a.length; i += 3) {
    var x = a[i],
        y = a[i + 1],
        z = a[i + 2];
    a[i + 0] = m[0] * x + m[4] * y + m[8] * z + m[12];
    a[i + 1] = m[1] * x + m[5] * y + m[9] * z + m[13];
    a[i + 2] = m[2] * x + m[6] * y + m[10] * z + m[14];
  }
}; // starting indices, starting coordinates, coordinates per index


K3D.edit.unwrap = function (ind, crd, cpi) {
  var ncrd = new Array(Math.floor(ind.length / 3) * cpi);

  for (var i = 0; i < ind.length; i++) {
    for (var j = 0; j < cpi; j++) {
      ncrd[i * cpi + j] = crd[ind[i] * cpi + j];
    }
  }

  return ncrd;
}; // current indices, new indices, current array, coordinates per vertex


K3D.edit.remap = function (ind, nind, arr, cpi) {
  var ncrd = new Array(arr.length);

  for (var i = 0; i < ind.length; i++) {
    for (var j = 0; j < cpi; j++) {
      ncrd[nind[i] * cpi + j] = arr[ind[i] * cpi + j];
    }
  }

  return ncrd;
};

K3D.utils = {};

K3D.utils.getAABB = function (vts) {
  var minx, miny, minz, maxx, maxy, maxz;
  minx = miny = minz = 999999999;
  maxx = maxy = maxz = -minx;

  for (var i = 0; i < vts.length; i += 3) {
    var vx = vts[i + 0];
    var vy = vts[i + 1];
    var vz = vts[i + 2];
    if (vx < minx) minx = vx;
    if (vx > maxx) maxx = vx;
    if (vy < miny) miny = vy;
    if (vy > maxy) maxy = vy;
    if (vz < minz) minz = vz;
    if (vy > maxz) maxz = vz;
  }

  return {
    min: {
      x: minx,
      y: miny,
      z: minz
    },
    max: {
      x: maxx,
      y: maxy,
      z: maxz
    }
  };
};

math.vec4(4);
math.vec4();
math.vec4();
math.vec3([1, 0, 0]);
math.vec3([0, 1, 0]);
math.vec3([0, 0, 1]);
math.vec3(3);
math.vec3(3);
math.identityMat4();

new Map({});

/**
 * @private
 * @type {{WEBGL: boolean, SUPPORTED_EXTENSIONS: {}}}
 */
var WEBGL_INFO = {
  WEBGL: false,
  SUPPORTED_EXTENSIONS: {}
};
var canvas = document.createElement("canvas");

if (canvas) {
  var gl = canvas.getContext("webgl", {
    antialias: true
  }) || canvas.getContext("experimental-webgl", {
    antialias: true
  });
  WEBGL_INFO.WEBGL = !!gl;

  if (WEBGL_INFO.WEBGL) {
    WEBGL_INFO.ANTIALIAS = gl.getContextAttributes().antialias;

    if (gl.getShaderPrecisionFormat) {
      if (gl.getShaderPrecisionFormat(gl.FRAGMENT_SHADER, gl.HIGH_FLOAT).precision > 0) {
        WEBGL_INFO.FS_MAX_FLOAT_PRECISION = "highp";
      } else if (gl.getShaderPrecisionFormat(gl.FRAGMENT_SHADER, gl.MEDIUM_FLOAT).precision > 0) {
        WEBGL_INFO.FS_MAX_FLOAT_PRECISION = "mediump";
      } else {
        WEBGL_INFO.FS_MAX_FLOAT_PRECISION = "lowp";
      }
    } else {
      WEBGL_INFO.FS_MAX_FLOAT_PRECISION = "mediump";
    }

    WEBGL_INFO.DEPTH_BUFFER_BITS = gl.getParameter(gl.DEPTH_BITS);
    WEBGL_INFO.MAX_TEXTURE_SIZE = gl.getParameter(gl.MAX_TEXTURE_SIZE);
    WEBGL_INFO.MAX_CUBE_MAP_SIZE = gl.getParameter(gl.MAX_CUBE_MAP_TEXTURE_SIZE);
    WEBGL_INFO.MAX_RENDERBUFFER_SIZE = gl.getParameter(gl.MAX_RENDERBUFFER_SIZE);
    WEBGL_INFO.MAX_TEXTURE_UNITS = gl.getParameter(gl.MAX_COMBINED_TEXTURE_IMAGE_UNITS);
    WEBGL_INFO.MAX_TEXTURE_IMAGE_UNITS = gl.getParameter(gl.MAX_TEXTURE_IMAGE_UNITS);
    WEBGL_INFO.MAX_VERTEX_ATTRIBS = gl.getParameter(gl.MAX_VERTEX_ATTRIBS);
    WEBGL_INFO.MAX_VERTEX_UNIFORM_VECTORS = gl.getParameter(gl.MAX_VERTEX_UNIFORM_VECTORS);
    WEBGL_INFO.MAX_FRAGMENT_UNIFORM_VECTORS = gl.getParameter(gl.MAX_FRAGMENT_UNIFORM_VECTORS);
    WEBGL_INFO.MAX_VARYING_VECTORS = gl.getParameter(gl.MAX_VARYING_VECTORS);
    gl.getSupportedExtensions().forEach(function (ext) {
      WEBGL_INFO.SUPPORTED_EXTENSIONS[ext] = true;
    });
  }
}

math.vec3();

/**
 * @author xeolabs / https://github.com/xeolabs
 */
math.vec3();
new Map({});

/**
 * @author xeolabs / https://github.com/xeolabs
 */
new Map({});
math.vec3();

/**
 * @author xeolabs / https://github.com/xeolabs
 */
new Map({});
math.vec3();

/**
 * @author xeolabs / https://github.com/xeolabs
 */
math.vec3(); // No ID, because there is exactly one PickMeshRenderer per scene

/**
 * @author xeolabs / https://github.com/xeolabs
 */
math.vec3();

/**
 * @author xeolabs / https://github.com/xeolabs
 */
math.vec3(); // No ID, because there is exactly one PickMeshRenderer per scene

math.OBB3();
math.vec4();
math.vec4();
math.vec4();
math.vec3([1, 0, 0]);
math.vec3([0, 1, 0]);
math.vec3([0, 0, 1]);
math.vec3(3);
math.vec3(3);
math.identityMat4();

(function () {
  // Cached vars to avoid garbage collection
  var localRayOrigin = math.vec3();
  var localRayDir = math.vec3();
  var positionA = math.vec3();
  var positionB = math.vec3();
  var positionC = math.vec3();
  var triangleVertices = math.vec3();
  var position = math.vec4();
  var worldPos = math.vec3();
  var viewPos = math.vec3();
  var bary = math.vec3();
  var normalA = math.vec3();
  var normalB = math.vec3();
  var normalC = math.vec3();
  var uva = math.vec3();
  var uvb = math.vec3();
  var uvc = math.vec3();
  var tempVec4a = math.vec4();
  var tempVec4b = math.vec4();
  var tempVec4c = math.vec4();
  var tempVec3 = math.vec3();
  var tempVec3b = math.vec3();
  var tempVec3c = math.vec3();
  var tempVec3d = math.vec3();
  var tempVec3e = math.vec3();
  var tempVec3f = math.vec3();
  var tempVec3g = math.vec3();
  var tempVec3h = math.vec3();
  var tempVec3i = math.vec3();
  var tempVec3j = math.vec3();
  var tempVec3k = math.vec3();
  return function (mesh, pickViewMatrix, pickProjMatrix, pickResult) {
    var primIndex = pickResult.primIndex;

    if (primIndex !== undefined && primIndex !== null && primIndex > -1) {
      var geometry = mesh.geometry._state;
      var scene = mesh.scene;
      var camera = scene.camera;
      var canvas = scene.canvas;

      if (geometry.primitiveName === "triangles") {
        // Triangle picked; this only happens when the
        // Mesh has a Geometry that has primitives of type "triangle"
        pickResult.primitive = "triangle"; // Get the World-space positions of the triangle's vertices

        var i = primIndex; // Indicates the first triangle index in the indices array

        var indices = geometry.indices; // Indices into geometry arrays, not into shared VertexBufs

        var positions = geometry.positions;
        var ia3;
        var ib3;
        var ic3;

        if (indices) {
          var ia = indices[i + 0];
          var ib = indices[i + 1];
          var ic = indices[i + 2];
          triangleVertices[0] = ia;
          triangleVertices[1] = ib;
          triangleVertices[2] = ic;
          pickResult.indices = triangleVertices;
          ia3 = ia * 3;
          ib3 = ib * 3;
          ic3 = ic * 3;
        } else {
          ia3 = i * 3;
          ib3 = ia3 + 3;
          ic3 = ib3 + 3;
        }

        positionA[0] = positions[ia3 + 0];
        positionA[1] = positions[ia3 + 1];
        positionA[2] = positions[ia3 + 2];
        positionB[0] = positions[ib3 + 0];
        positionB[1] = positions[ib3 + 1];
        positionB[2] = positions[ib3 + 2];
        positionC[0] = positions[ic3 + 0];
        positionC[1] = positions[ic3 + 1];
        positionC[2] = positions[ic3 + 2];

        if (geometry.compressGeometry) {
          // Decompress vertex positions
          var positionsDecodeMatrix = geometry.positionsDecodeMatrix;

          if (positionsDecodeMatrix) {
            geometryCompressionUtils.decompressPosition(positionA, positionsDecodeMatrix, positionA);
            geometryCompressionUtils.decompressPosition(positionB, positionsDecodeMatrix, positionB);
            geometryCompressionUtils.decompressPosition(positionC, positionsDecodeMatrix, positionC);
          }
        } // Attempt to ray-pick the triangle in local space


        var canvasPos;

        if (pickResult.canvasPos) {
          canvasPos = pickResult.canvasPos;
          math.canvasPosToLocalRay(canvas.canvas, pickViewMatrix, pickProjMatrix, mesh.worldMatrix, canvasPos, localRayOrigin, localRayDir);
        } else if (pickResult.origin && pickResult.direction) {
          math.worldRayToLocalRay(mesh.worldMatrix, pickResult.origin, pickResult.direction, localRayOrigin, localRayDir);
        }

        math.normalizeVec3(localRayDir);
        math.rayPlaneIntersect(localRayOrigin, localRayDir, positionA, positionB, positionC, position); // Get Local-space cartesian coordinates of the ray-triangle intersection

        pickResult.localPos = position;
        pickResult.position = position; // Get interpolated World-space coordinates
        // Need to transform homogeneous coords

        tempVec4a[0] = position[0];
        tempVec4a[1] = position[1];
        tempVec4a[2] = position[2];
        tempVec4a[3] = 1; // Get World-space cartesian coordinates of the ray-triangle intersection

        math.transformVec4(mesh.worldMatrix, tempVec4a, tempVec4b);
        worldPos[0] = tempVec4b[0];
        worldPos[1] = tempVec4b[1];
        worldPos[2] = tempVec4b[2];
        pickResult.worldPos = worldPos; // Get View-space cartesian coordinates of the ray-triangle intersection

        math.transformVec4(camera.matrix, tempVec4b, tempVec4c);
        viewPos[0] = tempVec4c[0];
        viewPos[1] = tempVec4c[1];
        viewPos[2] = tempVec4c[2];
        pickResult.viewPos = viewPos; // Get barycentric coordinates of the ray-triangle intersection

        math.cartesianToBarycentric(position, positionA, positionB, positionC, bary);
        pickResult.bary = bary; // Get interpolated normal vector

        var normals = geometry.normals;

        if (normals) {
          if (geometry.compressGeometry) {
            // Decompress vertex normals
            var ia2 = ia * 3;
            var ib2 = ib * 3;
            var ic2 = ic * 3;
            geometryCompressionUtils.decompressNormal(normals.subarray(ia2, ia2 + 2), normalA);
            geometryCompressionUtils.decompressNormal(normals.subarray(ib2, ib2 + 2), normalB);
            geometryCompressionUtils.decompressNormal(normals.subarray(ic2, ic2 + 2), normalC);
          } else {
            normalA[0] = normals[ia3];
            normalA[1] = normals[ia3 + 1];
            normalA[2] = normals[ia3 + 2];
            normalB[0] = normals[ib3];
            normalB[1] = normals[ib3 + 1];
            normalB[2] = normals[ib3 + 2];
            normalC[0] = normals[ic3];
            normalC[1] = normals[ic3 + 1];
            normalC[2] = normals[ic3 + 2];
          }

          var normal = math.addVec3(math.addVec3(math.mulVec3Scalar(normalA, bary[0], tempVec3), math.mulVec3Scalar(normalB, bary[1], tempVec3b), tempVec3c), math.mulVec3Scalar(normalC, bary[2], tempVec3d), tempVec3e);
          pickResult.worldNormal = math.normalizeVec3(math.transformVec3(mesh.worldNormalMatrix, normal, tempVec3f));
        } // Get interpolated UV coordinates


        var uvs = geometry.uv;

        if (uvs) {
          uva[0] = uvs[ia * 2];
          uva[1] = uvs[ia * 2 + 1];
          uvb[0] = uvs[ib * 2];
          uvb[1] = uvs[ib * 2 + 1];
          uvc[0] = uvs[ic * 2];
          uvc[1] = uvs[ic * 2 + 1];

          if (geometry.compressGeometry) {
            // Decompress vertex UVs
            var uvDecodeMatrix = geometry.uvDecodeMatrix;

            if (uvDecodeMatrix) {
              geometryCompressionUtils.decompressUV(uva, uvDecodeMatrix, uva);
              geometryCompressionUtils.decompressUV(uvb, uvDecodeMatrix, uvb);
              geometryCompressionUtils.decompressUV(uvc, uvDecodeMatrix, uvc);
            }
          }

          pickResult.uv = math.addVec3(math.addVec3(math.mulVec2Scalar(uva, bary[0], tempVec3g), math.mulVec2Scalar(uvb, bary[1], tempVec3h), tempVec3i), math.mulVec2Scalar(uvc, bary[2], tempVec3j), tempVec3k);
        }
      }
    }
  };
})();

math.vec3();
math.vec3();
math.vec3();
math.vec3([0, -1, 0]);
math.vec4([0, 0, 0, 1]);

math.vec3();
math.vec3();
math.mat4();
/**
 * @private
 */

var FrustumPlane = /*#__PURE__*/function () {
  function FrustumPlane() {
    _classCallCheck(this, FrustumPlane);

    this.normal = math.vec3();
    this.offset = 0;
    this.testVertex = math.vec3();
  }

  _createClass(FrustumPlane, [{
    key: "set",
    value: function set(nx, ny, nz, offset) {
      var s = 1.0 / Math.sqrt(nx * nx + ny * ny + nz * nz);
      this.normal[0] = nx * s;
      this.normal[1] = ny * s;
      this.normal[2] = nz * s;
      this.offset = offset * s;
      this.testVertex[0] = this.normal[0] >= 0.0 ? 1 : 0;
      this.testVertex[1] = this.normal[1] >= 0.0 ? 1 : 0;
      this.testVertex[2] = this.normal[2] >= 0.0 ? 1 : 0;
    }
  }]);

  return FrustumPlane;
}();
/**
 * @private
 */


var Frustum = /*#__PURE__*/_createClass(function Frustum() {
  _classCallCheck(this, Frustum);

  this.planes = [new FrustumPlane(), new FrustumPlane(), new FrustumPlane(), new FrustumPlane(), new FrustumPlane(), new FrustumPlane()];
});

Frustum.INSIDE = 0;
Frustum.INTERSECT = 1;
Frustum.OUTSIDE = 2;

/*
 * Canvas2Image v0.1
 * Copyright (c) 2008 Jacob Seidelin, cupboy@gmail.com
 * MIT License [http://www.opensource.org/licenses/mit-license.php]
 *
 * Modified by @xeolabs to permit vertical flipping, so that snapshot can be taken from WebGL frame buffers,
 * which vertically flip image data as part of the way that WebGL renders textures.
 */

/**
 * @private
 */
(function () {
  // check if we have canvas support
  var oCanvas = document.createElement("canvas"),
      sc = String.fromCharCode;
 // no canvas, bail out.

  if (!oCanvas.getContext) {
    return {
      saveAsBMP: function saveAsBMP() {},
      saveAsPNG: function saveAsPNG() {},
      saveAsJPEG: function saveAsJPEG() {}
    };
  }

  var bHasImageData = !!oCanvas.getContext("2d").getImageData,
      bHasDataURL = !!oCanvas.toDataURL,
      bHasBase64 = !!window.btoa; // ok, we're good

  var readCanvasData = function readCanvasData(oCanvas) {
    var iWidth = parseInt(oCanvas.width),
        iHeight = parseInt(oCanvas.height);
    return oCanvas.getContext("2d").getImageData(0, 0, iWidth, iHeight);
  }; // base64 encodes either a string or an array of charcodes


  var encodeData = function encodeData(data) {
    var i,
        aData,
        strData = "";

    if (typeof data == "string") {
      strData = data;
    } else {
      aData = data;

      for (i = 0; i < aData.length; i++) {
        strData += sc(aData[i]);
      }
    }

    return btoa(strData);
  }; // creates a base64 encoded string containing BMP data takes an imagedata object as argument


  var createBMP = function createBMP(oData) {
    var strHeader = '';
    var iWidth = oData.width;
    var iHeight = oData.height;
    strHeader += 'BM';
    var iFileSize = iWidth * iHeight * 4 + 54; // total header size = 54 bytes

    strHeader += sc(iFileSize % 256);
    iFileSize = Math.floor(iFileSize / 256);
    strHeader += sc(iFileSize % 256);
    iFileSize = Math.floor(iFileSize / 256);
    strHeader += sc(iFileSize % 256);
    iFileSize = Math.floor(iFileSize / 256);
    strHeader += sc(iFileSize % 256);
    strHeader += sc(0, 0, 0, 0, 54, 0, 0, 0); // data offset

    strHeader += sc(40, 0, 0, 0); // info header size

    var iImageWidth = iWidth;
    strHeader += sc(iImageWidth % 256);
    iImageWidth = Math.floor(iImageWidth / 256);
    strHeader += sc(iImageWidth % 256);
    iImageWidth = Math.floor(iImageWidth / 256);
    strHeader += sc(iImageWidth % 256);
    iImageWidth = Math.floor(iImageWidth / 256);
    strHeader += sc(iImageWidth % 256);
    var iImageHeight = iHeight;
    strHeader += sc(iImageHeight % 256);
    iImageHeight = Math.floor(iImageHeight / 256);
    strHeader += sc(iImageHeight % 256);
    iImageHeight = Math.floor(iImageHeight / 256);
    strHeader += sc(iImageHeight % 256);
    iImageHeight = Math.floor(iImageHeight / 256);
    strHeader += sc(iImageHeight % 256);
    strHeader += sc(1, 0, 32, 0); // num of planes & num of bits per pixel

    strHeader += sc(0, 0, 0, 0); // compression = none

    var iDataSize = iWidth * iHeight * 4;
    strHeader += sc(iDataSize % 256);
    iDataSize = Math.floor(iDataSize / 256);
    strHeader += sc(iDataSize % 256);
    iDataSize = Math.floor(iDataSize / 256);
    strHeader += sc(iDataSize % 256);
    iDataSize = Math.floor(iDataSize / 256);
    strHeader += sc(iDataSize % 256);
    strHeader += sc(0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0); // these bytes are not used

    var aImgData = oData.data;
    var strPixelData = "";
    var x;
    var y = iHeight;
    var iOffsetX;
    var iOffsetY;
    var strPixelRow;

    do {
      iOffsetY = iWidth * (y - 1) * 4;
      strPixelRow = "";

      for (x = 0; x < iWidth; x++) {
        iOffsetX = 4 * x;
        strPixelRow += sc(aImgData[iOffsetY + iOffsetX + 2], // B
        aImgData[iOffsetY + iOffsetX + 1], // G
        aImgData[iOffsetY + iOffsetX], // R
        aImgData[iOffsetY + iOffsetX + 3] // A
        );
      }

      strPixelData += strPixelRow;
    } while (--y);

    return encodeData(strHeader + strPixelData);
  }; // sends the generated file to the client


  var saveFile = function saveFile(strData) {
    if (!window.open(strData)) {
      document.location.href = strData;
    }
  };

  var makeDataURI = function makeDataURI(strData, strMime) {
    return "data:" + strMime + ";base64," + strData;
  }; // generates a <img> object containing the imagedata


  var makeImageObject = function makeImageObject(strSource) {
    var oImgElement = document.createElement("img");
    oImgElement.src = strSource;
    return oImgElement;
  };

  var scaleCanvas = function scaleCanvas(oCanvas, iWidth, iHeight, flipy) {
    if (iWidth && iHeight) {
      var oSaveCanvas = document.createElement("canvas");
      oSaveCanvas.width = iWidth;
      oSaveCanvas.height = iHeight;
      oSaveCanvas.style.width = iWidth + "px";
      oSaveCanvas.style.height = iHeight + "px";
      var oSaveCtx = oSaveCanvas.getContext("2d");

      if (flipy) {
        oSaveCtx.save();
        oSaveCtx.scale(1.0, -1.0);
        oSaveCtx.imageSmoothingEnabled = true;
        oSaveCtx.drawImage(oCanvas, 0, 0, oCanvas.width, oCanvas.height, 0, 0, iWidth, -iHeight);
        oSaveCtx.restore();
      } else {
        oSaveCtx.imageSmoothingEnabled = true;
        oSaveCtx.drawImage(oCanvas, 0, 0, oCanvas.width, oCanvas.height, 0, 0, iWidth, iHeight);
      }

      return oSaveCanvas;
    }

    return oCanvas;
  };

  return {
    saveAsPNG: function saveAsPNG(oCanvas, bReturnImg, iWidth, iHeight, flipy) {
      if (!bHasDataURL) return false;
      var oScaledCanvas = scaleCanvas(oCanvas, iWidth, iHeight, flipy);
      var strMime = "image/png";
      var strData = oScaledCanvas.toDataURL(strMime);

      if (bReturnImg) {
        return makeImageObject(strData);
      } else {
        saveFile(strData);
      }

      return true;
    },
    saveAsJPEG: function saveAsJPEG(oCanvas, bReturnImg, iWidth, iHeight, flipy) {
      if (!bHasDataURL) return false;
      var oScaledCanvas = scaleCanvas(oCanvas, iWidth, iHeight, flipy);
      var strMime = "image/jpeg";
      var strData = oScaledCanvas.toDataURL(strMime); // check if browser actually supports jpeg by looking for the mime type in the data uri. if not, return false

      if (strData.indexOf(strMime) != 5) return false;

      if (bReturnImg) {
        return makeImageObject(strData);
      } else {
        saveFile(strData);
      }

      return true;
    },
    saveAsBMP: function saveAsBMP(oCanvas, bReturnImg, iWidth, iHeight, flipy) {
      if (!(bHasDataURL && bHasImageData && bHasBase64)) return false;
      var oScaledCanvas = scaleCanvas(oCanvas, iWidth, iHeight, flipy);
      var strMime = "image/bmp";
      var oData = readCanvasData(oScaledCanvas),
          strImgData = createBMP(oData);

      if (bReturnImg) {
        return makeImageObject(makeDataURI(strImgData, strMime));
      } else {
        saveFile(makeDataURI(strImgData, strMime));
      }

      return true;
    }
  };
})();

math.vec4();
math.vec4();

math.vec3();

math.vec3();

/**
 * Provides scratch memory for methods like TrianglesBatchingLayer setFlags() and setColors(),
 * so they don't need to allocate temporary arrays that need garbage collection.
 *
 * @private
 */
var ScratchMemory = /*#__PURE__*/function () {
  function ScratchMemory() {
    _classCallCheck(this, ScratchMemory);

    this._uint8Arrays = {};
    this._float32Arrays = {};
  }

  _createClass(ScratchMemory, [{
    key: "_clear",
    value: function _clear() {
      this._uint8Arrays = {};
      this._float32Arrays = {};
    }
  }, {
    key: "getUInt8Array",
    value: function getUInt8Array(len) {
      var uint8Array = this._uint8Arrays[len];

      if (!uint8Array) {
        uint8Array = new Uint8Array(len);
        this._uint8Arrays[len] = uint8Array;
      }

      return uint8Array;
    }
  }, {
    key: "getFloat32Array",
    value: function getFloat32Array(len) {
      var float32Array = this._float32Arrays[len];

      if (!float32Array) {
        float32Array = new Float32Array(len);
        this._float32Arrays[len] = float32Array;
      }

      return float32Array;
    }
  }]);

  return ScratchMemory;
}();

new ScratchMemory();

math.vec4();
math.vec3();

math.vec4();
math.vec3();

math.vec3();

math.vec3();

math.vec3();

math.vec3();

math.vec3();

math.vec3();

math.vec3();

math.vec3();

math.vec3();

math.vec3();

math.vec4();
math.vec3(); // const TEXTURE_DECODE_FUNCS = {};

math.vec3();

math.vec4();
math.vec3();

math.mat4();
math.mat4();

math.mat4();
math.mat4();
math.vec4([0, 0, 0, 1]);
math.vec4([0, 0, 0, 1]);
math.vec4([0, 0, 0, 1]);
math.OBB3();
math.vec3();
math.vec3();
math.vec3();
math.vec3();
math.vec3();
math.vec3();
math.vec3();

math.vec4();
math.vec3();

math.vec4();
math.vec3();

math.vec3();

math.vec3();

math.vec3();

math.vec3();

math.vec3();

math.vec3();

math.vec3();

math.vec3();

math.vec3();

math.vec3();

math.vec4();
math.vec3();

math.vec3();

math.vec4();
math.vec3();

math.vec4([0, 0, 0, 1]);
math.vec4([0, 0, 0, 1]);
math.vec4([0, 0, 0, 1]);
math.vec3();
math.vec3();
math.vec3();
math.vec3();
math.vec3();
math.vec3();
math.vec3();

math.vec3();

math.vec3();

math.vec4([0, 0, 0, 1]);
math.vec4([0, 0, 0, 1]);
math.vec4([0, 0, 0, 1]);
math.OBB3();

math.vec3();

math.vec3();

math.vec4([0, 0, 0, 1]);
math.vec4([0, 0, 0, 1]);
math.vec4([0, 0, 0, 1]);

math.vec3();

math.vec3();

math.vec3();

math.vec3();

math.vec3();

math.vec4();
math.vec4();
math.vec4([0, 0, 0, 1]);
math.vec4([0, 0, 0, 1]);
math.vec4([0, 0, 0, 1]);
math.OBB3();

math.vec3();

math.vec3();

math.vec3();

math.vec3();

math.vec3();

math.vec3();

math.vec3();

math.vec4([0, 0, 0, 1]);
math.vec4([0, 0, 0, 1]);
math.vec4([0, 0, 0, 1]);

var LoadingManager = /*#__PURE__*/function () {
  function LoadingManager(onLoad, onProgress, onError) {
    _classCallCheck(this, LoadingManager);

    this.isLoading = false;
    this.itemsLoaded = 0;
    this.itemsTotal = 0;
    this.urlModifier = undefined;
    this.handlers = [];
    this.onStart = undefined;
    this.onLoad = onLoad;
    this.onProgress = onProgress;
    this.onError = onError;
  }

  _createClass(LoadingManager, [{
    key: "itemStart",
    value: function itemStart(url) {
      this.itemsTotal++;

      if (this.isLoading === false) {
        if (this.onStart !== undefined) {
          this.onStart(url, this.itemsLoaded, this.itemsTotal);
        }
      }

      this.isLoading = true;
    }
  }, {
    key: "itemEnd",
    value: function itemEnd(url) {
      this.itemsLoaded++;

      if (this.onProgress !== undefined) {
        this.onProgress(url, this.itemsLoaded, this.itemsTotal);
      }

      if (this.itemsLoaded === this.itemsTotal) {
        this.isLoading = false;

        if (this.onLoad !== undefined) {
          this.onLoad();
        }
      }
    }
  }, {
    key: "itemError",
    value: function itemError(url) {
      if (this.onError !== undefined) {
        this.onError(url);
      }
    }
  }, {
    key: "resolveURL",
    value: function resolveURL(url) {
      if (this.urlModifier) {
        return this.urlModifier(url);
      }

      return url;
    }
  }, {
    key: "setURLModifier",
    value: function setURLModifier(transform) {
      this.urlModifier = transform;
      return this;
    }
  }, {
    key: "addHandler",
    value: function addHandler(regex, loader) {
      this.handlers.push(regex, loader);
      return this;
    }
  }, {
    key: "removeHandler",
    value: function removeHandler(regex) {
      var index = this.handlers.indexOf(regex);

      if (index !== -1) {
        this.handlers.splice(index, 2);
      }

      return this;
    }
  }, {
    key: "getHandler",
    value: function getHandler(file) {
      for (var i = 0, l = this.handlers.length; i < l; i += 2) {
        var regex = this.handlers[i];
        var loader = this.handlers[i + 1];
        if (regex.global) regex.lastIndex = 0; // see #17920

        if (regex.test(file)) {
          return loader;
        }
      }

      return null;
    }
  }]);

  return LoadingManager;
}();

new LoadingManager();

math.vec3();
math.mat4();
math.vec3([1, 1, 1]);
math.vec3([0, 0, 0]);
math.vec3([0, 0, 0]);
math.identityQuaternion();

math.vec3([1.0, 0.0, 0.0]);

math.vec3();

math.vec2();

var blurStdDev = 4;
var KERNEL_RADIUS = 16;
new Float32Array(createSampleOffsets(KERNEL_RADIUS + 1, [0, 1]));
new Float32Array(createSampleOffsets(KERNEL_RADIUS + 1, [1, 0]));
new Float32Array(createSampleWeights(KERNEL_RADIUS + 1, blurStdDev));

function createSampleWeights(kernelRadius, stdDev) {
  var weights = [];

  for (var i = 0; i <= kernelRadius; i++) {
    weights.push(gaussian(i, stdDev));
  }

  return weights; // TODO: Optimize
}

function gaussian(x, stdDev) {
  return Math.exp(-(x * x) / (2.0 * (stdDev * stdDev))) / (Math.sqrt(2.0 * Math.PI) * stdDev);
}

function createSampleOffsets(kernelRadius, uvIncrement) {
  var offsets = [];

  for (var i = 0; i <= kernelRadius; i++) {
    offsets.push(uvIncrement[0] * i);
    offsets.push(uvIncrement[1] * i);
  }

  return offsets;
}

math.vec3();
math.vec3();
math.vec3();
math.vec3();
math.vec3();
math.vec3();
math.mat4();
math.mat4();
math.vec3();
math.vec3();
math.vec3();
math.vec3();

function _createSuper$1(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct$1(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _isNativeReflectConstruct$1() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }
/**
 * Creates {@link DistanceMeasurement}s from mouse and touch input.
 *
 * Belongs to a {@link DistanceMeasurementsPlugin}. Located at {@link DistanceMeasurementsPlugin#control}.
 *
 * Once the DistanceMeasurementControl is activated, the first click on any {@link Entity} begins constructing a {@link DistanceMeasurement}, fixing its origin to that Entity. The next click on any Entity will complete the DistanceMeasurement, fixing its target to that second Entity. The DistanceMeasurementControl will then wait for the next click on any Entity, to begin constructing another DistanceMeasurement, and so on, until deactivated.
 *
 * See {@link DistanceMeasurementsPlugin} for more info.
 */

var DistanceMeasurementsControl = /*#__PURE__*/function (_Component) {
  _inherits(DistanceMeasurementsControl, _Component);

  var _super = _createSuper$1(DistanceMeasurementsControl);

  /**
   * @private
   */
  function DistanceMeasurementsControl(plugin) {
    var _this;

    _classCallCheck(this, DistanceMeasurementsControl);

    _this = _super.call(this, plugin.viewer.scene);
    /**
     * The {@link DistanceMeasurementsPlugin} that owns this DistanceMeasurementsControl.
     * @type {DistanceMeasurementsPlugin}
     */

    _this.plugin = plugin;
    _this._active = false; // Mouse input uses a combo of events that requires us to track
    // the current DistanceMeasurement under construction. This is not used for touch input.

    _this._currentDistanceMeasurementByMouse = null;
    _this._currentDistanceMeasurementByMouseInittouchState = {
      wireVisible: null,
      axisVisible: null,
      xAxisVisible: null,
      yaxisVisible: null,
      zAxisVisible: null,
      targetVisible: null
    }; // Shows 2D canvas pos of touch start

    _this._touchStartDot = new ctGXeokitSharedPluginLib.Dot(plugin._container, {
      fillColor: plugin.defaultColor,
      zIndex: plugin.zIndex + 1,
      visible: false
    }); // Tracks 3D world pos of touch start, dynamically calculates 2D canvas pos

    _this._touchStartMarker = new ctGXeokitViewer.Marker(_assertThisInitialized(_this), {
      id: "distanceMeasurementMarker"
    }); // Routes 2D canvas pos from Marker to Dot

    _this._touchStartMarker.on("canvasPos", function (canvasPos) {
      _this._touchStartDot.setPos(canvasPos[0], canvasPos[1]);
    }); // Event handles from CameraControl


    _this._onMouseHoverSurface = null;
    _this._onMouseHoverOff = null;
    _this._onPickedNothing = null; // Event handles from Scene.input

    _this._onInputMouseDown = null;
    _this._onInputMouseUp = null; // Event handles from Canvas element

    _this._onCanvasTouchStart = null;
    _this._onCanvasTouchEnd = null;
    return _this;
  }
  /** Gets if this DistanceMeasurementsControl is currently active, where it is responding to input.
   *
   * @returns {Boolean}
   */


  _createClass(DistanceMeasurementsControl, [{
    key: "active",
    get: function get() {
      return this._active;
    }
    /**
     * Activates this DistanceMeasurementsControl, ready to respond to input.
     */

  }, {
    key: "activate",
    value: function activate() {
      var _this2 = this;

      if (this._active) {
        return;
      }

      var plugin = this.plugin;
      var scene = this.scene;
      var cameraControl = plugin.viewer.cameraControl;
      var canvas = scene.canvas.canvas;
      var input = scene.input;
      var startDot = this._touchStartDot;
      var pickSurfacePrecisionEnabled = scene.pickSurfacePrecisionEnabled;
      var mouseHoverEntity = null;
      var mouseWorldPos = math.vec3();
      var mouseCanvasPos = math.vec2();
      var lastMouseCanvasX;
      var lastMouseCanvasY;
      var mouseCanvasClickTolerance = 5;
      var FIRST_TOUCH_EXPECTED = 0;
      var SECOND_TOUCH_EXPECTED = 1;
      var touchState = FIRST_TOUCH_EXPECTED;
      var touchCanvasClickTolerance = 5;
      var touchStartCanvasPos = math.vec2();
      var touchEndCanvasPos = math.vec2();
      var touchStartWorldPos = math.vec3();
      this._onMouseHoverSurface = cameraControl.on("hoverSurface", function (event) {
        // This gets fired for both mouse and touch input, but we don't care when handling touch
        mouseHoverEntity = event.entity;
        mouseWorldPos.set(event.worldPos);
        mouseCanvasPos.set(event.canvasPos);
        canvas.style.cursor = "pointer";

        if (_this2._currentDistanceMeasurementByMouse) {
          _this2._currentDistanceMeasurementByMouse.wireVisible = _this2._currentDistanceMeasurementByMouseInittouchState.wireVisible;
          _this2._currentDistanceMeasurementByMouse.axisVisible = _this2._currentDistanceMeasurementByMouseInittouchState.axisVisible && _this2.plugin.defaultAxisVisible;
          _this2._currentDistanceMeasurementByMouse.xAxisVisible = _this2._currentDistanceMeasurementByMouseInittouchState.xAxisVisible && _this2.plugin.defaultXAxisVisible;
          _this2._currentDistanceMeasurementByMouse.yAxisVisible = _this2._currentDistanceMeasurementByMouseInittouchState.yAxisVisible && _this2.plugin.defaultYAxisVisible;
          _this2._currentDistanceMeasurementByMouse.zAxisVisible = _this2._currentDistanceMeasurementByMouseInittouchState.zAxisVisible && _this2.plugin.defaultZAxisVisible;
          _this2._currentDistanceMeasurementByMouse.targetVisible = _this2._currentDistanceMeasurementByMouseInittouchState.targetVisible;
          _this2._currentDistanceMeasurementByMouse.target.entity = mouseHoverEntity;
          _this2._currentDistanceMeasurementByMouse.target.worldPos = mouseWorldPos;
        }
      });
      this._onInputMouseDown = input.on("mousedown", function (coords) {
        if (!input.mouseDownLeft) {
          lastMouseCanvasX = null;
          lastMouseCanvasY = null;
          return;
        }

        lastMouseCanvasX = coords[0];
        lastMouseCanvasY = coords[1];
      });
      this._onInputMouseUp = input.on("mouseup", function (coords) {
        if (!lastMouseCanvasX || !lastMouseCanvasY) {
          return;
        }

        if (coords[0] > lastMouseCanvasX + mouseCanvasClickTolerance || coords[0] < lastMouseCanvasX - mouseCanvasClickTolerance || coords[1] > lastMouseCanvasY + mouseCanvasClickTolerance || coords[1] < lastMouseCanvasY - mouseCanvasClickTolerance) {
          return;
        }

        if (_this2._currentDistanceMeasurementByMouse) {
          if (mouseHoverEntity) {
            if (pickSurfacePrecisionEnabled) {
              var pickResult = scene.pick({
                canvasPos: mouseCanvasPos,
                pickSurface: true,
                pickSurfacePrecision: true
              });

              if (pickResult && pickResult.worldPos) {
                _this2._currentDistanceMeasurementByMouse.target.worldPos = pickResult.worldPos;
              }

              _this2._currentDistanceMeasurementByMouse.approximate = false;
            }

            _this2._currentDistanceMeasurementByMouse.clickable = true;

            _this2.fire("measurementEnd", _this2._currentDistanceMeasurementByMouse);

            _this2._currentDistanceMeasurementByMouse = null;
          } else {
            _this2._currentDistanceMeasurementByMouse.destroy();

            _this2.fire("measurementCancel", _this2._currentDistanceMeasurementByMouse);

            _this2._currentDistanceMeasurementByMouse = null;
          }
        } else {
          if (mouseHoverEntity) {
            if (pickSurfacePrecisionEnabled) {
              var _pickResult = scene.pick({
                canvasPos: mouseCanvasPos,
                pickSurface: true,
                pickSurfacePrecision: true
              });

              if (_pickResult && _pickResult.worldPos) {
                mouseWorldPos.set(_pickResult.worldPos);
              }
            }

            _this2._currentDistanceMeasurementByMouse = plugin.createMeasurement({
              id: math.createUUID(),
              origin: {
                entity: mouseHoverEntity,
                worldPos: mouseWorldPos
              },
              target: {
                entity: mouseHoverEntity,
                worldPos: mouseWorldPos
              },
              approximate: true,
              xAxisColor: plugin.xAxisColor,
              yAxisColor: plugin.yAxisColor,
              zAxisColor: plugin.zAxisColor,
              xAxisLabelColor: plugin.xAxisLabelColor,
              yAxisLabelColor: plugin.yAxisLabelColor,
              zAxisLabelColor: plugin.zAxisLabelColor,
              xAxisClassName: plugin.xAxisClassName,
              yAxisClassName: plugin.yAxisClassName,
              zAxisClassName: plugin.zAxisClassName,
              xAxisLabelClassName: plugin.xAxisLabelClassName,
              yAxisLabelClassName: plugin.yAxisLabelClassName,
              zAxisLabelClassName: plugin.zAxisLabelClassName
            });
            _this2._currentDistanceMeasurementByMouseInittouchState.axisVisible = _this2._currentDistanceMeasurementByMouse.axisVisible && _this2.plugin.defaultAxisVisible;
            _this2._currentDistanceMeasurementByMouseInittouchState.xAxisVisible = _this2._currentDistanceMeasurementByMouse.xAxisVisible && _this2.plugin.defaultXAxisVisible;
            _this2._currentDistanceMeasurementByMouseInittouchState.yAxisVisible = _this2._currentDistanceMeasurementByMouse.yAxisVisible && _this2.plugin.defaultYAxisVisible;
            _this2._currentDistanceMeasurementByMouseInittouchState.zAxisVisible = _this2._currentDistanceMeasurementByMouse.zAxisVisible && _this2.plugin.defaultZAxisVisible;
            _this2._currentDistanceMeasurementByMouseInittouchState.wireVisible = _this2._currentDistanceMeasurementByMouse.wireVisible;
            _this2._currentDistanceMeasurementByMouseInittouchState.targetVisible = _this2._currentDistanceMeasurementByMouse.targetVisible;
            _this2._currentDistanceMeasurementByMouse.clickable = false;

            _this2.fire("measurementStart", _this2._currentDistanceMeasurementByMouse);
          }
        }
      });
      this._onMouseHoverOff = cameraControl.on("hoverOff", function (event) {
        mouseHoverEntity = null;

        if (_this2._currentDistanceMeasurementByMouse) {
          _this2._currentDistanceMeasurementByMouse.wireVisible = false;
          _this2._currentDistanceMeasurementByMouse.targetVisible = false;
          _this2._currentDistanceMeasurementByMouse.axisVisible = false;
        }

        canvas.style.cursor = "default";
      });
      this._onPickedNothing = cameraControl.on("pickedNothing", function (event) {
        if (_this2._currentDistanceMeasurementByMouse) {
          _this2._currentDistanceMeasurementByMouse.destroy();

          _this2._currentDistanceMeasurementByMouse = null;
        }

        startDot.setVisible(false);
        touchState = FIRST_TOUCH_EXPECTED;
      });
      canvas.addEventListener("touchstart", this._onCanvasTouchStart = function (event) {
        var touches = event.touches;
        var changedTouches = event.changedTouches;

        if (touches.length === 1 && changedTouches.length === 1) {
          getCanvasPosFromEvent(touches[0], touchStartCanvasPos);
        }
      }, {
        passive: true
      });
      canvas.addEventListener("touchend", this._onCanvasTouchEnd = function (event) {
        var touches = event.touches;
        var changedTouches = event.changedTouches;

        if (touches.length === 0 && changedTouches.length === 1) {
          getCanvasPosFromEvent(changedTouches[0], touchEndCanvasPos);

          if (touchEndCanvasPos[0] > touchStartCanvasPos[0] + touchCanvasClickTolerance || touchEndCanvasPos[0] < touchStartCanvasPos[0] - touchCanvasClickTolerance || touchEndCanvasPos[1] > touchStartCanvasPos[1] + touchCanvasClickTolerance || touchEndCanvasPos[1] < touchStartCanvasPos[1] - touchCanvasClickTolerance) {
            return; // User is repositioning the camera or model
          }

          var pickResult = scene.pick({
            canvasPos: touchEndCanvasPos,
            pickSurface: true,
            pickSurfacePrecision: pickSurfacePrecisionEnabled
          });

          if (pickResult && pickResult.worldPos) {
            switch (touchState) {
              case FIRST_TOUCH_EXPECTED:
                startDot.setVisible(true);
                _this2._touchStartMarker.worldPos = pickResult.worldPos;
                touchStartWorldPos.set(pickResult.worldPos);
                touchState = SECOND_TOUCH_EXPECTED;
                break;

              case SECOND_TOUCH_EXPECTED:
                startDot.setVisible(false);
                _this2._touchStartMarker.worldPos = pickResult.worldPos;
                var measurement = plugin.createMeasurement({
                  id: math.createUUID(),
                  origin: {
                    entity: mouseHoverEntity,
                    worldPos: touchStartWorldPos
                  },
                  target: {
                    entity: mouseHoverEntity,
                    worldPos: pickResult.worldPos
                  },
                  approximate: !pickSurfacePrecisionEnabled,
                  xAxisColor: plugin.xAxisColor,
                  yAxisColor: plugin.yAxisColor,
                  zAxisColor: plugin.zAxisColor,
                  xAxisLabelColor: plugin.xAxisLabelColor,
                  yAxisLabelColor: plugin.yAxisLabelColor,
                  zAxisLabelColor: plugin.zAxisLabelColor,
                  xAxisClassName: plugin.xAxisClassName,
                  yAxisClassName: plugin.yAxisClassName,
                  zAxisClassName: plugin.zAxisClassName,
                  xAxisLabelClassName: plugin.xAxisLabelClassName,
                  yAxisLabelClassName: plugin.yAxisLabelClassName,
                  zAxisLabelClassName: plugin.zAxisLabelClassName
                });
                measurement.clickable = true;
                touchState = FIRST_TOUCH_EXPECTED;
                break;
            }
          } else {
            startDot.setVisible(false);
            touchState = FIRST_TOUCH_EXPECTED;
          }
        } //  event.stopPropagation();

      }, {
        passive: true
      });
      this._active = true;
    }
    /**
     * Deactivates this DistanceMeasurementsControl, making it unresponsive to input.
     *
     * Destroys any {@link DistanceMeasurement} under construction.
     */

  }, {
    key: "deactivate",
    value: function deactivate() {
      if (!this._active) {
        return;
      }

      this._touchStartDot.setVisible(false);

      this.reset();
      var input = this.plugin.viewer.scene.input;
      input.off(this._onInputMouseDown);
      input.off(this._onInputMouseUp);
      var cameraControl = this.plugin.viewer.cameraControl;
      cameraControl.off(this._onMouseHoverSurface);
      cameraControl.off(this._onMouseHoverOff);
      cameraControl.off(this._onPickedNothing);
      var canvas = this.plugin.viewer.scene.canvas.canvas;
      canvas.removeEventListener("touchstart", this._onCanvasTouchStart);
      canvas.removeEventListener("touchend", this._onCanvasTouchEnd);
      this._currentDistanceMeasurementByMouse = null;
      this._active = false;
    }
    /**
     * Resets this DistanceMeasurementsControl.
     *
     * Destroys any {@link DistanceMeasurement} under construction.
     *
     * Does nothing if the DistanceMeasurementsControl is not active.
     */

  }, {
    key: "reset",
    value: function reset() {
      if (!this._active) {
        return;
      }

      if (this._currentDistanceMeasurementByMouse) {
        this._currentDistanceMeasurementByMouse.destroy();

        this._currentDistanceMeasurementByMouse = null;
      }
    }
    /**
     * @private
     */

  }, {
    key: "destroy",
    value: function destroy() {
      this._touchStartDot.destroy();

      this.deactivate();

      _get(_getPrototypeOf(DistanceMeasurementsControl.prototype), "destroy", this).call(this);
    }
  }]);

  return DistanceMeasurementsControl;
}(ctGXeokitViewer.Component);

var getCanvasPosFromEvent = function getCanvasPosFromEvent(event, canvasPos) {
  if (!event) {
    event = window.event;
    canvasPos[0] = event.x;
    canvasPos[1] = event.y;
  } else {
    var element = event.target;
    var totalOffsetLeft = 0;
    var totalOffsetTop = 0;

    while (element.offsetParent) {
      totalOffsetLeft += element.offsetLeft;
      totalOffsetTop += element.offsetTop;
      element = element.offsetParent;
    }

    canvasPos[0] = event.pageX - totalOffsetLeft;
    canvasPos[1] = event.pageY - totalOffsetTop;
  }

  return canvasPos;
};

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }
/**
 * {@link Viewer} plugin for measuring point-to-point distances.
 *
 * [<img src="https://user-images.githubusercontent.com/83100/63047331-867a0a80-bed4-11e9-892f-398740013c5f.gif">](https://xeokit.github.io/xeokit-sdk/examples/#measurements_distance_createWithMouse)
 *
 * * [[Example 1: Model with distance measurements](https://xeokit.github.io/xeokit-sdk/examples/#measurements_distance_modelWithMeasurements)]
 * * [[Example 2: Create distance measurements with mouse](https://xeokit.github.io/xeokit-sdk/examples/#measurements_distance_createWithMouse)]
 * * [[Example 3: Configuring units and scale](https://xeokit.github.io/xeokit-sdk/examples/#measurements_distance_unitsAndScale)
 *
 * ## Overview
 *
 * * A {@link DistanceMeasurement} represents a point-to-point measurement between two 3D points on one or two {@link Entity}s.
 * * As shown on the screen capture above, a DistanceMeasurement has one wire (light blue) that shows the direct point-to-point measurement,
 * and three more wires (red, green and blue) that show the distance on each of the World-space X, Y and Z axis.
 * * Create DistanceMeasurements programmatically with {@link DistanceMeasurementsPlugin#createMeasurement}.
 * * Create DistanceMeasurements interactively using the {@link DistanceMeasurementsControl}, located at {@link DistanceMeasurementsPlugin#control}.
 * * Existing DistanceMeasurements are registered by ID in {@link DistanceMeasurementsPlugin#measurements}.
 * * Destroy DistanceMeasurements using {@link DistanceMeasurementsPlugin#destroyMeasurement}.
 * * Configure global measurement units and scale via {@link Metrics}, located at {@link Scene#metrics}.
 *
 * ## Example 1: Creating DistanceMeasurements Programmatically
 *
 * In our first example, we'll use an {@link XKTLoaderPlugin} to load a model, and then use a DistanceMeasurementsPlugin to programmatically create two {@link DistanceMeasurement}s.
 *
 * Note how each DistanceMeasurement has ````origin```` and ````target```` endpoints, which each indicate a 3D World-space
 * position on the surface of an {@link Entity}. The endpoints can be attached to the same Entity, or to different Entitys.
 *
 * [[Run example](https://xeokit.github.io/xeokit-sdk/examples/#measurements_distance_modelWithMeasurements)]
 *
 * ````JavaScript
 * import {Viewer, XKTLoaderPlugin, DistanceMeasurementsPlugin} from "xeokit-sdk.es.js";
 *
 * const viewer = new Viewer({
 *     canvasId: "myCanvas",
 *     transparent: true
 * });
 *
 * viewer.scene.camera.eye = [-2.37, 18.97, -26.12];
 * viewer.scene.camera.look = [10.97, 5.82, -11.22];
 * viewer.scene.camera.up = [0.36, 0.83, 0.40];
 *
 * const xktLoader = new XKTLoaderPlugin(viewer);
 *
 * const distanceMeasurements = new DistanceMeasurementsPlugin(viewer);
 *
 * const model = xktLoader.load({
 *      src: "./models/xkt/duplex/duplex.xkt"
 * });
 *
 * model.on("loaded", () => {
 *
 *      const myMeasurement1 = distanceMeasurements.createMeasurement({
 *          id: "distanceMeasurement1",
 *          origin: {
 *              entity: viewer.scene.objects["2O2Fr$t4X7Zf8NOew3FLOH"],
 *              worldPos: [0.044, 5.998, 17.767]
 *          },
 *          target: {
 *              entity: viewer.scene.objects["2O2Fr$t4X7Zf8NOew3FLOH"],
 *              worldPos: [4.738, 3.172, 17.768]
 *          },
 *          visible: true,
 *          wireVisible: true
 *      });
 *
 *      const myMeasurement2 = distanceMeasurements.createMeasurement({
 *          id: "distanceMeasurement2",
 *          origin: {
 *              entity: viewer.scene.objects["2O2Fr$t4X7Zf8NOew3FNr2"],
 *              worldPos: [0.457, 2.532, 17.766]
 *          },
 *          target: {
 *              entity: viewer.scene.objects["1CZILmCaHETO8tf3SgGEXu"],
 *              worldPos: [0.436, 0.001, 22.135]
 *          },
 *          visible: true,
 *          wireVisible: true
 *      });
 * });
 * ````
 *
 * ## Example 2: Creating DistanceMeasurements Interactively
 *
 * In our second example, we'll use an {@link XKTLoaderPlugin} to load a model, then we'll use the DistanceMeasurementPlugin's {@link DistanceMeasurementsControl} to interactively create {@link DistanceMeasurement}s with mouse or touch input.
 *
 * After we've activated the DistanceMeasurementsControl, the first click on any {@link Entity} begins constructing a DistanceMeasurement, fixing its
 * origin to that Entity. The next click on any Entity will complete the DistanceMeasurement, fixing its target to that second Entity.
 *
 * The DistanceMeasurementControl will then wait for the next click on any Entity, to begin constructing
 * another DistanceMeasurement, and so on, until deactivated again.
 *
 * [[Run example](https://xeokit.github.io/xeokit-sdk/examples/#measurements_distance_createWithMouse)]
 *
 * ````JavaScript
 * import {Viewer, XKTLoaderPlugin, DistanceMeasurementsPlugin} from "xeokit-sdk.es.js";
 *
 * const viewer = new Viewer({
 *     canvasId: "myCanvas",
 *     transparent: true
 * });
 *
 * viewer.scene.camera.eye = [-2.37, 18.97, -26.12];
 * viewer.scene.camera.look = [10.97, 5.82, -11.22];
 * viewer.scene.camera.up = [0.36, 0.83, 0.40];
 *
 * const xktLoader = new XKTLoaderPlugin(viewer);
 *
 * const distanceMeasurements = new DistanceMeasurementsPlugin(viewer);
 *
 * const model = xktLoader.load({
 *     src: "./models/xkt/duplex/duplex.xkt"
 * });
 *
 * distanceMeasurements.control.activate();  // <------------ Activate the DistanceMeasurementsControl
 * ````
 *
 * ## Example 3: Configuring Measurement Units and Scale
 *
 * In our third example, we'll use the  {@link Scene}'s {@link Metrics} to set the global unit of measurement to ````"meters"````. We'll also specify that a unit within the World-space coordinate system represents ten meters.
 *
 * The wires belonging to our DistanceMeasurements show their lengths in Real-space coordinates, in the current unit of measurement. They will dynamically update as we set these configurations.
 *
 * * [[Run example](https://xeokit.github.io/xeokit-sdk/examples/#measurements_distance_unitsAndScale)]
 *
 * ````JavaScript
 * const metrics = viewer.scene.metrics;

 * metrics.units = "meters";
 * metrics.scale = 10.0;
 * ````
 *
 * ## Example 4: Attaching Mouse Handlers
 *
 * In our fourth example, we'll attach even handlers to our plugin, to catch when the user
 * hovers or right-clicks over our measurements.
 *
 * [[Run example](https://xeokit.github.io/xeokit-sdk/examples/#measurements_distance_modelWithMeasurements)]
 *
 * ````javascript
 * import {Viewer, XKTLoaderPlugin, DistanceMeasurementsPlugin} from "xeokit-sdk.es.js";
 *
 * const viewer = new Viewer({
 *     canvasId: "myCanvas",
 *     transparent: true
 * });
 *
 * viewer.scene.camera.eye = [-2.37, 18.97, -26.12];
 * viewer.scene.camera.look = [10.97, 5.82, -11.22];
 * viewer.scene.camera.up = [0.36, 0.83, 0.40];
 *
 * const xktLoader = new XKTLoaderPlugin(viewer);
 *
 * const distanceMeasurements = new DistanceMeasurementsPlugin(viewer);
 *
 * distanceMeasurements.on("mouseOver", (e) => {
 *     e.measurement.setHighlighted(true);
 * });
 *
 * distanceMeasurements.on("mouseLeave", (e) => {
 *     e.measurement.setHighlighted(false);
 * });
 *
 * distanceMeasurements.on("contextMenu", (e) => {
 *     // Show context menu
 *     e.event.preventDefault();
 * });
 *
 * const model = xktLoader.load({
 *      src: "./models/xkt/duplex/duplex.xkt"
 * });
 *
 * model.on("loaded", () => {
 *
 *      const myMeasurement1 = distanceMeasurements.createMeasurement({
 *          id: "distanceMeasurement1",
 *          origin: {
 *              entity: viewer.scene.objects["2O2Fr$t4X7Zf8NOew3FLOH"],
 *              worldPos: [0.044, 5.998, 17.767]
 *          },
 *          target: {
 *              entity: viewer.scene.objects["2O2Fr$t4X7Zf8NOew3FLOH"],
 *              worldPos: [4.738, 3.172, 17.768]
 *          },
 *          visible: true,
 *          wireVisible: true
 *      });
 *
 *      const myMeasurement2 = distanceMeasurements.createMeasurement({
 *          id: "distanceMeasurement2",
 *          origin: {
 *              entity: viewer.scene.objects["2O2Fr$t4X7Zf8NOew3FNr2"],
 *              worldPos: [0.457, 2.532, 17.766]
 *          },
 *          target: {
 *              entity: viewer.scene.objects["1CZILmCaHETO8tf3SgGEXu"],
 *              worldPos: [0.436, 0.001, 22.135]
 *          },
 *          visible: true,
 *          wireVisible: true
 *      });
 * });
 * ````
 */

var DistanceMeasurementsPlugin = /*#__PURE__*/function (_Plugin) {
  _inherits(DistanceMeasurementsPlugin, _Plugin);

  var _super = _createSuper(DistanceMeasurementsPlugin);

  /**
   * @constructor
   * @param {Viewer} viewer The Viewer.
   * @param {Object} [cfg]  Plugin configuration.
   * @param {String} [cfg.id="DistanceMeasurements"] Optional ID for this plugin, so that we can find it within {@link Viewer#plugins}.
   * @param {Number} [cfg.labelMinAxisLength=25] The minimum length, in pixels, of an axis wire beyond which its label is shown.
   * @param {HTMLElement} [cfg.container] Container DOM element for markers and labels. Defaults to ````document.body````.
   * @param {boolean} [cfg.defaultVisible=true] The default value of the DistanceMeasurements `visible` property.
   * @param {boolean} [cfg.defaultOriginVisible=true] The default value of the DistanceMeasurements `originVisible` property.
   * @param {boolean} [cfg.defaultTargetVisible=true] The default value of the DistanceMeasurements `targetVisible` property.
   * @param {boolean} [cfg.defaultWireVisible=true] The default value of the DistanceMeasurements `wireVisible` property.
   * @param {boolean} [cfg.defaultLabelsVisible=true] The default value of the DistanceMeasurements `labelsVisible` property.
   * @param {boolean} [cfg.defaultAxisVisible=true] The default value of the DistanceMeasurements `axisVisible` property.
   * @param {boolean} [cfg.defaultXAxisVisible=true] The default value of the DistanceMeasurements `xAxisVisible` property.
   * @param {boolean} [cfg.defaultYAxisVisible=true] The default value of the DistanceMeasurements `yAxisVisible` property.
   * @param {boolean} [cfg.defaultZAxisVisible=true] The default value of the DistanceMeasurements `zAxisVisible` property.
   * @param {string} [cfg.defaultColor=#00BBFF] The default color of the length dots, wire and label.
   * @param {number} [cfg.zIndex] If set, the wires, dots and labels will have this zIndex (+1 for dots and +2 for labels).
   * @param {string} [cfg.xAxisColor] The color of the X axis wire.
   * @param {string} [cfg.yAxisColor] The color of the Y axis wire.
   * @param {string} [cfg.zAxisColor] The color of the Z axis wire.
   * @param {string} [cfg.xAxisLabelColor] The color of the X axis label.
   * @param {string} [cfg.yAxisLabelColor] The color of the Y axis label.
   * @param {string} [cfg.zAxisLabelColor] The color of the Z axis label.
   * @param {string} [cfg.xAxisClassName] The class name of the X axis wire.
   * @param {string} [cfg.yAxisClassName] The class name of the Y axis wire.
   * @param {string} [cfg.zAxisClassName] The class name of the Z axis wire.
   * @param {string} [cfg.xAxisLabelClassName] The class name of the X axis label.
   * @param {string} [cfg.yAxisLabelClassName] The class name of the Y axis label.
   * @param {string} [cfg.zAxisLabelClassName] The class name of the Z axis label.
   *
   *
   */
  function DistanceMeasurementsPlugin(viewer) {
    var _this;

    var cfg = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};

    _classCallCheck(this, DistanceMeasurementsPlugin);

    _this = _super.call(this, "DistanceMeasurements", viewer);
    _this._container = cfg.container || document.body;
    _this._control = new DistanceMeasurementsControl(_assertThisInitialized(_this));
    _this._measurements = {};
    _this.labelMinAxisLength = cfg.labelMinAxisLength;
    _this.defaultVisible = cfg.defaultVisible !== false;
    _this.defaultOriginVisible = cfg.defaultOriginVisible !== false;
    _this.defaultTargetVisible = cfg.defaultTargetVisible !== false;
    _this.defaultWireVisible = cfg.defaultWireVisible !== false;
    _this.defaultLabelsVisible = cfg.defaultLabelsVisible !== false;
    _this.defaultAxisVisible = cfg.defaultAxisVisible !== false;
    _this.defaultXAxisVisible = cfg.defaultXAxisVisible !== false;
    _this.defaultYAxisVisible = cfg.defaultYAxisVisible !== false;
    _this.defaultZAxisVisible = cfg.defaultZAxisVisible !== false;
    _this.defaultColor = cfg.defaultColor !== undefined ? cfg.defaultColor : "#00BBFF";
    _this.zIndex = cfg.zIndex || 10000;
    _this.xAxisColor = cfg.xAxisColor;
    _this.yAxisColor = cfg.yAxisColor;
    _this.zAxisColor = cfg.zAxisColor;
    _this.xAxisLabelColor = cfg.xAxisLabelColor;
    _this.yAxisLabelColor = cfg.yAxisLabelColor;
    _this.zAxisLabelColor = cfg.zAxisLabelColor;
    _this.xAxisClassName = cfg.xAxisClassName;
    _this.yAxisClassName = cfg.yAxisClassName;
    _this.zAxisClassName = cfg.zAxisClassName;
    _this.xAxisLabelClassName = cfg.xAxisLabelClassName;
    _this.yAxisLabelClassName = cfg.yAxisLabelClassName;
    _this.zAxisLabelClassName = cfg.zAxisLabelClassName;

    _this._onMouseOver = function (event, measurement) {
      _this.fire("mouseOver", {
        plugin: _assertThisInitialized(_this),
        measurement: measurement,
        event: event
      });
    };

    _this._onMouseLeave = function (event, measurement) {
      _this.fire("mouseLeave", {
        plugin: _assertThisInitialized(_this),
        measurement: measurement,
        event: event
      });
    };

    _this._onContextMenu = function (event, measurement) {
      _this.fire("contextMenu", {
        plugin: _assertThisInitialized(_this),
        measurement: measurement,
        event: event
      });
    };

    return _this;
  }
  /**
   * @private
   */


  _createClass(DistanceMeasurementsPlugin, [{
    key: "send",
    value: function send(name, value) {}
    /**
     * Gets the {@link DistanceMeasurementsControl}, which creates {@link DistanceMeasurement}s from user input.
     *
     * @type {DistanceMeasurementsControl}
     */

  }, {
    key: "control",
    get: function get() {
      return this._control;
    }
    /**
     * Gets the existing {@link DistanceMeasurement}s, each mapped to its {@link DistanceMeasurement#id}.
     *
     * @type {{String:DistanceMeasurement}}
     */

  }, {
    key: "measurements",
    get: function get() {
      return this._measurements;
    }
    /**
     * Sets the minimum length, in pixels, of an axis wire beyond which its label is shown.
     *
     * The axis wire's label is not shown when its length is less than this value.
     *
     * This is ````25```` pixels by default.
     *
     * Must not be less than ````1````.
     *
     * @type {number}
     */

  }, {
    key: "labelMinAxisLength",
    get:
    /**
     * Gets the minimum length, in pixels, of an axis wire beyond which its label is shown.
     * @returns {number}
     */
    function get() {
      return this._labelMinAxisLength;
    }
    /**
     * Creates a {@link DistanceMeasurement}.
     *
     * The DistanceMeasurement is then registered by {@link DistanceMeasurement#id} in {@link DistanceMeasurementsPlugin#measurements}.
     *
     * @param {Object} params {@link DistanceMeasurement} configuration.
     * @param {String} params.id Unique ID to assign to {@link DistanceMeasurement#id}. The DistanceMeasurement will be registered by this in {@link DistanceMeasurementsPlugin#measurements} and {@link Scene.components}. Must be unique among all components in the {@link Viewer}.
     * @param {Number[]} params.origin.worldPos Origin World-space 3D position.
     * @param {Entity} params.origin.entity Origin Entity.
     * @param {Number[]} params.target.worldPos Target World-space 3D position.
     * @param {Entity} params.target.entity Target Entity.
     * @param {Boolean} [params.visible=true] Whether to initially show the {@link DistanceMeasurement}.
     * @param {Boolean} [params.originVisible=true] Whether to initially show the {@link DistanceMeasurement} origin.
     * @param {Boolean} [params.targetVisible=true] Whether to initially show the {@link DistanceMeasurement} target.
     * @param {Boolean} [params.wireVisible=true] Whether to initially show the direct point-to-point wire between {@link DistanceMeasurement#origin} and {@link DistanceMeasurement#target}.
     * @param {Boolean} [params.axisVisible=true] Whether to initially show the axis-aligned wires between {@link DistanceMeasurement#origin} and {@link DistanceMeasurement#target}.
     * @param {Boolean} [params.xAxisVisible=true] Whether to initially show the X-axis-aligned wires between {@link DistanceMeasurement#origin} and {@link DistanceMeasurement#target}.
     * @param {Boolean} [params.yAxisVisible=true] Whether to initially show the Y-axis-aligned wires between {@link DistanceMeasurement#origin} and {@link DistanceMeasurement#target}.
     * @param {Boolean} [params.zAxisVisible=true] Whether to initially show the Z-axis-aligned wires between {@link DistanceMeasurement#origin} and {@link DistanceMeasurement#target}.
     * @param {Boolean} [params.labelsVisible=true] Whether to initially show the labels.
     * @param {string} [params.color] The color of the length dot, wire and label.
     * @param {string} [params.xAxisColor] The color of the X axis wire.
     * @param {string} [params.yAxisColor] The color of the Y axis wire.
     * @param {string} [params.zAxisColor] The color of the Z axis wire.
     * @param {string} [params.xAxisLabelColor] The color of the X axis label.
     * @param {string} [params.yAxisLabelColor] The color of the Y axis label.
     * @param {string} [params.zAxisLabelColor] The color of the Z axis label.
     * @param {string} [params.xAxisClassName] The class name of the X axis wire.
     * @param {string} [params.yAxisClassName] The class name of the Y axis wire.
     * @param {string} [params.zAxisClassName] The class name of the Z axis wire.
     * @param {string} [params.xAxisLabelClassName] The class name of the X axis label.
     * @param {string} [params.yAxisLabelClassName] The class name of the Y axis label.
     * @param {string} [params.zAxisLabelClassName] The class name of the Z axis label.
     * @returns {DistanceMeasurement} The new {@link DistanceMeasurement}.
     */
    ,
    set: function set(labelMinAxisLength) {
      if (labelMinAxisLength < 1) {
        this.error("labelMinAxisLength must be >= 1; defaulting to 25");
        labelMinAxisLength = 25;
      }

      this._labelMinAxisLength = labelMinAxisLength || 25;
    }
  }, {
    key: "createMeasurement",
    value: function createMeasurement() {
      var _this2 = this;

      var params = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};

      if (this.viewer.scene.components[params.id]) {
        this.error("Viewer scene component with this ID already exists: " + params.id);
        delete params.id;
      }

      var origin = params.origin;
      var target = params.target;
      var measurement = new DistanceMeasurement(this, {
        id: params.id,
        plugin: this,
        container: this._container,
        origin: {
          entity: origin.entity,
          worldPos: origin.worldPos
        },
        target: {
          entity: target.entity,
          worldPos: target.worldPos
        },
        visible: params.visible,
        wireVisible: params.wireVisible,
        axisVisible: params.axisVisible !== false && this.defaultAxisVisible !== false,
        xAxisVisible: params.xAxisVisible !== false && this.defaultXAxisVisible !== false,
        yAxisVisible: params.yAxisVisible !== false && this.defaultYAxisVisible !== false,
        zAxisVisible: params.zAxisVisible !== false && this.defaultZAxisVisible !== false,
        labelsVisible: params.labelsVisible !== false && this.defaultLabelsVisible !== false,
        originVisible: params.originVisible,
        targetVisible: params.targetVisible,
        color: params.color,
        xAxisColor: params.xAxisColor,
        yAxisColor: params.yAxisColor,
        zAxisColor: params.zAxisColor,
        xAxisLabelColor: params.xAxisLabelColor,
        yAxisLabelColor: params.yAxisLabelColor,
        zAxisLabelColor: params.zAxisLabelColor,
        xAxisClassName: params.xAxisClassName,
        yAxisClassName: params.yAxisClassName,
        zAxisClassName: params.zAxisClassName,
        xAxisLabelClassName: params.xAxisLabelClassName,
        yAxisLabelClassName: params.yAxisLabelClassName,
        zAxisLabelClassName: params.zAxisLabelClassName,
        onMouseOver: this._onMouseOver,
        onMouseLeave: this._onMouseLeave,
        onContextMenu: this._onContextMenu
      });
      this._measurements[measurement.id] = measurement;
      measurement.on("destroyed", function () {
        delete _this2._measurements[measurement.id];
      });
      this.fire("measurementCreated", measurement);
      return measurement;
    }
    /**
     * Destroys a {@link DistanceMeasurement}.
     *
     * @param {String} id ID of DistanceMeasurement to destroy.
     */

  }, {
    key: "destroyMeasurement",
    value: function destroyMeasurement(id) {
      var measurement = this._measurements[id];

      if (!measurement) {
        this.log("DistanceMeasurement not found: " + id);
        return;
      }

      measurement.destroy();
      this.fire("measurementDestroyed", measurement);
    }
    /**
     * Shows all or hides the angle label of each {@link DistanceMeasurement}.
     *
     * @param {Boolean} labelsShown Whether or not to show the labels.
     */

  }, {
    key: "setLabelsShown",
    value: function setLabelsShown(labelsShown) {
      for (var _i = 0, _Object$entries = Object.entries(this.measurements); _i < _Object$entries.length; _i++) {
        var _Object$entries$_i = _slicedToArray(_Object$entries[_i], 2);
            _Object$entries$_i[0];
            var measurement = _Object$entries$_i[1];

        measurement.labelShown = labelsShown;
      }
    }
    /**
     * Destroys all {@link DistanceMeasurement}s.
     */

  }, {
    key: "clear",
    value: function clear() {
      var ids = Object.keys(this._measurements);

      for (var i = 0, len = ids.length; i < len; i++) {
        this.destroyMeasurement(ids[i]);
      }
    }
    /**
     * Destroys this DistanceMeasurementsPlugin.
     *
     * Destroys all {@link DistanceMeasurement}s first.
     */

  }, {
    key: "destroy",
    value: function destroy() {
      this.clear();

      _get(_getPrototypeOf(DistanceMeasurementsPlugin.prototype), "destroy", this).call(this);
    }
  }]);

  return DistanceMeasurementsPlugin;
}(ctGXeokitViewer.Plugin);

exports.DistanceMeasurementsPlugin = DistanceMeasurementsPlugin;
//# sourceMappingURL=distance-measurements.cjs.js.map
